pro MSP_PPOL_Save_Group_File, Event
	;
	;	saves the group summary structure to the indicated save file
	;	
	;	20161231 - added two levels of group summary save file protection (old, old_old).
	;	           these are there in case remote mounted file links go down in the middle of
	;	           updating (writing) the group save file. When this happened, it killed the
	;	           group save file, which renders the PPOL analysis dead. 
	;	           IF a similar failure happens now, exit PPOL, remove the .sav file, copy
	;	           the .old file to the .sav file and restart PPOL.
	;	           (old_old is just my paranoia showing up...)
	;
	;	and saves history, if present
	;
	WIDGET_CONTROL, Event.top, GET_UVALUE=PTR_struct
	;
	s_ptr = PTR_struct.PTR_summary
	g_ptr = PTR_struct.PTR_group
	h_ptr = PTR_struct.PTR_history
	;
	;	check that there is something in the analysis dir buffer
	;
	if((*s_ptr).analysis_dir ne '') then begin
		file = (*s_ptr).analysis_dir + 'S1_Image_Groups_and_Meta_Groups' + PATH_SEP() + 'Group_Summary.sav'
		print_text, Event, "Preparing to Save Group File to "+file+" with backups"
		;
		; 20161231 - test for presence of backup group save files, do renames if there
		;
		old_old_file = file + '.old.old'
		old_file = file + '.old'
		;
		; if old_old present and old present, delete old_old and mv old->old_old
		;
		test_old_old = FILE_TEST(old_old_file)
		test_old = FILE_TEST(old_file)
		test_file = FILE_TEST(file)
		;
		if(test_old_old eq 1) then begin
		    if(test_old eq 1) then begin
		      FILE_DELETE, old_old_file
          FILE_COPY, old_file, old_old_file
          print_text, Event, '.......old_old removed; cp old -> old_old'
        endif else begin
          ;
          ; odd case - old_old but no old - copy old_old -> old
          ;
          FILE_COPY, old_old_file, old_file
          print_text, Event, '.......old_old present, but no old; cp old_old -> old'
        endelse
    endif else begin
        if(test_old eq 1) then begin
          FILE_COPY, old_file, old_old_file
          print_text, Event, '.......no old_old; cp old -> old_old'
        endif 
    endelse
		;
		; is there already a sav file present? if so copy it to the old file
		; 
		if(test_file eq 1) then begin
		    if(test_old eq 1) then begin
		       FILE_COPY, file, old_file, /overwrite
		       print_text, Event, '.......cp sav -> old'
		    endif else begin
		       ;
		       ;  no, so make a copy of the sav file
		       ;  
		       SAVE, g_ptr, DESCRIPTION="PPOL Group Summary File ", FILENAME=old_file
		       print_text, Event, '.......creating backup old_file'
		    endelse
		endif
		;
		SAVE, g_ptr, DESCRIPTION="PPOL Group Summary File ", FILENAME=file ; don't know if this overwrites - assume yes
		print_text, Event, 'Group Summary Saved successfully'
		;
		;	try to save history to history save file
		;
		n_history_total = TOTAL( (*h_ptr).n_history[*])
		file = (*s_ptr).analysis_dir + 'S1_Image_Groups_and_Meta_Groups' + PATH_SEP() + 'Problem_History.sav'
		if(n_history_total gt 0) then begin
			print_text, Event, "Saving Problem History to "+file
		endif else print_text, Event, "Clearing Problem History file on disk"
		SAVE, h_ptr, DESCRIPTION="PPOL Problem History File ", FILENAME=file
		;
	endif else begin
		print_text, Event, "ERROR - must select New or Existing analysis directory first"
	endelse
	;
end
