;	Step 1 Event Handler Routines - Group Creation, Management
;
pro S1_Init, Event
	;
	;	initialize S1 stuff when tabbing onto Step 1
	;
	WIDGET_CONTROL, Event.top, GET_UVALUE=PTR_struct
	w_ptr = PTR_struct.PTR_wid_id
	g_ptr = PTR_struct.PTR_group
	;
	;	init all subtabs and subsubtabs
	;
	(*w_ptr).S1_current_tab = 0
	(*w_ptr).S1A_current_tab = 0
	;
	;	init all tabs
	;
	for sub_tab = 0, 2 do begin
	;
		case sub_tab of
			0:	begin
					print_text, Event, "Init for Step 1, Tab A"
					;
					for sub_sub_tab = 0, 1 do begin
						case sub_sub_tab of
							0: begin
								print_text, Event, "Init for Step 1A, Tab 1"
								WIDGET_CONTROL, (*w_ptr).S1A_1_group_name_textbox_wid, SET_VALUE=''
								WIDGET_CONTROL, (*w_ptr).S1A_1_save_group_wid, SENSITIVE=0
							   end
							1: begin
								print_text, Event, "Init for Step 1A, Tab 2"
								WIDGET_CONTROL, (*w_ptr).S1A_2_start_multiple_group_creation_button_wid, SENSITIVE=0
							   end
							else: print_text, Event, "Tab init for Step 1A not recognized"
						endcase
					endfor
				end
			1:	begin
					print_text, Event, "Init for Step 1, Tab B"
				end
			2:	begin
					print_text, Event, "Init for Step 1, Tab C"
					WIDGET_CONTROL, (*w_ptr).S1C_group_name_textbox_wid, SET_VALUE=''
				end
			else: print_text, Event, "ERROR - illegal subtab on Step 6"
		endcase
	endfor
	;
	;	turn off tabbing bases
	;
	WIDGET_CONTROL, (*w_ptr).S1_tab_base_wid, SENSITIVE=0
	;
	;	and anything else
	;
	WIDGET_CONTROL, (*w_ptr).S1A_tab_base_wid, SENSITIVE=1
	;
	;	and populate the group and meta-group lists in main window
	;
;	n_groups = (*g_ptr).n_groups
;	if(n_groups gt 0) then begin
;		ind = WHERE((*g_ptr).S1_group_queue[0:n_groups-1] ge 1,count)
;		if(count gt 0) then (*g_ptr).S1_group_queue[ind] = -2
;	endif
	S1_populate_group_list, Event
	;
;	n_meta_groups = (*g_ptr).n_meta_groups
;	if(n_meta_groups gt 0) then begin
;		ind = WHERE((*g_ptr).S1_meta_group_queue[0:n_meta_groups-1] ge 1,count)
;		if(count gt 0) then (*g_ptr).S1_meta_group_queue[ind] = -2
;	endif
	S1_populate_meta_list, Event

end
;
;-----------------------------------------------------------------------------------
pro S1_Tab_Handler, Event
	WIDGET_CONTROL, Event.top, GET_UVALUE=PTR_struct
	w_ptr = PTR_struct.PTR_wid_id
	g_ptr = PTR_struct.PTR_group
	;
	;	what to do when arriving at a tab
	;
	(*w_ptr).S1_current_tab = Event.tab
	print_text, Event, "In S1_Tab_Handler, Event.tab = "+STRING(Event.tab, format='(I6)')
	;
	case Event.tab of
		0: begin
				print_text, Event, "Tab Change to Step 1A"
				WIDGET_CONTROL, (*w_ptr).S1A_tab_base_wid, SENSITIVE=0
				WIDGET_CONTROL, (*w_ptr).S1A_tab_base_wid, SENSITIVE=1
				;
				for sub_sub_tab = 0, 1 do begin
					case sub_sub_tab of
						0: begin
							print_text, Event, "Init for Step 1A, Tab 1"
							WIDGET_CONTROL, (*w_ptr).S1A_1_group_name_textbox_wid, SET_VALUE=''
							WIDGET_CONTROL, (*w_ptr).S1A_1_save_group_wid, SENSITIVE=0
						   end
						1: begin
							print_text, Event, "Init for Step 1A, Tab 2"
							WIDGET_CONTROL, (*w_ptr).S1A_2_start_multiple_group_creation_button_wid, SENSITIVE=0
						   end
						else: print_text, Event, "Tab init for Step 1A not recognized"
					endcase
				endfor
			end
		1:  begin
				print_text, Event, "Tab Change to Step 1B"
				WIDGET_CONTROL, (*w_ptr).S1A_tab_base_wid, SENSITIVE=0
				;
				;	turn off all items on 1A and 1C
				;
				WIDGET_CONTROL, (*w_ptr).S1C_group_name_textbox_wid, SENSITIVE=0
				;
			end
		2:  begin
				print_text, Event, "Tab Change to Step 1C"
				WIDGET_CONTROL, (*w_ptr).S1A_tab_base_wid, SENSITIVE=0
				(*w_ptr).S1C_gntb_nch = 0
				;
				;
				;
			end
		else: begin print_text, Event, "Tab not recognized - try again"
			end
	endcase
	;
end
;
;---------------------------------------------------------------------
pro S1A_Tab_Handler, Event
	WIDGET_CONTROL, Event.top, GET_UVALUE=PTR_struct
	w_ptr = PTR_struct.PTR_wid_id
	g_ptr = PTR_struct.PTR_group
	;
	;	what to do when arriving at a tab
	;
	print_text, Event, "Got into S1A_Tab_Handler routine"
	;
	(*w_ptr).S1A_current_tab = Event.tab
	;
	case Event.tab of
		0: begin
				print_text, Event, "Tab Change to Step 1A_1"
				WIDGET_CONTROL, (*w_ptr).S1A_1_save_group_wid, SENSITIVE=0
				(*w_ptr).S1A_1_gntb_nch = 0
				;
			end
		1:  begin
				print_text, Event, "Tab Change to Step 1A_2"
				WIDGET_CONTROL, (*w_ptr).S1A_2_start_multiple_group_creation_button_wid, SENSITIVE=0
				;
			end
		else: begin print_text, Event, "Tab not recognized - try again"
			end
	endcase
	;
end
;---------------------------------------------
;			S1_Create_new_group, Event
;			S1_Remove_group, Event
;			S1_Rename_group, Event
;			S1_Edit_image_list, Event
;			S1_Clear_image_flags, Event
;			S1_Change_group_status, Event
;			S1_Remove_meta_group, Event
;			S1_Edit_step_number, Event
;			S1_Select_meta_group, Event
;			S1_Select_images, Event
;			;
;			S1A_Launch_file_chooser, Event, 0
;			S1A_1_Save_group, Event
;			S1A_Group_name_textbox, Event, 0
;			S1A_Launch_file_chooser, Event, 1
;			S1A_2_Start_group_name_parsing, Event
;			S1A_2_Read_directory, Event
;			;
;			S1B_Add_Images_to_List, Event
;			S1B_Remove_Images_to_List, Event
;			S1B_Select_images_on_list, Event
;			;
;			S1C_Group_name_textbox, Event, 2
;
;			S1_Tab_Handler, Event
;			S1A_Tab_Handler, Event
;----------------------------------------------
;
pro S1_Create_New_Group, Event
	WIDGET_CONTROL, Event.top, GET_UVALUE=PTR_struct
	w_ptr = PTR_struct.PTR_wid_id
	s_ptr = PTR_struct.PTR_summary
	;
	(*w_ptr).S1A_1_gntb_nch = 0
	(*w_ptr).S1C_gntb_nch = 0
	;
	;	turn on the tab base
	;
	WIDGET_CONTROL, (*w_ptr).S1_tab_base_wid, SENSITIVE=1
	;
	;	and tab sub tab base
	;
	WIDGET_CONTROL, (*w_ptr).S1A_tab_base_wid, SENSITIVE=1
	WIDGET_CONTROL, (*w_ptr).S1A_1_save_group_wid, SENSITIVE=0
	WIDGET_CONTROL, (*w_ptr).S1A_2_start_multiple_group_creation_button_wid, SENSITIVE=0
	WIDGET_CONTROL, (*w_ptr).S1A_2_read_directory_wid, SENSITIVE=1
	WIDGET_CONTROL, (*w_ptr).S1A_2_multiple_group_file_chooser_button_wid, SENSITIVE=1
	;
	;	and select front tab
	;
	WIDGET_CONTROL, (*w_ptr).S1_tab_base_wid, SET_TAB_CURRENT=0
	;
end
;----------------------------------------------
pro S1_Remove_Group, Event
	;
	;	if a group or groups was highlighted, remove it/them
	;	
	; assumes the group is NOT already in a meta-group
	;   if so, this will mess up the meta-groups (DPC 20140523)
	;
	WIDGET_CONTROL, Event.top, GET_UVALUE=PTR_struct
	s_ptr = PTR_struct.PTR_summary
	w_ptr = PTR_struct.PTR_wid_id
	g_ptr = PTR_struct.PTR_group
	;
	;	check that there is a non-(-1) index selected
	;
	n_selected = (*g_ptr).n_groups_selected
	;
	if(n_selected eq 0) then begin
		print_text, Event, "No group(s) selected. Try again."
		goto, S1RG_end
	endif
	;
	index = (*g_ptr).selected_groups[0:n_selected-1]
	;
	for is = 0, n_selected-1 do begin
		if(index[is] ne -1L) then begin
			this_group = (*g_ptr).group_names[index[is]]
			;
			n_groups = (*g_ptr).n_groups
			if(n_groups gt 0) then begin
				j = 0L
				for ig = 0, n_groups-1 do begin
					if(ig ne index[is]) then begin
						(*g_ptr).group_names[j] = (*g_ptr).group_names[ig]
						(*g_ptr).group_numbers[j] = (*g_ptr).group_numbers[ig]
						(*g_ptr).group_step[j] = (*g_ptr).group_step[ig]
						(*g_ptr).group_meta[j] = (*g_ptr).group_meta[ig]
						(*g_ptr).group_images[j,0:(*g_ptr).group_numbers[j]-1] = $
								(*g_ptr).group_images[ig,0:(*g_ptr).group_numbers[j]-1]
						(*g_ptr).group_image_flags[j,0:(*g_ptr).group_numbers[j]-1] = $
								(*g_ptr).group_image_flags[ig,0:(*g_ptr).group_numbers[j]-1]
						(*g_ptr).group_llq_flags[j,0:(*g_ptr).group_numbers[j]-1] = $
								(*g_ptr).group_llq_flags[ig,0:(*g_ptr).group_numbers[j]-1]
						;
						j++
					endif
				endfor
				(*g_ptr).group_names[n_groups-1] = ''
				(*g_ptr).group_numbers[n_groups-1] = 0L
				(*g_ptr).group_images[n_groups-1,*] = ''
				(*g_ptr).group_image_flags[n_groups-1,*] = 0L
				(*g_ptr).group_llq_flags[n_groups-1,*] = 0
				(*g_ptr).group_step[n_groups-1] = 0
				(*g_ptr).group_meta[n_groups-1] = 0
				;
				(*g_ptr).n_groups--
				;
				;	next, pull all the values in the index array down by one,
				;		so that its entries point to the "new" group order
				;
				index -= 1
				;
			endif
		endif
	endfor
	;
	print_text, Event, "Removed Group "+this_group+" from Group List"
	;
	;	clear selection
	;
	(*g_ptr).n_groups_selected = 0
	(*g_ptr).selected_groups[*] = 0
	;
	;	rebuild list
	;
	S1RG_end:
	;
	S1_populate_group_list, Event
	;
	;	update disk version of group list
	;
	MSP_PPOL_Save_Group_File, Event
end
;----------------------------------------------
;
pro S1_Edit_image_list, Event
	WIDGET_CONTROL, Event.top, GET_UVALUE=PTR_struct
	w_ptr = PTR_struct.PTR_wid_id
	s_ptr = PTR_struct.PTR_summary
	g_ptr = PTR_struct.PTR_group
	;
	;	check to see that ONE and only one group is selected
	;
	n = (*g_ptr).n_groups_selected
	if(n ne 1) then begin
		print_text, Event,"Incorrect number of groups selected. Must select only one group. Try again."
		goto, S1EIL_end
	endif
	;
	(*w_ptr).S1A_1_gntb_nch = 0
	(*w_ptr).S1C_gntb_nch = 0
	;
	;	turn on the tab base
	;
	WIDGET_CONTROL, (*w_ptr).S1_tab_base_wid, SENSITIVE=1
	;
	;	and force to second tab page
	;
	(*w_ptr).S1_current_tab = 1
	WIDGET_CONTROL, (*w_ptr).S1_tab_base_wid, SET_TAB_CURRENT=1
	;
	;	fill listbox of current images in this group
	;
	S1B_populate_image_listbox, Event
	;
	;	turn on edit buttons
	;
	S1EIL_end:
end
;------------------------------------------------------------------
;
pro S1_Rename_Group, Event
	WIDGET_CONTROL, Event.top, GET_UVALUE=PTR_struct
	w_ptr = PTR_struct.PTR_wid_id
	s_ptr = PTR_struct.PTR_summary
	g_ptr = PTR_struct.PTR_group
	;
	;	check to see that ONE and only one group is selected
	;
	n = (*g_ptr).n_groups_selected
	if(n ne 1) then begin
		print_text, Event,"Incorrect number of groups selected. Must select only one group. Try again."
		goto, S1RG_end
	endif
	;
	;	turn on the tab base
	;
	WIDGET_CONTROL, (*w_ptr).S1_tab_base_wid, SENSITIVE=1
	(*w_ptr).S1A_1_gntb_nch = 0
	(*w_ptr).S1C_gntb_nch = 0
	;
	;	and force to third tab page
	;
	(*w_ptr).S1_current_tab = 2
	WIDGET_CONTROL, (*w_ptr).S1_tab_base_wid, SET_TAB_CURRENT=2
	;
	;	populate group name textbox with selected group
	;
	group_name = (*g_ptr).group_names[(*g_ptr).selected_groups[0]]
	nlen = STRLEN(group_name)
	WIDGET_CONTROL, (*w_ptr).S1C_group_name_textbox_wid, SET_VALUE=group_name
	WIDGET_CONTROL, (*w_ptr).S1C_group_name_textbox_wid, SET_TEXT_SELECT=[nlen,0]
	;
	;	and make sensitive (?) DPC 20091204
	;
	WIDGET_CONTROL, (*w_ptr).S1C_group_name_textbox_wid, SENSITIVE=1
	;
	S1RG_end:
	;
	;	save changes to disk list
	;
	MSP_PPOL_Save_Group_File, Event
end
;---------------------------------------------------------------------
;
pro S1_Clear_image_flags, Event
	;
	;	clears the image flags for all steps for the indicated group(s)
	;
	WIDGET_CONTROL, Event.top, GET_UVALUE=PTR_struct
	w_ptr = PTR_struct.PTR_wid_id
	g_ptr = PTR_struct.PTR_group
	;
	n_selected = (*g_ptr).n_groups_selected
	if(n_selected gt 0) then begin
		;
		index = (*g_ptr).selected_groups[0:n_selected-1]
		;
		for is = 0, n_selected-1 do begin
			if(index[is] ne -1L) then begin
				ind = index[is]
				this_group = (*g_ptr).group_names[ind]
				;
				n_images = (*g_ptr).group_numbers[ind]
				;
				for ii = 0, n_images do begin
					(*g_ptr).group_image_flags[ind,ii] = 1
				endfor
				;
				print_text, Event, "Cleared Image use flags for group "+this_group
			endif
		endfor
		;
		print_text, Event, "Finished clearing image use flags for selected groups"
		;
		;	repaint the edit list
		;
		S1B_populate_image_listbox, Event
		;
		;	update disk file
		;
		MSP_PPOL_Save_Group_File, Event
		;
	endif else begin
		print_text, Event, "Warning - no group(s) selected. Try again"
	endelse
end
;
;-----------------------------------------------
pro S1_Select_groups, Event
	;
	;	one or more items in the group listbox was/were selected
	;
	WIDGET_CONTROL, Event.top, GET_UVALUE=PTR_struct
	s_ptr = PTR_struct.PTR_summary
	w_ptr = PTR_struct.PTR_wid_id
	g_ptr = PTR_struct.PTR_group
	;
	;	use WIDGET_INFO to determine the number of items selected
	;
	wid = (*w_ptr).S1_group_summary_listbox_wid
	index = WIDGET_INFO(wid, /LIST_SELECT)
	n = N_ELEMENTS(index)
	;
	if(index[0] ne -1 and n gt 0) then begin
		(*g_ptr).n_groups_selected = n
		;
		;print_text, Event, "Number of selected groups = "+STRING(format='(I)',n)
		;
		if(n gt 1) then begin
			in_list = ''
			for in = 0, n-1 do begin
				in_list = in_list + STRING(format='(1x,I5.3,1x)',index[in])
			endfor
		endif else in_list = STRING(format='(1x,F5.3,1x)',index)
		;
		;print_text, Event, "Index of selected items in list = "+in_list
		;
		;	set the index - it gets reset after a button action is handled
		;
		(*g_ptr).selected_groups[0:n-1] = index[*]
		if(n eq 1) then begin
			group = (*g_ptr).group_names[index[0]]
			print_text, Event, "Selected Group "+group+" from Group List"
		endif else begin
			print_text, Event, "Selected "+STRING(format='(I)',n)+" groups from list"
		endelse
	endif else print_text, Event, "Warning - no groups selected."
	;
end
;
;-----------------------------------------------
pro S1_Change_Group_Status, Event
	;
	; if one group has been selected, write its group completion value to
	;	the text box.
	;
	WIDGET_CONTROL, Event.top, GET_UVALUE=PTR_struct
	w_ptr = PTR_struct.PTR_wid_id
	g_ptr = PTR_struct.PTR_group
	;
	n = (*g_ptr).n_groups_selected
	if(n eq 1) then begin
		;
		g_ind = (*g_ptr).selected_groups[0]
		;
		print_text, Event, "Preparing to edit step number for group "+STRING(g_ind)
		;
		(*w_ptr).S1_step_number_value = (*g_ptr).group_step[g_ind]
		sval = ' '+STRTRIM(STRING((*w_ptr).S1_step_number_value, format='(I)'),2)+' '
		;
		WIDGET_CONTROL, (*w_ptr).S1_step_number_textbox_wid, SET_VALUE=sval
		;
		;	note that we don't actually change the group status until CR is
		;	hit when editing
		;
		;print_text, Event, "Step should have read "+sval
		;
		;	update disk status for all groups
		;
		MSP_PPOL_Save_Group_File, Event
		;
	endif else begin
		print_text, Event, "ERROR - no group was selected for editing"
	endelse
end
;
;-----------------------------------------------
pro S1A_Launch_file_chooser, Event, multiple_flag
	;
	;	uses file chooser to select images to group
	;
	;	if multiple_flag = 0, this is for a single group
	;	if multiple_flag = 1, this is for a bunch of groups
	;
	WIDGET_CONTROL, Event.top, GET_UVALUE=PTR_struct
	w_ptr = PTR_struct.PTR_wid_id
	s_ptr = PTR_struct.PTR_summary
	g_ptr = PTR_struct.PTR_group
	;
	n_groups = (*g_ptr).n_groups
	last_dir = (*s_ptr).last_dir
	;
	(*w_ptr).S1A_1_gntb_nch = 0
	(*w_ptr).S1C_gntb_nch = 0
	;
	;	open file chooser
	;
	file_list = dialog_pickfile(Title="Select Images to Group",FILE=last_dir+'junk',$
						/MULTIPLE_FILES)
	if(N_ELEMENTS(file_list) eq 1) then begin
		if(file_list eq '') then begin
			print_text, Event, "No images selected. Try again."
			goto, S1ALFC_end
		endif
	endif
	;
	n_file = N_ELEMENTS(file_list)
	if(n_file eq 0) then begin
		print_text, Event, "No images selected. Try again."
		goto, S1ALFC_end
	endif
	;
	(*s_ptr).last_dir = FILE_DIRNAME(file_list[0],/MARK_DIRECTORY)
	;
	;	sort by filenames (undo windows sort oddity)
	;
	scan_no = lonarr(n_file)
	scan = 0L
	for ifile = 0, n_file-1 do begin
		sflist = FILE_BASENAME(file_list[ifile])
		numlist = STRSPLIT(sflist, '.', /extract)
		imno = STRSPLIT(numlist[1],'_', /extract)
		reads, imno[0], scan, format='(I)'
		scan_no[ifile] = scan
	endfor
	;
	ind = SORT(scan_no)
	;
	;	force the sorted list
	;
	file_list = file_list[ind]
	;
	case multiple_flag of
		0: begin
			;
			if(n_file ge 1) then begin
				last_dir = FILE_DIRNAME(file_list[0],/MARK_DIRECTORY)
				(*s_ptr).last_dir = last_dir
				(*g_ptr).group_images[n_groups,0:n_file-1] = file_list
				(*g_ptr).group_image_flags[n_groups,0:n_file-1] = 1L		; set initial flag to good
				(*g_ptr).group_llq_flags[n_groups,0:n_file-1] = 0
				(*g_ptr).group_numbers[n_groups] = n_file
				(*g_ptr).group_step[n_groups] = 0
				(*g_ptr).group_meta[n_groups] = 0
				(*g_ptr).n_groups++
			endif
			;
			for ii = 0, n_file-1 do begin
				print_text, Event, "   Included image = "+FILE_BASENAME(file_list[ii])
			endfor
			print_text, Event, "Selected "+STRING(format='(I5.3)',n_file)+" images to form a new group"
			;
			;	develop default group name
			;
			header = HEADFITS(file_list[0])
			obj_name = STRTRIM(SXPAR(header, "OBJECT"),2)
			;
			obj_name = space_gone(obj_name)
			(*g_ptr).group_names[n_groups]=obj_name
			;
			;	show this in the text box and turn on the save button
			;
			WIDGET_CONTROL, (*w_ptr).S1A_1_group_name_textbox_wid, SET_VALUE=obj_name
			WIDGET_CONTROL, (*w_ptr).S1A_1_save_group_wid, SENSITIVE=1
			;
			;	and load into the text box buffer and character counter
			;
			(*w_ptr).S1A_1_gntb_nch = STRLEN(obj_name)
			len = STRLEN(obj_name)
			for ich = 0, (*w_ptr).S1A_1_gntb_nch-1 do begin
				(*w_ptr).S1A_1_gntb_buffer[ich] = STRMID(obj_name, ich, 1)
			endfor
			;
			WIDGET_CONTROL, (*w_ptr).S1A_1_group_name_textbox_wid, SET_TEXT_SELECT=[len-1,0]
			;
			print_text, Event, "Preparing to save these images as group = "+(*g_ptr).group_names[(*g_ptr).n_groups-1]
			;
			;	check for duplicate group name
			;
			if((*g_ptr).n_groups ge 2) then begin
				ind = WHERE((*g_ptr).group_names[0:(*g_ptr).n_groups-2] eq obj_name, count)
				if(count ge 1) then begin
					print_text, Event, "WARNING - This Group Name Duplicates Existing Group Name in List"
				endif
			endif
			;
		  end
		1: begin
			;
			;	images comprising many possible groups. load into the big save file
			;
			(*w_ptr).S1A_2_image_list[0:n_file-1] = file_list
			(*w_ptr).S1A_2_n_images = n_file
			;
			;	turn on next processing button
			;
			WIDGET_CONTROL, (*w_ptr).S1A_2_start_multiple_group_creation_button_wid, SENSITIVE=1
		   end
	endcase
	;
	S1ALFC_end:
end
;
;----------------------------------------------
pro S1_Edit_Step_Number, Event
	;
	;	a new character was entered in the step box
	;	- if delete, clear. - if character, enter and
	;	show. - if CR, replace step number of group
	;	and repaint group list
	;
	WIDGET_CONTROL, Event.top, GET_UVALUE=PTR_struct
	s_ptr = PTR_struct.PTR_summary
	w_ptr = PTR_struct.PTR_wid_id
	g_ptr = PTR_struct.PTR_group
	;
	nch = (*w_ptr).S1_sn_nch > 0
	;
	if(Event.type eq 0) then begin
		;
		;	if character not CR, put it into buffer
		;
		ch = Event.ch
		if(ch ne 10B) then begin
			(*w_ptr).S1_sn_buffer[nch] = STRING(ch)
			(*w_ptr).S1_sn_nch++
		endif else begin
			;
			;	was a character return - read the buffer as the step,
			;	put it into the group, and repaint the group listbox
			;
			name = ''
			for ich = 0, (*w_ptr).S1_sn_nch-1 do begin
				name = name + (*w_ptr).S1_sn_buffer[ich]
			endfor
			;
			name = STRTRIM(name,2)
			reads, name, step, format='(I)'
			;
			;	is the step within limits?
			;
			if(step lt 0 or step gt 9) then begin
				print_text, Event, "ERROR - step number not understood - try again"
				print_text, Event, "  Name = "+name+" inferred step = "+STRING(step, format='(I)')
				print_text, Event, "  Nch in buffer = "+STRING((*w_ptr).S1_sn_nch,format='(I)')
				;
				WIDGET_CONTROL, (*w_ptr).S1_step_number_textbox_wid, SET_VALUE=' '
			endif else begin
				;
				;	good step number, fetch group id and insert it
				;
				n = (*g_ptr).n_groups_selected
				if(n eq 1) then begin
					;
					g_ind = (*g_ptr).selected_groups[0]
					(*w_ptr).S1_step_number_value = step
					(*g_ptr).group_step[g_ind] = step
					;
					print_text, Event, "Changing step value of selected group to "+STRING(step,format='(I)')
					;
					S1_populate_group_list, Event
					(*g_ptr).n_groups_selected = 0
					(*g_ptr).selected_groups[*] = -1
				endif else begin
					print_text, Event, "ERROR - may only change step number of individual groups - reselect"
				endelse
			endelse
		endelse
		;
		;print_text, Event, "Insert Character Event - Character = "+STRING(format='(a)',Event.ch)
	endif else begin
		if(Event.type eq 1) then begin
			print_text, Event, "ERROR - Paste operation not supported - try again"
			;
		endif else begin
			if(Event.type eq 2) then begin
				;
				;	delete type event, go to offset, delete length
				;
				(*w_ptr).S1_sn_nch = 0
				(*w_ptr).S1_sn_buffer[*] = ''
				print_text, Event, "Delete found - Offset, Length = "+STRING(format='(I5.3,1x,I5.3)',Event.offset, Event.length)
			endif else begin
				print_text, Event, "Event not recognized"
			endelse
		endelse
	endelse
	;
	;	update disk file
	;
	MSP_PPOL_Save_Group_File, Event
end
;
;-----------------------------------------------
pro S1X_Group_name_textbox, Event, tab_num
	;
	;	handles textbox editing for
	;
	;		tab_num = 0		- create subtab
	;		tab_num = 2		- rename subtab
	;
	WIDGET_CONTROL, Event.top, GET_UVALUE=PTR_struct
	s_ptr = PTR_struct.PTR_summary
	w_ptr = PTR_struct.PTR_wid_id
	g_ptr = PTR_struct.PTR_group
	;
	;	handles insert character and insert string events
	;
	;	first, fetch current pointer into text box buffer
	;
	case tab_num of
		0: nch = (*w_ptr).S1A_1_gntb_nch
		2: nch = (*w_ptr).S1C_gntb_nch
	endcase
	;
	;	if it is zero, check whether something is already there
	;
	if(nch eq 0) then begin
		case tab_num of
			0: mch = WIDGET_INFO((*w_ptr).S1A_1_group_name_textbox_wid,/TEXT_NUMBER)
			2: mch = WIDGET_INFO((*w_ptr).S1C_group_name_textbox_wid,/TEXT_NUMBER)
		endcase
		if(mch ne 0) then begin
			case tab_num of
				0: WIDGET_CONTROL, (*w_ptr).S1A_1_group_name_textbox_wid, GET_VALUE=existing_text
				2: WIDGET_CONTROL, (*w_ptr).S1C_group_name_textbox_wid, GET_VALUE=existing_text
			endcase
			mch = STRLEN(existing_text[0])  ; to account for CR/LF in Windows (maybe 2 for linux...)
			;
			;	pack into character buffer
			;
			case tab_num of
				0: (*w_ptr).S1A_1_gntb_buffer[*] = ''
				2: (*w_ptr).S1C_gntb_buffer[*] = ''
			endcase
			;
			for im = 0, mch-1 do begin
				case tab_num of
					0: (*w_ptr).S1A_1_gntb_buffer[im] = STRMID(existing_text, im, 1)
					2: (*w_ptr).S1C_gntb_buffer[im] = STRMID(existing_text, im, 1)
				endcase
			endfor
			case tab_num of
				0: (*w_ptr).S1A_1_gntb_nch = mch
				2: (*w_ptr).S1C_gntb_nch = mch
			endcase
			nch = mch
		endif
	endif
	;
	new_name = 0
	;
	;	if any type of event, turn off Save button on create tab
	;
	if(tab_num eq 0) then WIDGET_CONTROL, (*w_ptr).S1A_1_save_group_wid, SENSITIVE=0
	;
	if(Event.type eq 0) then begin		; insert single character (not necessarily at the end)
		;
		;	if character not CR, put it into buffer
		;
		ch = Event.ch
		if(ch ne 10B) then begin
			;
			;print_text, Event, "Text Event type 0, offset = "+STRING(Event.offset,format='(I)')
			;
			case tab_num of
					0: WIDGET_CONTROL, (*w_ptr).S1A_1_group_name_textbox_wid, GET_VALUE=existing_text
					2: WIDGET_CONTROL, (*w_ptr).S1C_group_name_textbox_wid, GET_VALUE=existing_text
			endcase
			existing_text = space_gone(existing_text)
			;print_text, Event, "At Insert Ch, Current widget buffer = "+existing_text
			;
			case tab_num of
				0: begin
						(*w_ptr).S1A_1_gntb_nch = STRLEN(existing_text)
						for il = 0, STRLEN(existing_text[0])-1 do (*w_ptr).S1A_1_gntb_buffer[il] = STRMID(existing_text, il, 1)
						WIDGET_CONTROL, (*w_ptr).S1A_1_group_name_textbox_wid, SET_VALUE=space_gone(existing_text)
						WIDGET_CONTROL, (*w_ptr).S1A_1_group_name_textbox_wid, SET_TEXT_SELECT=[Event.offset,0]
					end
				2: begin
						(*w_ptr).S1C_gntb_nch = STRLEN(existing_text)
						len = STRLEN(existing_text[0])
						for il = 0, len-1 do begin
							(*w_ptr).S1C_gntb_buffer[il] = STRMID(existing_text, il, 1)
						endfor
						WIDGET_CONTROL, (*w_ptr).S1C_group_name_textbox_wid, SET_VALUE=space_gone(existing_text)
						WIDGET_CONTROL, (*w_ptr).S1C_group_name_textbox_wid, SET_TEXT_SELECT=[Event.offset,0]
					end
			endcase
		endif else begin
			;
			;	was a character return - load the buffer into a single string
			;
			name = ''
			case tab_num of
				0: max_ch = (*w_ptr).S1A_1_gntb_nch
				2: max_ch = (*w_ptr).S1C_gntb_nch
			endcase
			for ich = 0, max_ch-1 do begin
				case tab_num of
					0: this_ch = (*w_ptr).S1A_1_gntb_buffer[ich]
					2: this_ch = (*w_ptr).S1C_gntb_buffer[ich]
				endcase
				name = name + this_ch
			endfor
			;
			name = STRTRIM(name,2)
			;
			;	new name available - put it into current buffer and issue a relist command
			;
			new_name = 1
			;
		endelse
		;
		;print_text, Event, "Insert Character Event - Character = "+STRING(format='(a)',Event.ch)
	endif else begin
		if(Event.type eq 1) then begin
			case tab_num of
					0: WIDGET_CONTROL, (*w_ptr).S1A_1_group_name_textbox_wid, GET_VALUE=existing_text
					2: WIDGET_CONTROL, (*w_ptr).S1C_group_name_textbox_wid, GET_VALUE=existing_text
			endcase
			;print_text, Event, "At Insert String, Current widget buffer = "+existing_text
			existing_text = space_gone(existing_text)
			;
			;	to get here, a string was copied and pasted into the window
			;	as an insert action
			;
			name = STRTRIM(Event.str,2)
			length = STRLEN(name)
			if(length gt 1) then begin
				this_name = strarr(length)
				for il=0, length-1 do begin
					this_name[il] = STRMID(name,il,1)
				endfor
			endif else begin
				if(length eq 0) then begin
					;
					;	no length, skip
					;
					goto, S1X_end
				endif
				;
				this_name = strarr(1)
				this_name[0] = name
			endelse
			;
			case tab_num of
					0: begin
						(*w_ptr).S1A_1_gntb_nch = STRLEN(existing_text)
						for il = 0, STRLEN(existing_text[0])-1 do (*w_ptr).S1A_1_gntb_buffer[il] = STRMID(existing_text, il, 1)
						WIDGET_CONTROL, (*w_ptr).S1A_1_group_name_textbox_wid, SET_VALUE=space_gone(existing_text)
						WIDGET_CONTROL, (*w_ptr).S1A_1_group_name_textbox_wid, SET_TEXT_SELECT=[Event.offset,0]
					   end
					2: begin
						(*w_ptr).S1C_gntb_nch = STRLEN(existing_text)
						for il = 0, STRLEN(existing_text[0])-1 do (*w_ptr).S1C_gntb_buffer[il] = STRMID(existing_text, il, 1)
						WIDGET_CONTROL, (*w_ptr).S1C_group_name_textbox_wid, SET_VALUE=space_gone(existing_text)
						WIDGET_CONTROL, (*w_ptr).S1c_group_name_textbox_wid, SET_TEXT_SELECT=[Event.offset,0]
					   end
			endcase
			;
			;print_text, Event, "Insert String Event - String = "+STRING(format='(a)',Event.str)
		endif else begin
			if(Event.type eq 2) then begin
				;
				;	delete type event, go to offset, delete length and repost to the widget
				;
				;print_text, Event, "Delete found - Offset, Length = "+STRING(format='(I5.3,1x,I5.3)',Event.offset, Event.length)
				case tab_num of
					0: WIDGET_CONTROL, (*w_ptr).S1A_1_group_name_textbox_wid, GET_VALUE=existing_text
					2: WIDGET_CONTROL, (*w_ptr).S1C_group_name_textbox_wid, GET_VALUE=existing_text
				endcase
				;print_text, Event, "Current widget buffer = "+existing_text
				existing_text = space_gone(existing_text)
				;
				;	if length = 0 just skip
				;
				if(Event.length eq 0) then goto, S1X_end
				;
				case tab_num of
					0: begin
						(*w_ptr).S1A_1_gntb_nch = STRLEN(existing_text)
						for il = 0, STRLEN(existing_text[0])-1 do (*w_ptr).S1A_1_gntb_buffer[il] = STRMID(existing_text, il, 1)
						WIDGET_CONTROL, (*w_ptr).S1A_1_group_name_textbox_wid, SET_VALUE=space_gone(existing_text)
						WIDGET_CONTROL, (*w_ptr).S1A_1_group_name_textbox_wid, SET_TEXT_SELECT=[Event.offset,0]
					   end
					2: begin
						(*w_ptr).S1C_gntb_nch = STRLEN(existing_text)
						for il = 0, STRLEN(existing_text[0])-1 do (*w_ptr).S1C_gntb_buffer[il] = STRMID(existing_text, il, 1)
						WIDGET_CONTROL, (*w_ptr).S1C_group_name_textbox_wid, SET_VALUE=space_gone(existing_text)
						WIDGET_CONTROL, (*w_ptr).S1C_group_name_textbox_wid, SET_TEXT_SELECT=[Event.offset,0]
					   end
				endcase
				;
			endif else begin
				print_text, Event, "Event not recognized"
			endelse
		endelse
	endelse
	;
	;	if a new name was generated, test that it isn't a dupe
	;
	if(new_name eq 1) then begin
		;
		name = STRTRIM(space_gone(name),2)
		i_dupe = 0
		n_groups = (*g_ptr).n_groups
;		print_text, Event, "Number of groups to test for name dups = "+STRING(n_groups)
		if(n_groups ge 2) then begin
			ind = WHERE((*g_ptr).group_names[0:n_groups-1] eq name, count)
;			print_text, Event, "Number matching = "+STRING(count)
			if(count ge 1) then begin
				print_text, Event, "WARNING - Group Name "+name+" Duplicates Existing Group Name on List"
				i_dupe = 1
			endif
		endif
		;
		if(i_dupe eq 0) then begin
			;
			;	no dupe, go ahead and rename it and save it, if create tab
			;
			case tab_num of
				0: begin
					(*g_ptr).group_names[(*g_ptr).n_groups-1] = STRTRIM(name,2)
					;
					;	and update step
					;
					(*g_ptr).group_step[(*g_ptr).n_groups-1] = 1
					;
					;	then clear all buffers
					;
					(*w_ptr).S1A_1_gntb_nch = 0
					(*w_ptr).S1A_1_gntb_buffer[*] = ''
					WIDGET_CONTROL, (*w_ptr).S1A_1_group_name_textbox_wid, SET_VALUE=''
					print_text, Event, "Saved images in group named "+name
				   end
				2: begin
					;
					;	which group had been selected?
					;
					index = (*g_ptr).selected_groups[0]
					(*g_ptr).group_names[index] = STRTRIM(name,2)
					;
					;	then clear all buffers
					;
					(*w_ptr).S1C_gntb_nch = 0
					(*w_ptr).S1C_gntb_buffer[*] = ''
					WIDGET_CONTROL, (*w_ptr).S1C_group_name_textbox_wid, SET_VALUE=''
					print_text, Event, "Renamed group of images to "+name
				   end
			endcase
			;
			;	turn off base
			;
			WIDGET_CONTROL, (*w_ptr).S1_tab_base_wid, SENSITIVE=0
			nopop = 0
		endif else begin
			print_text, Event, "ERROR - Duplicate Group Name was not added to list. Rename necessary"
			case tab_num of
				0: nopop = 1
				2: begin
				    nopop = 0
					index = (*g_ptr).selected_groups[0]
					(*g_ptr).group_names[index] = name+'_duplicate'
					WIDGET_CONTROL, (*w_ptr).S1_tab_base_wid, SENSITIVE=0
				   end
			endcase
			;
		endelse
		if(nopop eq 0) then S1_populate_group_list, Event
	endif
	;
	S1X_end:
end
;
;-----------------------------------------------
pro S1A_1_Save_Group, Event
	WIDGET_CONTROL, Event.top, GET_UVALUE=PTR_struct
	s_ptr = PTR_struct.PTR_summary
	g_ptr = PTR_struct.PTR_group
	w_ptr = PTR_struct.PTR_wid_id
	;
	;	actually, the group is already saved, but this button will cause
	;	the list to be repopulated
	;
	;	check for duplicate group name
	;
	i_dupe = 0
	n_groups = (*g_ptr).n_groups
	if(n_groups ge 2) then begin
		this_group_name = (*g_ptr).group_names[n_groups-1]
		ind = WHERE((*g_ptr).group_names[0:n_groups-2] eq this_group_name, count)
		if(count ge 1) then begin
			print_text, Event, "WARNING - This Group Name Duplicates Existing Group Name in List"
			i_dupe = 1
		endif
	endif
	;
	if(i_dupe eq 0) then begin
		print_text, Event, "Saving image list as group = "+(*g_ptr).group_names[n_groups-1]
		;
		;	turn off tab base
		;
		WIDGET_CONTROL, (*w_ptr).S1_tab_base_wid, SENSITIVE=0
		;
		(*g_ptr).group_step[n_groups-1] = 1
		;
		S1_populate_group_list, Event
		;
		; and write to disk
		;
		MSP_PPOL_Save_Group_File, Event
	endif else begin
		print_text, Event, "ERROR - Duplicate Group Name was not added to list"
		(*g_ptr).n_groups--
		S1_populate_group_list, Event
	endelse
end
;---------------------------------------------------
pro S1A_2_Start_group_name_parsing, Event
	;
	;	takes list of images and parses it into distinct and non-duplicate groups
	;
	WIDGET_CONTROL, Event.top, GET_UVALUE=PTR_struct
	w_ptr = PTR_struct.PTR_wid_id
	s_ptr = PTR_struct.PTR_summary
	g_ptr = PTR_struct.PTR_group
	;
;	S1A_2_image_list:		strarr(10000), $		; file names
;	S1A_2_image_names:		strarr(10000), $		; object names
;	S1A_2_n_images:					0L, $
;	S1A_2_group_list:		strarr(10000), $
;	S1A_2_group_image_IDs:	lonarr(10000), $		; group number for each image
;	S1A_2_n_groups:					0L, $
	;
	n_images = (*w_ptr).S1A_2_n_images
	if(n_images eq 0) then begin
		print_text, Event, "Warning - no images in list. Must select images first."
		goto, S1A2SGNP_end
	endif
	;
	print_text, Event, "Parsing file names into groups... please wait..."
	WIDGET_CONTROL, (*w_ptr).S1A_2_read_directory_wid, SENSITIVE=0
	WIDGET_CONTROL, (*w_ptr).S1A_2_multiple_group_file_chooser_button_wid, SENSITIVE=0
	;
	;	get object names from each image (note: image order already sorted by image number in file chooser code above)
	;
	WIDGET_CONTROL, /hourglass
	;
	for ii = 0, n_images-1 do begin
		header = headfits( (*w_ptr).S1A_2_image_list[ii], /SILENT)
		;
		obj_name = SXPAR(header, "OBJECT")
		obj_name = space_gone(STRTRIM(obj_name,2))
		;
		(*w_ptr).S1A_2_image_names[ii] = obj_name
	endfor
	;
	;	find unique names
	;
	ind_uniq = UNIQ( (*w_ptr).S1A_2_image_names[0:n_images-1] )	; ind_uniq now points to last unique name in each group
	;
	;	for every unique name
	;
	n_uniq = N_ELEMENTS(ind_uniq)
	;
	for iname = 0, n_uniq-1 do begin
		;
		if(iname eq 0) then begin
			first = 0
		endif else begin
			first = ind_uniq[iname-1] + 1
		endelse
		last = ind_uniq[iname]
		;
		n_in_group = last - first + 1
		;
		this_group_name = (*w_ptr).S1A_2_image_names[ind_uniq[iname]]
		;
		;	check for duplicate names on the group list
		;
		;		print_text, Event, "Number of groups to test for name dups = "+STRING(n_groups)
		;
		n_groups = (*g_ptr).n_groups
		;
		if(n_groups ge 2) then begin
			;
			iloop = 0
			root_name = this_group_name
			recheck_names:
			;
			ind = WHERE((*g_ptr).group_names[0:n_groups-1] eq this_group_name, count)
;			print_text, Event, "Number matching = "+STRING(count)
			if(count ge 1) then begin
				print_text, Event, "WARNING - Group name "+this_group_name+" duplicates existing group name on list - modifying name"
				this_group_name = root_name + '_' + STRING(iloop+1,format='(I2.2)')
				iloop++
				if(iloop lt 10) then goto, recheck_names
				print_text, Event, "ERROR - too many duplicated group names. Skipping this group."
				goto, skip_group
			endif
		endif
		;
		;	if we got here, then the name is fine and the group may be added to the list
		;
		(*g_ptr).group_images[n_groups,0:n_in_group-1] = (*w_ptr).S1A_2_image_list[first:last]
		(*g_ptr).group_image_flags[n_groups,0:n_in_group-1] = 1L		; set initial flag to good
		(*g_ptr).group_llq_flags[n_groups,0:n_in_group-1] = 0
		(*g_ptr).group_numbers[n_groups] = n_in_group
		(*g_ptr).group_step[n_groups] = 1
		(*g_ptr).group_meta[n_groups] = 0
		(*g_ptr).n_groups++
		(*g_ptr).group_names[(*g_ptr).n_groups-1] = this_group_name
		;
		print_text, Event, "Saving group "+this_group_name
		;
		;	update group list
		;
		S1_populate_group_list, Event
		;
		;	position list to show the most recent plus a few
		;
		if( (*g_ptr).n_groups  gt 10) then begin
			WIDGET_CONTROL, (*w_ptr).S1_group_summary_listbox_wid, SET_LIST_TOP=( (*g_ptr).n_groups - 6 )
		endif
		;
		wait, 0.25
		;
		skip_group:				; label for not saving group
	endfor
	;
	print_text, Event, "Finished parsing, writing "+STRING(n_uniq,format='(I)')+" new groups"
	;
	; turn off tab subwindow
	;
	WIDGET_CONTROL, (*w_ptr).S1_tab_base_wid, SENSITIVE=0
	;
	;	and write to disk
	;
	MSP_PPOL_Save_Group_File, Event
	;
	S1A2SGNP_end:
end
;------------------------------------------------
pro S1A_2_Read_directory, Event
	;
	;	opens file chooser to select directory, then uses FILESEARCH to get all
	;	images into list (to go beyond 1000 image list limit of DIALOG_pickfile)
	;
	WIDGET_CONTROL, Event.top, GET_UVALUE=PTR_struct
	w_ptr = PTR_struct.PTR_wid_id
	s_ptr = PTR_struct.PTR_summary
	g_ptr = PTR_struct.PTR_group
	;
	last_dir = (*s_ptr).last_dir
	this_dir = dialog_pickfile(Title="Select Directory",PATH=last_dir,$
						/DIRECTORY)
	;
	if(this_dir eq '') then begin
		print_text, Event, "Invalid directory specified. Try again"
		goto, S1A2RD_end
	endif
	;
	;	check that it exists
	;
	test = FILE_INFO(this_dir)
	if(NOT(test.exists) or NOT(test.directory)) then begin
		print_text, Event, "Invalid directory specified. Try again"
		goto, S1A2RD_end
	endif
	;
	(*s_ptr).last_dir = this_dir 			; + PATH_SEP() ??
	;
	print_text, Event, "Reading all files in directory "+FILE_DIRNAME(this_dir)+" ... please wait..."
	;
	;	read the files in the directory (of type .FITS)
	;
	WIDGET_CONTROL, /hourglass
	;
	file_list = FILE_SEARCH(this_dir, '*.fits')
	;
	n_file = N_ELEMENTS(file_list)
	if(n_file eq 0) then begin
		print_text, Event, "No valid images in directory "+FILE_DIRNAME(this_dir)
		goto, S1A2RD_end
	endif
	;
	;	sort by filenames (undo windows sort oddity)
	;
	scan_no = lonarr(n_file)
	scan = 0L
	for ifile = 0, n_file-1 do begin
		sflist = FILE_BASENAME(file_list[ifile])
		numlist = STRSPLIT(sflist, '.', /extract)
		imno = STRSPLIT(numlist[1],'_', /extract)
		reads, imno[0], scan, format='(I)'
		scan_no[ifile] = scan
	endfor
	;
	ind = SORT(scan_no)
	;
	;	force the sorted list
	;
	file_list = file_list[ind]
	;
	;	images comprising many possible groups. load into the big save file
	;
	(*w_ptr).S1A_2_image_list[0:n_file-1] = file_list
	(*w_ptr).S1A_2_n_images = n_file
	;
	;	turn on next processing button
	;
	WIDGET_CONTROL, (*w_ptr).S1A_2_start_multiple_group_creation_button_wid, SENSITIVE=1
	print_text, Event, "Read names of "+STRING(n_file,format='(I)')+" image files"
	;
	S1A2RD_end:
	;
end
;-----------------------------------------------
;
pro S1B_populate_image_listbox, Event
	;
	;	lists current images in the selected group on the listbox on tab 1C
	;
	WIDGET_CONTROL, Event.top, GET_UVALUE=PTR_struct
	w_ptr = PTR_struct.PTR_wid_id
	s_ptr = PTR_struct.PTR_summary
	g_ptr = PTR_struct.PTR_group
	;
	this_group = (*g_ptr).selected_groups[0]
	n_images = (*g_ptr).group_numbers[this_group]
	image_list = REFORM((*g_ptr).group_images[this_group,0:n_images-1])
	;
	if(n_images gt 0) then begin
		;
		;	trim to date, number
		;
		image_list = FILE_BASENAME(image_list, '_LDFC.FITS')
		text_list = strarr(N_ELEMENTS(image_list))
		for il = 0, n_images-1 do begin
			text_list[il] = image_list[il] + '  UseFlag ' + STRING((*g_ptr).group_image_flags[this_group,il],format='(I2)')
		endfor
		;
		;
		WIDGET_CONTROL, (*w_ptr).S1B_select_images_listbox_wid, SET_VALUE=text_list
	endif
	;
	;
	;	display total image count and USE=0 flag image count
	;
	this_group = (*g_ptr).selected_groups[0]
	n_images = (*g_ptr).group_numbers[this_group]
	;
	WIDGET_CONTROL, (*w_ptr).S1B_image_count_textbox_wid, SET_VALUE=STRING(n_images,format='(2x,i3.1)')
	;
	if(n_images gt 0) then begin
		;
		;	count use flags = 0
		;
		n_use_zero = n_images - ROUND(TOTAL( (*g_ptr).group_image_flags[this_group,0:n_images-1] ))
	endif else begin
		n_use_zero = 0
	endelse
	;
	WIDGET_CONTROL, (*w_ptr).S1B_use_zero_count_textbox_wid, SET_VALUE=STRING(n_use_zero,format='(2x,i3.1)')
end
;
;---------------------------------------------------
pro S1B_Add_images_to_List, Event
	;
	;	adds more images to those in the selected group
	;	(and resorts before saving)
	;
	WIDGET_CONTROL, Event.top, GET_UVALUE=PTR_struct
	w_ptr = PTR_struct.PTR_wid_id
	s_ptr = PTR_struct.PTR_summary
	g_ptr = PTR_struct.PTR_group
	;
	;n_groups = (*g_ptr).n_groups
	last_dir = (*s_ptr).last_dir
	;
	this_group = (*g_ptr).selected_groups[0]
	n_images = (*g_ptr).group_numbers[this_group]
	image_list = REFORM((*g_ptr).group_images[this_group,0:n_images-1])
	;
	;	open file chooser
	;
	new_file_list = dialog_pickfile(Title="Select Images to Group",FILE=last_dir+'junk',$
						/MULTIPLE_FILES)
	n_file = N_ELEMENTS(new_file_list)
	;
	;	concatenate
	;
	n_file = n_file + n_images
	file_list = strarr(n_file)
	file_list[0:n_images-1] = image_list
	file_list[n_images:n_file-1] = new_file_list
	;
	;	sort by filenames,  (undo windows sort oddity)
	;
	scan_no = lonarr(n_file)
	scan = 0L
	for ifile = 0, n_file-1 do begin
		sflist = FILE_BASENAME(file_list[ifile])
		numlist = STRSPLIT(sflist, '.', /extract)
		imno = STRSPLIT(numlist[1],'_', /extract)
		reads, imno[0], scan, format='(I)'
		scan_no[ifile] = scan
	endfor
	;
	if(n_file ge 1) then begin
		last_dir = FILE_DIRNAME(file_list[0],/MARK_DIRECTORY)
		ind = SORT(scan_no)
		;
		;	force the sorted list and use flags
		;
		(*g_ptr).group_image_flags[this_group,n_images:n_file-1] = 1L
		(*g_ptr).group_llq_flags[this_group,n_images:n_file-1] = 0
		;
		file_list = file_list[ind]
		n_old_file = n_file
		;
		; remove dupes
		;
		file_order = UNIQ(file_list)
		n_file = N_ELEMENTS(file_order)
		;
		print_text, Event, "Read in "+STRING(n_images)+" of which "+STRING(n_old_file - n_file)+" were duplicates"

		(*s_ptr).last_dir = last_dir
		(*g_ptr).group_images[this_group,0:n_file-1] = file_list[file_order]
		(*g_ptr).group_image_flags[this_group,0:n_file-1] = (*g_ptr).group_image_flags[this_group,file_order] ; use flags
		(*g_ptr).group_llq_flags[this_group,0:n_file-1] = (*g_ptr).group_llq_flags[this_group,file_order] ; llq flags
		(*g_ptr).group_numbers[this_group] = n_file
		(*g_ptr).group_step[this_group] = 0
		(*g_ptr).group_meta[this_group] = 0
	endif
	;
	S1B_populate_image_listbox, Event
	;
	;	and write to disk
	;
	MSP_PPOL_Save_Group_File, Event
	;
end
;------------------------------------------------
;
pro S1B_Select_images_on_List, Event
	;
	;	one or more images in the image listbox was/were selected
	;
	WIDGET_CONTROL, Event.top, GET_UVALUE=PTR_struct
	s_ptr = PTR_struct.PTR_summary
	w_ptr = PTR_struct.PTR_wid_id
	g_ptr = PTR_struct.PTR_group
	;
	;	use WIDGET_INFO to determine the number of items selected
	;
	this_group = (*g_ptr).selected_groups[0]
	;
	wid = (*w_ptr).S1B_select_images_listbox_wid
	index = WIDGET_INFO(wid, /LIST_SELECT)
	n = N_ELEMENTS(index)
	;
	if(index[0] ne -1 and n gt 0) then begin
		(*w_ptr).S1B_n_images_selected = n
		;
		print_text, Event, "Number of selected images = "+STRING(format='(I)',n)
		;
		;	set the index - it gets reset after a button action is handled
		;
		(*w_ptr).S1B_selected_image_indices[0:n-1] = index[*]
		if(n eq 1) then begin
			this_image = (*g_ptr).group_images[this_group,index[0]]
			print_text, Event, "Selected image "+this_image+" from list"
		endif else begin
			print_text, Event, "Selected "+STRING(format='(I)',n)+" images from list"
		endelse
	endif else print_text, Event, "Warning - no images selected."
	;
end
;-----------------------------------------------
pro S1B_Remove_images_from_list, Event
	;
	;	removes one or more images from the displayed list and updates all storage
	;
	WIDGET_CONTROL, Event.top, GET_UVALUE=PTR_struct
	s_ptr = PTR_struct.PTR_summary
	w_ptr = PTR_struct.PTR_wid_id
	g_ptr = PTR_struct.PTR_group
	;
	;
	this_group = (*g_ptr).selected_groups[0]
	;
	n_selected = (*w_ptr).S1B_n_images_selected
	;
	if(n_selected eq 0) then begin
		print_text, Event, "No images selected for deletion. Select first, then press delete button."
		goto, S1BRIFL_end
	endif
	;
	indices = (*w_ptr).S1B_selected_image_indices[0:n_selected-1]
	;
	;	set their use flags to -1, then push the list down
	;
	(*g_ptr).group_image_flags[this_group,indices] = -1
	;
	n_start = (*g_ptr).group_numbers[this_group]
	n_end = 0L
	;
	for ii = 0, n_start-1 do begin
		if((*g_ptr).group_image_flags[this_group,ii] ne -1) then begin
			(*g_ptr).group_image_flags[this_group,n_end] = (*g_ptr).group_image_flags[this_group,ii]
			(*g_ptr).group_llq_flags[this_group,n_end] = (*g_ptr).group_llq_flags[this_group,ii]
			(*g_ptr).group_images[this_group,n_end] = (*g_ptr).group_images[this_group,ii]
			n_end++
		endif
	endfor
	(*g_ptr).group_numbers[this_group] = n_end
	;
	print_text, Event, "Number of removed images = "+STRING(format='(I)',n_selected)
	;
	(*w_ptr).S1B_n_images_selected = 0L
	;
	S1BRIFL_end:
	S1B_populate_image_listbox, Event
	;
	;	and write to disk
	;
	MSP_PPOL_Save_Group_File, Event
end
;
;-----------------------------------------------
pro S1B_Set_Use_Flag_Zero, Event
	;
	;	Sets to zero the USE flag for one or more images from the displayed list and updates all storage
	;
	WIDGET_CONTROL, Event.top, GET_UVALUE=PTR_struct
	s_ptr = PTR_struct.PTR_summary
	w_ptr = PTR_struct.PTR_wid_id
	g_ptr = PTR_struct.PTR_group
	;
	;
	this_group = (*g_ptr).selected_groups[0]
	;
	n_selected = (*w_ptr).S1B_n_images_selected
	;
	if(n_selected eq 0) then begin
		print_text, Event, "No images selected. Select first, then press action button."
		goto, S1SUFZ_end
	endif
	;
	indices = (*w_ptr).S1B_selected_image_indices[0:n_selected-1]
	;
	;	set their use flags to 0
	;
	(*g_ptr).group_image_flags[this_group,indices] = 0
	;
	print_text, Event, "Number of images to set USE->0 = "+STRING(format='(I)',n_selected)
	;
	(*w_ptr).S1B_n_images_selected = 0L
	;
	S1SUFZ_end:
	;
	S1B_populate_image_listbox, Event
	;
	;	and write to disk
	;
	MSP_PPOL_Save_Group_File, Event
end
;
;-----------------------------------------------
pro S1_populate_group_list, Event
	;
	;	lists current groups and step status by name on the listbox
	;
	WIDGET_CONTROL, Event.top, GET_UVALUE=PTR_struct
	w_ptr = PTR_struct.PTR_wid_id
	s_ptr = PTR_struct.PTR_summary
	g_ptr = PTR_struct.PTR_group
	;
	n_groups = (*g_ptr).n_groups
	if(n_groups gt 0) then begin
		;
		;	load group name and step status
		;
		text_vec = strarr(n_groups)
		for ig = 0, n_groups-1 do begin
			grp_step = (*g_ptr).group_step[ig]
			if((grp_step ge 30 and grp_step le 40) or $
			   (grp_step ge 60 and grp_step le 70) or $
			   (grp_step ge 110 and grp_step le 119)) then begin
			   step_0 = FLOOR(grp_step / 10)
			   step_1 = grp_step - 10 * step_0
			   text_vec[ig] = STRTRIM(STRING(format='(A," Step=",I2.1,".",I1.1,", Meta=",I2.1)',$
					(*g_ptr).group_names[ig],step_0,step_1,(*g_ptr).group_meta[ig]),1)

			endif else begin
				text_vec[ig] = STRTRIM(STRING(format='(A," Step=",I2.1,", Meta=",I2.1)',$
					(*g_ptr).group_names[ig],(*g_ptr).group_step[ig],(*g_ptr).group_meta[ig]),1)
			endelse
		endfor
	endif else begin
		text_vec = ['','']
	endelse
	;
	WIDGET_CONTROL, (*w_ptr).S1_group_summary_listbox_wid, SET_VALUE=text_vec
	;
end
;
;------------------------------------------------------
pro S1_populate_meta_list, Event
	;
	;	lists current meta-groups and step status by name on the meta-group listbox
	;
	WIDGET_CONTROL, Event.top, GET_UVALUE=PTR_struct
	w_ptr = PTR_struct.PTR_wid_id
	s_ptr = PTR_struct.PTR_summary
	g_ptr = PTR_struct.PTR_group
	;
	n_meta_groups = (*g_ptr).n_meta_groups
	if(n_meta_groups gt 0) then begin
		;
		;	load meta-group name and step status
		;
		text_vec = strarr(n_meta_groups)
		;
		for img = 1, n_meta_groups do begin
			;
			text_vec[img-1] = STRTRIM(STRING(format='(A,"    Step=",I2.1,"  Meta_Group_No=",I2.1)',$
					(*g_ptr).meta_group_names[img],(*g_ptr).meta_group_step[img],img),1)
		endfor
	endif else begin
		;
		;	clear a couple of lines, just in case
		;
		text_vec = ['','']
	endelse
	;
	WIDGET_CONTROL, (*w_ptr).S1_meta_group_listbox_wid, SET_VALUE=text_vec
	;
end
;
;----------------------------------------------------
pro S1_Remove_meta_group, Event
	;
	;	removes the metagroup designation from the indicated meta-group
	;	and all its group members
	;
	WIDGET_CONTROL, Event.top, GET_UVALUE=PTR_struct
	s_ptr = PTR_struct.PTR_summary
	w_ptr = PTR_struct.PTR_wid_id
	g_ptr = PTR_struct.PTR_group
	;
	;	how many selected?
	;
	n = (*g_ptr).n_meta_groups_selected
	;
	; for now, only allow the first one to be deleted (DPC 20140523)
	; ;
	if(n gt 1) then begin
	   print_text, Event, 'More than one Meta-Group selected for deletion..'
	   print_text, Event, '  but limiting deletion to first on list, only'
	   n = 1
	endif
	;
	if(n gt 0) then begin
		index = (*g_ptr).selected_meta_groups[0:n-1]
		;
		for img = 0, n-1 do begin
			;
			j = index[img]
			;
			ngroups = (*g_ptr).meta_group_numbers[j]
			if(ngroups ge 1) then begin
				(*g_ptr).group_meta[(*g_ptr).meta_group_groups[j,0:ngroups-1]] = 0
			endif
			;
			;	push down
			;
			n_meta_max = N_ELEMENTS((*g_ptr).meta_group_numbers)
			(*g_ptr).meta_group_numbers[j:n_meta_max-2] = (*g_ptr).meta_group_numbers[j+1:n_meta_max-1]
			(*g_ptr).meta_group_numbers[n_meta_max-1] = 0
			;
			(*g_ptr).meta_group_groups[j:n_meta_max-2,*] = (*g_ptr).meta_group_groups[j+1:n_meta_max-1,*]
			(*g_ptr).meta_group_groups[n_meta_max-1,*] = -1
			;
			(*g_ptr).meta_group_group_flags[j:n_meta_max-2,*] = (*g_ptr).meta_group_group_flags[j+1:n_meta_max-1,*]
			(*g_ptr).meta_group_group_flags[n_meta_max-1,*] = -1
			;
			(*g_ptr).meta_group_names[j:n_meta_max-2] = (*g_ptr).meta_group_names[j+1:n_meta_max-1]
			(*g_ptr).meta_group_names[n_meta_max-1] = ''
			;
			(*g_ptr).meta_group_step[j:n_meta_max-2] = (*g_ptr).meta_group_step[j+1:n_meta_max-1]
			(*g_ptr).meta_group_step[n_meta_max-1] = 0
			;
			(*g_ptr).n_meta_groups--
			;
			;	update meta_group pointers in groups, since we have killed off some meta group
			;						;
			ind = WHERE((*g_ptr).group_meta[*] gt j, count)
			if(count gt 0) then (*g_ptr).group_meta[ind]--
;			jnd = WHERE((*g_ptr).selected_meta_groups[0:n-1] gt j,jcount)
;			if(jcount gt 0) then (*g_ptr).selected_meta_groups[jnd]--
			;
		endfor
		print_text, Event, "Removed "+STRING(n,format='(I)')+" meta-groups from list"
	endif else print_text, Event, "Warning - No meta-groups selected for removal"
	;
	;	reload listboxes
	;
	S1_populate_group_list, Event
	S1_populate_meta_list, Event
	;
	;	update disk file
	;
	MSP_PPOL_Save_Group_File, Event
end
;
;----------------------------------------------------
pro S1_Select_meta_groups, Event
	;
	;
	WIDGET_CONTROL, Event.top, GET_UVALUE=PTR_struct
	s_ptr = PTR_struct.PTR_summary
	w_ptr = PTR_struct.PTR_wid_id
	g_ptr = PTR_struct.PTR_group
	;
	wid = (*w_ptr).S1_meta_group_listbox_wid
	index = WIDGET_INFO(wid, /LIST_SELECT)
	n = N_ELEMENTS(index)
	if(index[0] ne -1 and n gt 0) then begin
		(*g_ptr).n_meta_groups_selected = n
		;
		print_text, Event, "Number of selected meta-groups = "+STRING(format='(I)',n)
		;
		;	set the index - it gets reset after a button action is handled
		;
		(*g_ptr).selected_meta_groups[0:n-1] = index[*] + 1
		if(n eq 1) then begin
			group = (*g_ptr).meta_group_names[index[0]+1]
			print_text, Event, "Selected Meta-group "+group+" from Meta-group List"
		endif else begin
			print_text, Event, "Selected "+STRING(format='(I)',n)+" meta-groups from list"
		endelse
	endif else print_text, Event, "Warning - No meta-groups selected. Selection error?"
	;
end
