;	Step 6 Event Handler Routines
;
pro S6_Init, Event
	;
	;	initialize S6 stuff when tabbing onto Step 6
	;
	WIDGET_CONTROL, Event.top, GET_UVALUE=PTR_struct
	w_ptr = PTR_struct.PTR_wid_id
	g_ptr = PTR_struct.PTR_group
	;
	h_wid = (*w_ptr).S6_history_textbox_wid
	SAll_populate_history, Event, h_wid, 6
	;
	;  DPC 20140523 - clear both S6 queue lists to +3 ("...")
	;  
	;(*g_ptr).S6_group_queue[*] = 3
	;(*g_ptr).S6_meta_group_queue[*] = 3
	;
	;	find which sub-tab is front and do its init
	;
	sub_tab = WIDGET_INFO((*w_ptr).S6_tab_base_wid,/TAB_CURRENT)
	case sub_tab of
		0:	begin
				n_groups = (*g_ptr).n_groups
				if(n_groups gt 0) then begin
					ind = WHERE((*g_ptr).S6_group_queue[0:n_groups-1] ge 1,count)
					if(count gt 0) then (*g_ptr).S6_group_queue[ind] = -2
				endif
				S6_populate_group_list, Event, 0
				S6_LED_sensitize, Event, 0, 0, 0
			end
		1:	begin
				n_groups = (*g_ptr).n_groups
				if(n_groups gt 0) then begin
					ind = WHERE((*g_ptr).S6_group_queue[0:n_groups-1] ge 1,count)
					if(count gt 0) then (*g_ptr).S6_group_queue[ind] = -2
				endif
				S6_populate_group_list, Event, 1
				n_meta_groups = (*g_ptr).n_meta_groups
				if(n_meta_groups gt 0) then begin
					ind = WHERE((*g_ptr).S6_meta_group_queue[1:n_meta_groups] ge 1,count)
					if(count gt 0) then (*g_ptr).S6_meta_group_queue[ind+1] = -2
				endif
				S6_populate_meta_group_list, Event, 1
			end
		2:	begin
				n_meta_groups = (*g_ptr).n_meta_groups
				if(n_meta_groups gt 0) then begin
					ind = WHERE((*g_ptr).S6_meta_group_queue[1:n_meta_groups] ge 1,count)
					if(count gt 0) then (*g_ptr).S6_meta_group_queue[ind+1] = -2
				endif
				S6_populate_meta_group_list, Event, 2
				S6_LED_sensitize, Event, 2, 0, 0
				S6_LED_sensitize, Event, 2, 1, 0
				S6_populate_textbox, Event, 2
			end
		3: begin
				n_meta_groups = (*g_ptr).n_meta_groups
				if(n_meta_groups gt 0) then begin
					ind = WHERE((*g_ptr).S6_meta_group_queue[1:n_meta_groups] ge 1,count)
					if(count gt 0) then (*g_ptr).S6_meta_group_queue[ind+1] = -2
				endif
				S6_populate_meta_group_list, Event, 3
				S6_LED_sensitize, Event, 3, 0, 0
			end
		else: print_text, Event, "ERROR - illegal subtab on Step 6"
	endcase
	;
end
;
;-----------------------------------------------------------------------------------
pro S6_Tab_Handler, Event
	WIDGET_CONTROL, Event.top, GET_UVALUE=PTR_struct
	w_ptr = PTR_struct.PTR_wid_id
	g_ptr = PTR_struct.PTR_group
	;
	;	what to do when arriving at a tab
	;
	(*w_ptr).S6_current_tab = Event.tab
	;
	h_wid = (*w_ptr).S6_history_textbox_wid
	SAll_populate_history, Event, h_wid, 6
	;
	case Event.tab of
		0: begin
				print_text, Event, "Tab Change to Step 6A"
				n_groups = (*g_ptr).n_groups
				if(n_groups gt 0) then begin
					ind = WHERE((*g_ptr).S6_group_queue[0:n_groups-1] ge 1,count)
					if(count gt 0) then (*g_ptr).S6_group_queue[ind] = -2
				endif
				S6_populate_group_list, Event, 0
				S6_LED_sensitize, Event, 0, 0, 0
				;
				;	maybe clear LED and draw window? or repaint?
				;
			end
		1:  begin
				print_text, Event, "Tab Change to Step 6B"
				n_groups = (*g_ptr).n_groups
				if(n_groups gt 0) then begin
					ind = WHERE((*g_ptr).S6_group_queue[0:n_groups-1] ge 1,count)
					if(count gt 0) then (*g_ptr).S6_group_queue[ind] = -2
				endif
				S6_populate_group_list, Event, 1
				n_meta_groups = (*g_ptr).n_meta_groups
				if(n_meta_groups gt 0) then begin
					ind = WHERE((*g_ptr).S6_meta_group_queue[1:n_meta_groups] ge 1,count)
					if(count gt 0) then (*g_ptr).S6_meta_group_queue[ind+1] = -2
				endif
				S6_populate_meta_group_list, Event, 1
			end
		2:  begin
				print_text, Event, "Tab Change to Step 6C"
				S6_populate_meta_group_list, Event, 2
				n_meta_groups = (*g_ptr).n_meta_groups
				if(n_meta_groups gt 0) then begin
					ind = WHERE((*g_ptr).S6_meta_group_queue[1:n_meta_groups] ge 1,count)
					if(count gt 0) then (*g_ptr).S6_meta_group_queue[ind+1] = -2
				endif
				S6_LED_sensitize, Event, 2, 0, 0
				S6_LED_sensitize, Event, 2, 1, 0
				;
				;	again, perhaps clear LED and draw window
				;
				S6_populate_textbox, Event, 2
			end
		3: begin
			print_text, Event, "Tab Change to Step 6D"
				S6_populate_meta_group_list, Event, 3
				n_meta_groups = (*g_ptr).n_meta_groups
				if(n_meta_groups gt 0) then begin
					ind = WHERE((*g_ptr).S6_meta_group_queue[1:n_meta_groups] ge 1,count)
					if(count gt 0) then (*g_ptr).S6_meta_group_queue[ind+1] = -2
				endif
				S6_LED_sensitize, Event, 3, 0, 0
			end
		else: begin print_text, Event, "Tab not recognized - try again"
			end
	endcase
;	MSP_PPOL_Save_Group_File, Event
    ;
end
;
;----------------------------------------------
pro S6_populate_textbox, Event, tab_no
	;
	;	populate textboxes on tabs
	;
	WIDGET_CONTROL, Event.top, GET_UVALUE=PTR_struct
	w_ptr = PTR_struct.PTR_wid_id
	;
	case tab_no of
		0:	begin
				wid = (*w_ptr).S6A_group_name_textbox_wid
				value = (*w_ptr).S6A_group_name
				WIDGET_CONTROL, wid, SET_VALUE= '    ' + value
				;
				wid = (*w_ptr).S6A_field_pol_textbox_wid
				value = '   ' + STRING( (*w_ptr).S6A_field_pol_value, (*w_ptr).S6A_field_pol_sigma, $
						format='(f5.3,"+/-",f5.3)')
				WIDGET_CONTROL, wid, SET_VALUE=value
				;
				wid = (*w_ptr).S6A_sky_noise_textbox_wid
				WIDGET_CONTROL, wid, SET_VALUE = '   ' + STRING( (*w_ptr).S6A_sky_noise_value, $
						format='(f6.3)')
				;
				wid = (*w_ptr).S6A_bad_image_count_textbox_wid
				WIDGET_CONTROL, wid, SET_VALUE= '   ' + STRING( (*w_ptr).S6A_bad_image_count, $
						format='(i3)')
				;
				wid = (*w_ptr).S6A_aper_no_textbox_wid
				WIDGET_CONTROL, wid, SET_VALUE= ' ' + STRING( (*w_ptr).S6A_aper_no_value, $
						format='(i2)')
				;
        wid = (*w_ptr).S6A_amplitude_textbox_wid
        WIDGET_CONTROL, wid, SET_VALUE= ' ' + STRING( (*w_ptr).S6A_scaling_amplitude, $
            format='(f6.2)')
			end
		1:  print_text, Event, "??? Should not get here - Tab 6B - populate textbox"
		2:  begin
				;
				
			end
		3: print_text, Event, "??? Should not get here - Tab 6D - populate textbox"
	endcase
end
;
;-----------------------------------------------
pro S6_LED_sensitize, Event, S6_LED_number, iw, sense
	;
	;	initializes LED stacks
	;
	WIDGET_CONTROL, Event.top, GET_UVALUE=PTR_struct
	w_ptr = PTR_struct.PTR_wid_id
	;
	wid = lonarr(2)
	;
	case S6_LED_number of
		0:	begin
				wid[0] = (*w_ptr).S6A_LED0_group_wid
				wid[1] = -1
			end
		2:	begin
				wid[0] = (*w_ptr).S6C_LED0_meta_group_wid
				wid[1] = (*w_ptr).S6C_LED1_group_wid
			end
		3:  begin
				wid[0] = (*w_ptr).S6D_LED0_meta_group_wid
				wid[1] = -1
			end
		else:  print_text, Event, "ERROR - wrong LED initialized"
	endcase
	;
	if(wid[iw] ne -1) then begin
		WIDGET_CONTROL, wid[iw], SENSITIVE=sense
		;
		;	set all colors to red upon sensitization
		;
		WIDGET_CONTROL, wid[iw], GET_UVALUE=nLED
		;
		n_ele = N_ELEMENTS(nLED)
		if(n_ele eq 0) then begin
			case S6_LED_number of
				0:	nLED = 25
				2:  nLED = 10
				3:  nLED = 5
			endcase
		endif
		if(nLED eq 0) then begin
			case S6_LED_number of
				0:	nLED = 25
				2:  nLED = 10
				3:  nLED = 5
			endcase
		endif
		WIDGET_CONTROL, wid[iw], SET_UVALUE=nLED
		colors = strarr(nLED)
		if(sense eq 1) then colors[*] = "red" else colors[*] = "gray"
		WCT_LED_stack, wid[iw], colors
	endif
end
;
;-----------------------------------------------------------------
pro S6_populate_group_list, Event, tab_no
	;
	;	lists current groups and step status by name on the listbox
	;	on the indicated tab number
	;
	WIDGET_CONTROL, Event.top, GET_UVALUE=PTR_struct
	w_ptr = PTR_struct.PTR_wid_id
	s_ptr = PTR_struct.PTR_summary
	g_ptr = PTR_struct.PTR_group
	;
	case tab_no of
		0:	wid = (*w_ptr).S6A_group_listbox_wid
		1:	wid = (*w_ptr).S6B_group_to_meta_group_listbox_wid
		else: print_text, Event, "ERROR - S6 group listbox number not recognized."
	endcase
	;
	n_groups = (*g_ptr).n_groups
	if(n_groups gt 0) then begin
		;
		;	load group name,step and meta status, and queue status
		;
		text_vec = strarr(n_groups)
		for ig = 0, n_groups-1 do begin
		  ;
		  ; if not processed sufficiently, set to ? to indicate confusion
		  ;
			if((*g_ptr).group_step[ig] lt 5) then begin
			   (*g_ptr).S6_group_queue[ig] = -2
			;
			;  else, look to see if it is already in a meta group
			;
			endif else begin
			   if( (*g_ptr).group_meta[ig] ne 0) then begin
			       ;
			       ; look for any meta group number greater than the highest one
			       ;
			       if( (*g_ptr).group_meta[ig] gt (*g_ptr).n_meta_groups) then begin
			           ;
			           ; found such a wild group - reset its pointer
			           ;
			           (*g_ptr).group_meta[ig] = 0
			           (*g_ptr).S6_group_queue[ig] = 3
			           print_text, Event,"Found group with meta group > largest, resetting"
			       endif else begin
			         (*g_ptr).S6_group_queue[ig] = -3
			       endelse
			   endif else begin
			       ;
			       ; group not linked to a meta group any longer, be sure its S6 queue status is -2;
			       ; if not already assigned
			       ;
			       if((*g_ptr).S6_group_queue[ig] lt -1) then (*g_ptr).S6_group_queue[ig] = -2
			   endelse
			endelse
		  i_queue = (*g_ptr).S6_group_queue[ig]
			;
			case i_queue of
				-3: queue = "in Meta"
				-2:	queue = '?'
				-1: queue = 'Skip'
				 0: queue = 'Done'
				 1: queue = 'Active'
				 2: queue = 'Queued'
				else: queue = '...'
			endcase
			;
			grp_step = (*g_ptr).group_step[ig]
			if((grp_step ge 30 and grp_step le 40) or $
			   (grp_step ge 60 and grp_step le 70) or $
			   (grp_step ge 110 and grp_step le 119)) then begin
			   step_0 = FLOOR(grp_step / 10)
			   step_1 = grp_step - 10 * step_0
			   text_vec[ig] = STRTRIM(STRING(format='(A," Step=",I2.1,".",I1.1,", Meta=",I2.1,", Action= ",A)',$
					(*g_ptr).group_names[ig],step_0,step_1,(*g_ptr).group_meta[ig],queue),1)

			endif else begin
				text_vec[ig] = STRTRIM(STRING(format='(A," Step=",I2.1,", Meta=",I2.1,", Action= ",A)',$
					(*g_ptr).group_names[ig],(*g_ptr).group_step[ig],(*g_ptr).group_meta[ig],queue),1)
			endelse
			;
			;text_vec[ig] = STRTRIM(STRING(format='(A19," Step=",I2.1,"  Meta=",I2.1,"  Action= ",A)',$
			;		(*g_ptr).group_names[ig],(*g_ptr).group_step[ig],(*g_ptr).group_meta[ig],queue),1)
		endfor
	endif else begin
		text_vec = ['','']
	endelse
	;
	WIDGET_CONTROL, wid, SET_VALUE=text_vec
	;
	;	next, clear selections
	;
	(*g_ptr).n_groups_selected = 0
	(*g_ptr).selected_groups[*] = 0
	;
;	MSP_PPOL_Save_Group_File, Event
    ;
end
;
;------------------------------------------------------------------
pro S6_populate_meta_group_list, Event, tab_no
	;
	;	loads the meta-name listbox on the indicated tab_number
	;
	WIDGET_CONTROL, Event.top, GET_UVALUE=PTR_struct
	w_ptr = PTR_struct.PTR_wid_id
	g_ptr = PTR_struct.PTR_group
	;
	case tab_no of
		1:	wid = (*w_ptr).S6B_meta_group_listbox_wid
		2:	wid = (*w_ptr).S6C_meta_group_listbox_wid
		3:  wid = (*w_ptr).S6D_meta_group_listbox_wid
		else: print_text, Event, "ERROR - S6 meta-group listbox number not recognized."
	endcase
	;
	n_meta = (*g_ptr).n_meta_groups
	if(n_meta gt 0) then begin
		;
		text_vec = strarr(n_meta)
		(*g_ptr).S6_meta_group_queue[0] = -1
		for img = 1, n_meta do begin
			;
			case (*g_ptr).S6_meta_group_queue[img] of
				-2:	queue = '?'
				-1: queue = 'Skip'
				 0: queue = 'Done'
				 1: queue = 'Active'
				 2: queue = 'Queued'
				else: queue = '...'
			endcase
			;
			;	parse the step a bit more
			;
			step = (*g_ptr).meta_group_step[img]
			;
			if(step lt 60) then begin
				step_0 = long(step)
				step_1 = 0L
			endif else begin
				step_0 = FLOOR(step/10)
				step_1 = step - step_0 * 10
			endelse
			;
			text_vec[img-1] = STRTRIM(STRING(format='(A," Step=",I2.1,".",I1.1,"  Action= ",A)',$
				(*g_ptr).meta_group_names[img],step_0, step_1,queue),1)
		endfor
	endif else begin
		text_vec = ['','']
	endelse
	;
	WIDGET_CONTROL, wid, SET_VALUE=text_vec
	;
	(*g_ptr).n_meta_groups_selected = 0
	(*g_ptr).selected_meta_groups[*] = 0
;	MSP_PPOL_Save_Group_File, Event
    ;
end
;
;----------------------------------------------------------------
;
;pro S6_Edit_width, Event, ibox
;	;
;	;	handle insert character events for options textboxes
;	;
;	WIDGET_CONTROL, Event.top, GET_UVALUE=PTR_struct
;	w_ptr = PTR_struct.PTR_wid_id
;	;
;	;	first, fetch current pointer into text box buffer
;	;
;	nch = (*w_ptr).S6_textbox_nch[ibox]
;	;
;	case ibox of
;		0: t_wid = (*w_ptr).S6C_RA_width_wid
;		1: t_wid = (*w_ptr).S6C_Dec_width_wid
;		2: t_wid = (*w_ptr).S6C_Mag_width_wid
;	endcase
;	;
;	if(nch eq 0) then begin
;		mch = WIDGET_INFO(t_wid,/TEXT_NUMBER)
;		if(mch gt 1) then begin								; mch includes CRLF
;			WIDGET_CONTROL, t_wid, GET_VALUE=existing_text
;			mch = STRLEN(STRTRIM(existing_text[0],2))
;			if(mch gt 0) then begin
;				existing_text = STRTRIM(existing_text,2)
;				;
;				;	pack into character buffer
;				;
;				(*w_ptr).S6_textbox_buffer[ibox,*] = ''
;				;
;				for im = 0, mch-1 do begin
;					(*w_ptr).S6_textbox_buffer[ibox,im] = STRMID(existing_text, im, 1)
;				endfor
;				(*w_ptr).S6_textbox_nch[ibox] = mch
;				nch = mch
;			endif
;		endif
;	endif
;	new_name = 0
;	;
;	if(Event.type eq 0) then begin
;		;
;		;	if character not CR, put it into buffer
;		;
;		ch = Event.ch
;		if(ch ne 10B) then begin
;			WIDGET_CONTROL, t_wid, GET_VALUE=existing_text
;			(*w_ptr).S6_textbox_nch[ibox] = STRLEN(existing_text)
;			for il = 0, STRLEN(existing_text[0])-1 do (*w_ptr).S6_textbox_buffer[ibox,il] = STRMID(existing_text, il, 1)
;			WIDGET_CONTROL, t_wid, SET_TEXT_SELECT=[Event.offset,0]
;		endif else begin
;			;
;			;	was a character return - load the buffer into a single string
;			;
;			name = ''
;			for ich = 0, (*w_ptr).S6_textbox_nch[ibox]-1 do begin
;				name = name + (*w_ptr).S6_textbox_buffer[ibox,ich]
;			endfor
;			;
;			name = STRTRIM(name,2)
;			new_name = 1
;			;
;		endelse
;		;
;	endif else begin
;		if(Event.type eq 1) then begin
;			WIDGET_CONTROL, (*w_ptr).S_textbox_wid, GET_VALUE=existing_text
;			;
;			name = STRTRIM(Event.str,2)
;			length = STRLEN(name)
;			if(length gt 1) then begin
;				this_name = strarr(length)
;				for il=0, length-1 do begin
;					this_name[il] = STRMID(name,il,1)
;				endfor
;			endif else begin
;				if(length eq 0) then goto, S6_CT_end
;				;
;				this_name = strarr(1)
;				this_name[0] = name
;			endelse
;		endif else begin
;			if(Event.type eq 2) then begin
;				;
;				WIDGET_CONTROL, t_wid, GET_VALUE=existing_text
;				if(Event.length eq 0) then goto, S6_CT_end
;			endif else begin
;				print_text, Event, "Event not recognized"
;			endelse
;			new_name = 0
;		endelse
;		(*w_ptr).S6_textbox_nch[ibox] = STRLEN(existing_text)
;		for il = 0, STRLEN(existing_text[0])-1 do (*w_ptr).S6_textbox_buffer[ibox,il] = STRMID(existing_text, il, 1)
;		WIDGET_CONTROL, t_wid, SET_TEXT_SELECT=[Event.offset,0]
;	endelse
;	;
;	if(new_name eq 1) then begin
;		;
;		;	replace old value with new, but only accept good floating point value
;		;
;		CATCH, ibad
;		;
;		if(ibad ne 0) then begin
;			print_text, Event, "Bad input, try again"
;			;
;			;	clear buffer to old values
;			;
;			(*w_ptr).S6_textbox_nch[ibox] = 0
;			(*w_ptr).S6_textbox_buffer[ibox,*] = ''
;			(*w_ptr).S6_textbox_values[ibox] = 0.0
;			;
;			;	and reshow
;			;
;			S6_populate_textbox, Event, 2
;			;
;			CATCH, /CANCEL
;			;
;			goto, S6_CT_end
;		endif
;		;
;		reads, name, format='(F)', value
;		;
;		print_text, Event, "Replacing value with "+STRING(format='(F)',value)
;		;
;		(*w_ptr).S6_textbox_values[ibox] = value
;		;
;		S6_populate_textbox, Event, 2
;		;
;		;	clear buffer
;		;
;		(*w_ptr).S6_textbox_nch[ibox] = 0
;		(*w_ptr).S6_textbox_buffer[ibox,*] = ''
;		;
;		CATCH, /CANCEL
;	endif
;	;
;	S6_CT_end:
;end
;
;------------------------------------------------------------------
pro S6_Select_groups, Event, tab_no, queue_list_flag
	;
	;	one or more items selected on tab - get them and
	;	put them either on the queue (qlf = 0) or into the
	;	list for meta-group generation (qlf = 1)
	;
	WIDGET_CONTROL, Event.top, GET_UVALUE=PTR_struct
	s_ptr = PTR_struct.PTR_summary
	w_ptr = PTR_struct.PTR_wid_id
	g_ptr = PTR_struct.PTR_group
	;
	group_meta_flag = 0
	case tab_no of
		0: begin
			wid = (*w_ptr).S6A_group_listbox_wid
			group_meta_flag = 0	; group list
		   end
		1: begin
				;
				;	this tab has two windows, use the second
				;	flag to tell which one
				;
				case queue_list_flag of
					1:	begin
							; this is the first box - groups to meta
							wid = (*w_ptr).S6B_group_to_meta_group_listbox_wid
							group_meta_flag = 0
						end
					0:	begin
							; this is the meta group listbox
							wid = (*w_ptr).S6B_meta_group_listbox_wid
							group_meta_flag = 1
						end
				endcase
			end
		2: begin
			wid = (*w_ptr).S6C_meta_group_listbox_wid
			group_meta_flag = 1
		   end
		3: begin
			wid = (*w_ptr).S6D_meta_group_listbox_wid
			group_meta_flag = 1
		   end
		else: print_text, Event, "ERROR - S6 sub-tab number not recognized."
	endcase
	;
	index = WIDGET_INFO( wid, /LIST_SELECT)
	n = N_ELEMENTS(index)
	skip = 0
	if(n eq 1 and index[0] eq -1) then skip=1
	if(skip eq 0) then begin
		;
		;	check to be sure groups have step >= 5, else drop from selected
		;	list
		;
		case group_meta_flag of
			0:	begin
					;
					ind = WHERE((*g_ptr).group_step[index[0:n-1]] ge 5 and $
			    				(*g_ptr).group_step[index[0:n-1]] ne 31 and $
			    				(*g_ptr).group_step[index[0:n-1]] ne 32, icount)
					if(icount gt 0) then begin
						index = index[ind]
						if(n ne icount) then print_text, Event, "Warning - some selected groups not yet processed through Step 5. Skipping those"
						n = icount
					endif else begin
						print_text, Event, "Warning - No selected group has been processed through Step 5. Go back."
						goto, S6_SG_end
					endelse
					;
					(*g_ptr).n_groups_selected = n
					;
					; if tab=1 don't enque groups that are already parts of meta groups buffer
					;	but do allow for tab=0 (first scaling)
					;
					case tab_no of
						0: begin
							;
							(*g_ptr).selected_groups[0:n-1] = index[*]		; list of group IDs
							;
							if(n eq 1) then begin
								group = (*g_ptr).group_names[index[0]]
								print_text, Event, "Selected Group "+group+" from List"
							endif else begin
								print_text, Event, "Selected "+STRING(format='(I)',n)+" groups from list"
							endelse
						   end
						1: begin
							;
							;	check that group scaling has already been done
							;
							ind = WHERE((*g_ptr).group_step[index[0:n-1]] ge 6 and $
			    						(*g_ptr).group_step[index[0:n-1]] ne 31 and $
			    						(*g_ptr).group_step[index[0:n-1]] ne 32, icount)
							if(icount gt 0) then begin
								index = index[ind]
								if(n ne icount) then print_text, Event, "Warning - some selected groups not been group-scaled. Go back one tab"
								n = icount
							endif else begin
								print_text, Event, "Warning - No selected group has been group-scaled. Go back one tab."
								goto, S6_SG_end
							endelse
							;
							;	also check that it isn't already in a meta group
							;
							ind_good = WHERE((*g_ptr).group_meta[index[0:n-1]] le 0, count)
							;
							if(count gt 0) then begin
								(*g_ptr).selected_groups[0:count-1] = index[ind_good]		; list of group IDs
								if(count eq 1) then begin
									group = (*g_ptr).group_names[index[ind_good]]
									print_text, Event, "Selected Group "+group+" from List"
								endif else begin
									print_text, Event, "Selected "+STRING(format='(I)',count)+" groups from list"
								endelse
							endif
						   end
					endcase
					;
					;	but, the delete buffer can always store the full list
					;
					(*w_ptr).S6_delete_buffer_n = n
					(*w_ptr).S6_delete_buffer[0:n-1] = index
					;
				end
			1:  begin
					;
					;	check for step 6.1 done before doing 6.2
					;
					case tab_no of
						1:
						2: begin
							;
							;	check that meta-group creation has already been done
							;
							ind = WHERE((*g_ptr).meta_group_step[index[0:n-1]+1] ge 7, icount)	; was 60
							if(icount gt 0) then begin
								index = index[ind]
								if(n ne icount) then print_text, Event, "Warning - some selected meta-groups were not properly formed."
								n = icount
							endif else begin
								print_text, Event, "Warning - No selected meta-group were properly formed."
								goto, S6_SG_end
							endelse
						   end
						3: begin
							;
							;	check that group scaling has already been done
							;
							ind = WHERE((*g_ptr).meta_group_step[index[0:n-1]+1] ge 61 or $
									((*g_ptr).meta_group_step[index[0:n-1]+1] ge 7 and $
									(*g_ptr).meta_group_step[index[0:n-1]+1] lt 60), icount)
							if(icount gt 0) then begin
								index = index[ind]
								if(n ne icount) then print_text, Event, "Warning - some selected meta-groups have not had their groups cross-matched. Redo previous tab"
								n = icount
							endif else begin
								print_text, Event, "Warning - No selected meta-group has had its groups cross-matched. Redo previous tab"
								goto, S6_SG_end
							endelse
						   end
					endcase
					;
					(*g_ptr).n_meta_groups_selected = n
					;
					ind_good = WHERE((*g_ptr).meta_group_numbers[index[0:n-1]+1] gt 0, count)
					if(count gt 0) then begin
						(*g_ptr).selected_meta_groups[1:count] = index[ind_good]+1	; list of metagroup IDs
						if(count eq 1) then begin
							group = (*g_ptr).meta_group_names[index[ind_good]+1]
							print_text, Event, "Selected MetaGroup "+group+" from List"
						endif else begin
							print_text, Event, "Selected "+STRING(format='(I)',count)+" MetaGroups from list"
						endelse
					endif
				end
		endcase
		;
	endif else print_text, Event,"Warning - no list elements selected"
	S6_SG_end:
end
;
;-----------------------------------------------
pro S6_Add_groups, Event, tab_no, queue_list_flag
	;
	;	selected groups are added to the either a queue (qlf=0) or a list (qlf=1)
	;
	WIDGET_CONTROL, Event.top, GET_UVALUE=PTR_struct
	w_ptr = PTR_struct.PTR_wid_id
	s_ptr = PTR_struct.PTR_summary
	g_ptr = PTR_struct.PTR_group
	;
	case tab_no of
		0: begin									; add single groups to group queue - all allowed
			;
			n = (*g_ptr).n_groups_selected
			if(n gt 0) then begin
				for ig = 0, n-1 do begin
					j = (*g_ptr).selected_groups[ig]
					;
					;	set queue pointer to 2 (enqueued)
					;
					(*g_ptr).S6_group_queue[j] = 2
				endfor
			endif else print_text, Event, "Warning - no groups added to queue. Either none selected, or all Meta"
			;
			;	repaint listbox
			;
			S6_populate_group_list, Event, 0
		   end
		1: begin
				;
				;	this tab has two windows, use the second
				;	flag to tell which one
				;
				case queue_list_flag of
					1:	begin
							;
							; this is the first box - groups to meta
							;
							n = (*g_ptr).n_groups_selected
							if(n gt 0) then begin
								;
								;	and capture/fill the default meta-group name
								;
								wid = (*w_ptr).S6B_name_meta_textbox_wid
								;
								;	get the next metagroup number
								;
								if((*g_ptr).n_meta_groups le 0) then (*g_ptr).n_meta_groups = 1 else (*g_ptr).n_meta_groups++
	;							if((*g_ptr).n_meta_groups le 0) then meta_next = 1 else meta_next = (*g_ptr).n_meta_groups + 1
	   						meta_next = (*g_ptr).n_meta_groups
								;
								WIDGET_CONTROL, wid, SET_VALUE="MetaGroup_"+STRING(meta_next,format='(I2.2)')
								;
								for ig = 0, n-1 do begin
									j = (*g_ptr).selected_groups[ig]
									;
									;	set queue pointer to -3 (to meta), if not already in meta group
									;
									if((*g_ptr).group_meta[j] le 0) then begin
										(*g_ptr).S6_group_queue[j] = -3
										(*g_ptr).group_meta[j] = meta_next
										(*g_ptr).meta_group_numbers[meta_next]++    ; meta group name handled in the naming routine below
										(*g_ptr).meta_group_groups[meta_next,ig] = j
										(*g_ptr).meta_group_group_flags[meta_next,ig] = 1
									endif else print_text, Event, "Warning - Group "+(*g_ptr).group_names[j]+" already in a MetaGroup"
								endfor
							endif else print_text, Event, "Warning - No groups added to meta-group. Selection error or already meta"
							;
							;	repaint listbox
							;
;							MSP_PPOL_Save_Group_File, Event    ; to register changes
              ;
							S6_populate_group_list, Event, 1
							;
						end
					0:	begin
							print_text, Event, "ERROR - Shouldn't get here - Add Meta-Group on Tab 6B"
						end
				endcase
			end
		2: begin
			n = (*g_ptr).n_meta_groups_selected
			if(n gt 0) then begin
				(*g_ptr).S6_meta_group_queue[0] = -1
				for ig = 1, n do begin
					j = (*g_ptr).selected_meta_groups[ig]
					;
					;	set queue pointer to 2 (enqueued)
					;
					(*g_ptr).S6_meta_group_queue[j] = 2
				endfor
			endif else print_text, Event, "Warning - No meta-groups added. Selection error?"
			;
			;	repaint listbox
			;
			S6_populate_meta_group_list, Event, 2
		   end
		3: begin
			n = (*g_ptr).n_meta_groups_selected
			if(n gt 0) then begin
			    (*g_ptr).S6_meta_group_queue[0] = -1
				for ig = 1, n do begin
					j = (*g_ptr).selected_meta_groups[ig]
					;
					;	set queue pointer to 2 (enqueued)
					;
					if(j eq 0) then begin
						(*g_ptr).S6_meta_group_queue[j] = -1
						print_text, Event, "Warning - problem adding meta-group to queue"
					endif else begin
						(*g_ptr).S6_meta_group_queue[j] = 2
					endelse
				endfor
			endif else print_text, Event, "Warning - No meta-groups added. Selection error?"
			;
			;	repaint listbox
			;
			S6_populate_meta_group_list, Event, 3
		   end
		else: print_text, Event, "ERROR - S6 sub-tab number not recognized on add-to-list command."
	endcase
	;
	;  just for safety's sake, clear out some key meta group buffers - DPC 20140523
	;
	(*g_ptr).meta_group_groups[0,*] = 0
	(*g_ptr).meta_group_group_flags[0,*] = -1
	;
;	MSP_PPOL_Save_Group_File, Event
    ;
end
;-----------------------------------------------
pro S6_Remove_groups, Event, tab_no, queue_list_flag
	;
	;	selected groups are removed from queues or lists
	;
	WIDGET_CONTROL, Event.top, GET_UVALUE=PTR_struct
	w_ptr = PTR_struct.PTR_wid_id
	s_ptr = PTR_struct.PTR_summary
	g_ptr = PTR_struct.PTR_group
	;
	case tab_no of
		0: begin									; remove single groups from group queue
    			;
    			n = (*w_ptr).S6_delete_buffer_n
    			if(n gt 0) then begin
    				for ig = 0, n-1 do begin
    					j = (*w_ptr).S6_delete_buffer[ig]
    					;
    					;	set queue pointers to -1 (skip)
    					;
    					(*g_ptr).S6_group_queue[j] = -1
    				endfor
    			endif else print_text, Event, "Warning - No groups removed from queue. Selection error, or all meta"
      			;
      			;	repaint listbox
      			;
      		S6_populate_group_list, Event, 0
		   end
		1: begin
				;
				;	this tab has two windows, use the second
				;	flag to tell which one
				;
				case queue_list_flag of
					1:	begin
							; this is the first box - groups to meta 
							;   DPC 20140523 - I don't follow how this should work - why delete a group from
							;                  a just created metagroup? Probably this option is never exercised
							;
;							n = (*g_ptr).n_groups_selected
							;
							n = (*w_ptr).S6_delete_buffer_n
							;
							if(n gt 0) then begin
								;
								;	remove from (next) meta-group if there, skip if not
								;
								if((*g_ptr).n_meta_groups le 0) then meta_next = 1 else meta_next = (*g_ptr).n_meta_groups++
								;
								for ig = 0, n-1 do begin
									;j = (*g_ptr).selected_groups[ig]
									j = (*w_ptr).S6_delete_buffer[ig]
									;
									;	set queue pointer to -1 (skip)
									;
									if((*g_ptr).group_meta[j] eq meta_next) then begin
										(*g_ptr).S6_group_queue[j] = -1
										(*g_ptr).group_meta[j] = 0
										n_meta = (*g_ptr).meta_group_numbers[meta_next]
										if(n_meta ne 0) then begin
											ind = WHERE((*g_ptr).meta_group_groups[meta_next,0:n_meta-1] eq j,count)
											if(count ne 0) then begin
												for ic = 0, count-1 do begin
													indj = ind[ic]
													;
													max_j = N_ELEMENTS(REFORM((*g_ptr).meta_group_groups[meta_next,*]))
													;
													(*g_ptr).meta_group_groups[meta_next,indj:max_j-2]  = (*g_ptr).meta_group_groups[meta_next,indj+1:max_j-1]
													(*g_ptr).meta_group_groups[meta_next,max_j-1] = -1
													(*g_ptr).meta_group_group_flags[meta_next,indj:max_j-2] = (*g_ptr).meta_group_group_flags[meta_next,indj+1:max_j-1]
													(*g_ptr).meta_group_group_flags[meta_next,max_j-1] = -1
													; S6_group_queue needs update too???
													(*g_ptr).meta_group_numbers[meta_next]--
													;
												endfor
											endif
										endif
									endif else print_text, Event, "Warning - Group "+(*g_ptr).group_names[j]+" not on list yet."
								endfor
							endif else print_text, Event, "Warning - no groups removed from new meta group. Selection error?"
							;
							;	repaint listbox
							;
;							MSP_PPOL_Save_Group_File, Event
    ;
							S6_populate_group_list, Event, 1
							;
						end
					0:	begin
							n = (*g_ptr).n_meta_groups_selected
							;
							if(n gt 0) then begin
								;
								;
								for img = 0, n-1 do begin
									j = (*g_ptr).selected_meta_groups[img]
									ngroups = (*g_ptr).meta_group_numbers[j]
									if(ngroups ge 1) then begin
										group_list = (*g_ptr).meta_group_groups[j,0:ngroups-1]
										(*g_ptr).S6_group_queue[group_list] = -2
										(*g_ptr).group_meta[group_list] = 0
									endif
									(*g_ptr).S6_meta_group_queue[j] = -2
									;
									;	push down
									;
									n_meta_max = N_ELEMENTS((*g_ptr).meta_group_numbers) - 1
									;
									(*g_ptr).S6_meta_group_queue[j:n_meta_max-1] = (*g_ptr).S6_meta_group_queue[j+1:n_meta_max]
									(*g_ptr).S6_meta_group_queue[n_meta_max] = -2
									;
									(*g_ptr).meta_group_numbers[j:n_meta_max-1] = (*g_ptr).meta_group_numbers[j+1:n_meta_max]
									(*g_ptr).meta_group_numbers[n_meta_max] = 0
									;
									(*g_ptr).meta_group_groups[j:n_meta_max-1,*] = (*g_ptr).meta_group_groups[j+1:n_meta_max,*]
									(*g_ptr).meta_group_groups[n_meta_max,*] = -1
									;
									(*g_ptr).meta_group_group_flags[j:n_meta_max-1,*] = (*g_ptr).meta_group_group_flags[j+1:n_meta_max,*]
									(*g_ptr).meta_group_group_flags[n_meta_max,*] = 0
									;
									(*g_ptr).meta_group_names[j:n_meta_max-1] = (*g_ptr).meta_group_names[j+1:n_meta_max]
									(*g_ptr).meta_group_names[n_meta_max] = ''
									;
									(*g_ptr).meta_group_step[j:n_meta_max-1] = (*g_ptr).meta_group_step[j+1:n_meta_max]
									(*g_ptr).meta_group_step[n_meta_max] = 0
									;
									(*g_ptr).n_meta_groups--
									;
									;	update meta_group pointers in groups, since we have killed off some meta group
									;
									ind = WHERE((*g_ptr).group_meta[*] gt j, count)
									if(count gt 0) then (*g_ptr).group_meta[ind]--
									;
;;									jnd = WHERE((*g_ptr).selected_meta_groups[1:n] gt j,jcount)
;;									if(jcount gt 0) then (*g_ptr).selected_meta_groups[jnd]--
									;
								endfor
								print_text, Event, "Removing Meta-Group from list"
							;
							endif else print_text, Event, "Warning - No meta-groups removed. Selection error?"
							;
							;	repaint listbox
							;
;							MSP_PPOL_Save_Group_File, Event
    ;
							S6_populate_meta_group_list, Event, 1
							S6_populate_group_list, Event, 1
						end
				endcase
			end
		2: begin
			n = (*g_ptr).n_meta_groups_selected
			if(n gt 0) then begin
				for ig = 1, n do begin
					j = (*g_ptr).selected_meta_groups[ig]
					;
					;	set queue pointer to -1 (skip)
					;
					(*g_ptr).S6_meta_group_queue[j] = -1
				endfor
			endif else print_text, Event, "Warning - No meta-groups removed from queue. Selection error?"
			;
			;	repaint listbox
			;
			S6_populate_meta_group_list, Event, 2
		   end
		3: begin
			n = (*g_ptr).n_meta_groups_selected
			if(n gt 0) then begin
				for ig = 1, n do begin
					j = (*g_ptr).selected_meta_groups[ig]
					;
					;	set queue pointer to -1 (skip)
					;
					(*g_ptr).S6_meta_group_queue[j] = -1
				endfor
			endif else print_text, Event, "Warning - No meta-groups removed from queue. Selection error?"
			;
			;	repaint listbox
			;
			S6_populate_meta_group_list, Event, 3
		   end
		else: print_text, Event, "ERROR - S6 sub-tab number not recognized on add-to-list command."
	endcase
  MSP_PPOL_Save_Group_File, Event
    ; 
end
;
;-----------------------------------------------------
pro S6_Name_meta_group, Event
	;
	;	handle insert character events for making meta-group name
	;
	WIDGET_CONTROL, Event.top, GET_UVALUE=PTR_struct
	w_ptr = PTR_struct.PTR_wid_id
	g_ptr = PTR_struct.PTR_group
	;
	;	first, fetch current pointer into text box buffer
	;
	nch = (*w_ptr).S6_meta_name_nch
	wid = (*w_ptr).S6B_name_meta_textbox_wid
	;
	;	if it is zero, check whether something is already there
	;
	if(nch eq 0) then begin
		mch = WIDGET_INFO(wid,/TEXT_NUMBER)
		if(mch gt 1) then begin
			WIDGET_CONTROL, wid, GET_VALUE=existing_text
			mch = STRLEN(existing_text[0])
			;
			;	pack into character buffer
			;
			(*w_ptr).S6_meta_name_buffer[*] = ''
			;
			for im = 0, mch-1 do begin
				(*w_ptr).S6_meta_name_buffer[im] = STRMID(existing_text, im, 1)
			endfor
			(*w_ptr).S6_meta_name_nch = mch
			nch = mch
		endif
	endif
	;
	new_name = 0
	;
	if(Event.type eq 0) then begin
		;
		;	if character not CR, put it into buffer
		;
		ch = Event.ch
		if(ch ne 10B) then begin
			WIDGET_CONTROL, wid, GET_VALUE=existing_text
			(*w_ptr).S6_meta_name_nch = STRLEN(existing_text)
			for il = 0, STRLEN(existing_text[0])-1 do (*w_ptr).S6_meta_name_buffer[il] = STRMID(existing_text, il, 1)
			WIDGET_CONTROL, wid, SET_TEXT_SELECT=[Event.offset,0]
		endif else begin
			;
			;	was a character return
			;
			name = ''
			for ich = 0, (*w_ptr).S6_meta_name_nch-1 do begin
				name = name + (*w_ptr).S6_meta_name_buffer[ich]
			endfor
			;
			name = STRTRIM(name,2)
			;
			;	new name available - put it into current buffer and issue a relist command
			;
			new_name = 1
			;
		endelse
		;
		;print_text, Event, "Insert Character Event - Character = "+STRING(format='(a)',Event.ch)
	endif else begin
		if(Event.type eq 1) then begin
			WIDGET_CONTROL, wid, GET_VALUE=existing_text
			;
			name = STRTRIM(Event.str,2)
			length = STRLEN(name)
			if(length gt 1) then begin
				this_name = strarr(length)
				for il=0, length-1 do begin
					this_name[il] = STRMID(name,il,1)
				endfor
			endif else begin
				if(length eq 0) then goto, S6NMG_end
				;
				this_name = strarr(1)
				this_name[0] = name
			endelse
		endif else begin
			if(Event.type eq 2) then begin
				;
				WIDGET_CONTROL, wid, GET_VALUE=existing_text
				if(Event.length eq 0) then goto, S6NMG_end
			endif else begin
				print_text, Event, "Event not recognized"
			endelse
			new_name = 0
		endelse
		(*w_ptr).S6_meta_name_nch = STRLEN(existing_text)
		for il = 0, STRLEN(existing_text[0])-1 do (*w_ptr).S6_meta_name_buffer[il] = STRMID(existing_text, il, 1)
		WIDGET_CONTROL, wid, SET_TEXT_SELECT=[Event.offset,0]
	endelse
	;
	if(new_name eq 1) then begin
		;
		print_text, Event, "Setting Meta-Group Name to "+name
		;
		;	bump meta group counter
		;
;		if((*g_ptr).n_meta_groups le 0) then (*g_ptr).n_meta_groups = 1 else (*g_ptr).n_meta_groups++ ; move to add meta group DPC 20140523
		(*g_ptr).meta_group_names[(*g_ptr).n_meta_groups] = name
		(*g_ptr).meta_group_step[(*g_ptr).n_meta_groups] = 60		; since scaling not yet performed
		;
		(*g_ptr).S6_meta_group_queue[(*g_ptr).n_meta_groups] = -2
		(*g_ptr).S6_meta_group_queue[0] = -1						; just in case
		(*g_ptr).meta_group_names[0] = "blank"
		(*g_ptr).meta_group_step[0] = 0
		(*g_ptr).meta_group_numbers[0] = 0
		;
		;	clear buffer
		;
		(*w_ptr).S6_meta_name_nch = 0
		(*w_ptr).S6_meta_name_buffer[*] = ''
		WIDGET_CONTROL, (*w_ptr).S6B_name_meta_textbox_wid, SET_VALUE=''
		;
		S6_populate_group_list, Event, 1
		S6_populate_meta_group_list, Event, 1
		;
;		MSP_PPOL_Save_Group_File, Event
	endif
	;
	S6NMG_end:
;	MSP_PPOL_Save_Group_File, Event
  ;
end
;----------------------------------------------------------------
;
pro S6_Start_matching, Event
	WIDGET_CONTROL, Event.top, GET_UVALUE=PTR_struct
	w_ptr = PTR_struct.PTR_wid_id
	g_ptr = PTR_struct.PTR_group
	s_ptr = PTR_struct.PTR_summary
	;
	;	for each queued meta-group, match
	;	reference images in each group to establish relative
	;	group to group scale factors
	;
	;	(must be run before starting scaling step)
	;
	LED_meta_wid = (*w_ptr).S6C_LED0_meta_group_wid
	LED_group_wid = (*w_ptr).S6C_LED1_group_wid
	;
	this_queue = (*g_ptr).S6_meta_group_queue[*]
	these_names = (*g_ptr).meta_group_names[*]
	;
	;	how many active items on the queue?
	;
	ind_queue = WHERE(this_queue[0:(*g_ptr).n_meta_groups] eq 2,count)
	if(count le 0) then begin
		; if none, quit
		print_text, Event, "WARNING - no items in queue to process."
		goto, S6_SM_end
	endif
	;
	print_text, Event, "Found "+STRING(format='(I)',count)+" groups in the queue. Processing starting"
	;
	;	Clear LED to red with the number of metagroups to process
	;
	nLED = 25
	LED_scale = float(count) / float(nLED)
	if(LED_scale le 1.0) then LED_scale = 1.0
	;
	WIDGET_CONTROL, LED_meta_wid, SET_UVALUE=(nLED < count)
	meta_colors = strarr(nLED < count)
	meta_colors[*] = "red"
	;
	S6_LED_sensitize, Event, 2, 0, 1
	;
	;	clear the number of groups progress bar to red, also
	;
	WIDGET_CONTROL, LED_group_wid, SET_UVALUE=(10)
	group_colors = strarr(10)
	group_colors[*] = "red"
	S6_LED_sensitize, Event, 2, 1, 1
	;
	;	for each of the enqueued meta-groups:
	;
	for ig = 0, count-1 do begin
		;
		g_ind = ind_queue[ig]
		group_name = these_names[g_ind]
		;
		print_text, Event, "Starting Matching for Meta-Group = "+group_name
		;
		;
		;if(count gt 1) then print, "count > 1;  ig, g_ind, ind_queue = ",ig,g_ind, ind_queue
		;
		;	change the list box queue list to active for this meta-group
		;
		(*g_ptr).S6_meta_group_queue[g_ind] = 1
		S6_populate_meta_group_list, Event, 2
		;
		;	position list to show this meta_group
		;
		if( g_ind gt 10) then begin
			WIDGET_CONTROL, (*w_ptr).S6C_meta_group_listbox_wid, SET_LIST_TOP= ( g_ind - 6)
		endif
		;
		;	change the metagroup LED bar to blue
		;
		this_LED = ROUND(float(ig) / LED_scale) & this_LED = 0 > ((nLED-1) < this_LED)
		meta_colors[this_LED] = "blue"
		WCT_LED_stack, LED_meta_wid, meta_colors
		;
		output_dir = (*s_ptr).analysis_dir + 'S6_Scaling' + PATH_SEP()
		new_group_name = replace_underscores(group_name)
		output_path = output_dir + new_group_name + '_meta_match.dat'
		;
		meta_group_number = g_ind
		;
		S6_meta_match, Event, meta_group_number, group_name, output_path, status
		;
		;	pause to allow plot windows to be examined
		;
		wait, 1
		;
		if(status eq 0) then begin
			;
			;	meta-group is done
			;
			;	change color of meta-group LED to green
			;
			this_LED = ROUND(float(ig) / LED_scale) & this_LED = 0 > ((nLED-1) < this_LED)
			meta_colors[this_LED] = "green"
			WCT_LED_stack, LED_meta_wid, meta_colors
			;
			;	clear queue tag for this meta-group, update step status value,
			; 			and rewrite listbox
			;
			(*g_ptr).S6_meta_group_queue[g_ind] = 0
			(*g_ptr).meta_group_step[g_ind] = 61			; the 61 means 6.1
			S6_populate_meta_group_list, Event, 2
			if( g_ind gt 10) then begin
				WIDGET_CONTROL, (*w_ptr).S6C_meta_group_listbox_wid, SET_LIST_TOP= ( g_ind - 6)
			endif
			;
			;
		endif
;		MSP_PPOL_Save_Group_File, Event
	endfor
	;
	;	all groups done.
	;
	print_text, Event, "All Queued Groups have had Scale Factors Computed"
	;
	S6_SM_end:
	MSP_PPOL_Save_Group_File, Event
end
;
;------------------------------------------------------
pro S6_Start_scaling, Event, tab_no
	;
	;	Begin scaling analysis for single groups (tab_no = 0)
	;	or for meta-groups (tab_no = 3)
	;
	;	for meta-groups, must perform relative scaling also,
	;	using matching of first images in each constituent group
	;
	WIDGET_CONTROL, Event.top, GET_UVALUE=PTR_struct
	w_ptr = PTR_struct.PTR_wid_id
	s_ptr = PTR_struct.PTR_summary
	g_ptr = PTR_struct.PTR_group
	;
	case tab_no of
		0: begin
			LED_wid = (*w_ptr).S6A_LED0_group_wid
			this_queue = (*g_ptr).S6_group_queue[*]
			these_names = (*g_ptr).group_names[*]
			n_groups = (*g_ptr).n_groups
		   end
		1: print_text, Event, "ERROR - should not get here - error in StartScaling tab 6B"
		2: print_text, Event, "ERROR - should not get here - error in StartScaling tab 6C"
		3: begin
			LED_wid = (*w_ptr).S6D_LED0_meta_group_wid
			this_queue = (*g_ptr).S6_meta_group_queue[*]
			these_names = (*g_ptr).meta_group_names[*]
			n_groups = (*g_ptr).n_meta_groups+1
		   end
	endcase
	;
	;	how many active items on the queue?
	;
	ind_queue = WHERE(this_queue[0:n_groups-1] eq 2,count)
	if(count le 0) then begin
		; if none, quit
		print_text, Event, "WARNING - no items in queue to process."
		goto, S6_SS_end
	endif
	;
	print_text, Event, "Found "+STRING(format='(I)',count)+" groups in the queue. Processing starting"
	;
	;	Clear LED to red with the number of groups to process
	;
	nLED = 10
	LED_scale = float(count) / float(nLED)
	if(LED_scale le 1.0) then LED_scale = 1.0
	;
	WIDGET_CONTROL, LED_wid, SET_UVALUE=(nLED < count)
	group_colors = strarr(nLED < count)
	group_colors[*] = "red"
	;
	S6_LED_sensitize, Event, tab_no, 0, 1
	;
	;	for each of the enqueued groups:
	;
	for ig = 0, count-1 do begin
		;
		g_ind = ind_queue[ig]
		group_name = these_names[g_ind]
		case tab_no of
			0: print_text, Event, "Starting Scaling for Group = "+group_name
			3: print_text, Event, "Starting Scaling for Meta-Group = "+group_name
		endcase
		;
		;	change the list box queue list to active for this group
		;
		case tab_no of
			0: begin
				(*g_ptr).S6_group_queue[g_ind] = 1
				S6_populate_group_list, Event, 0
				;
				if( g_ind gt 10) then begin
					WIDGET_CONTROL, (*w_ptr).S6A_group_listbox_wid, SET_LIST_TOP= ( g_ind - 6)
				endif
			   end
			3: begin
				(*g_ptr).S6_meta_group_queue[g_ind] = 1
				S6_populate_meta_group_list, Event, 3
				if( g_ind gt 10) then begin
					WIDGET_CONTROL, (*w_ptr).S6D_meta_group_listbox_wid, SET_LIST_TOP= ( g_ind - 6)
				endif
			   end
		endcase
		;
		;	change the LED2 bar to blue
		;
		this_LED = ROUND(float(ig) / LED_scale) & this_LED = 0 > ((nLED-1) < this_LED)
		group_colors[this_LED] = "blue"
		WCT_LED_stack, LED_wid, group_colors
		;
		case tab_no of
			0: begin
				summary_dir = (*s_ptr).analysis_dir + 'S5_Star_Matching' + PATH_SEP()
				new_group_name = replace_underscores(group_name)
				summary_path = summary_dir + new_group_name + '_match.dat'
				;
				;	clear textboxes at start
				;
				(*w_ptr).S6A_group_name = new_group_name
				(*w_ptr).S6A_field_pol_value = 0.0d0
				(*w_ptr).S6A_field_pol_sigma = 0.0d0
				(*w_ptr).S6A_sky_noise_value = 0.0d0
				(*w_ptr).S6A_aper_no_value = 0
				(*w_ptr).S6A_scaling_amplitude = 0.0d0
				;
				fetch_use_flag_count, Event, group_name, nbad
				;
				(*w_ptr).S6A_bad_image_count = nbad
				;
				;	write to the textboxes
				;
				S6_populate_textbox, Event, 0
				;
				;	start correction calculations
				;
				S6_ap_correction_factors, Event, new_group_name, summary_path
				;
			   end
			3: begin
				output_dir = (*s_ptr).analysis_dir + 'S6_Scaling' + PATH_SEP()
				new_group_name = replace_underscores(group_name)
				output_path = output_dir + new_group_name + '_meta_scale.dat'
				;
				meta_group_number = g_ind
				S6_meta_correction_factors, Event, meta_group_number, new_group_name, output_path
			   end
		endcase
		;
		;	pause to allow plot window to be examined
		;
		wait, 1
		;
		;	group is done
		;
		;	change color of group LED to green
		;
		this_LED = ROUND(float(ig) / LED_scale) & this_LED = 0 > ((nLED-1) < this_LED)
		group_colors[this_LED] = "green"
		WCT_LED_stack, LED_wid, group_colors
		;
		;	clear queue tag for this group, update step status value,
		; 			and rewrite listbox
		;
		case tab_no of
			0: begin
				(*g_ptr).S6_group_queue[g_ind] = 0
				(*g_ptr).group_step[g_ind] = 6
				S6_populate_group_list, Event, 0
				if( g_ind gt 10) then begin
					WIDGET_CONTROL, (*w_ptr).S6A_group_listbox_wid, SET_LIST_TOP= ( g_ind - 6)
				endif
			   end
			3: begin
				(*g_ptr).S6_meta_group_queue[g_ind] = 0
				(*g_ptr).meta_group_step[g_ind] = 62
				S6_populate_meta_group_list, Event, 3
				if( g_ind gt 10) then begin
					WIDGET_CONTROL, (*w_ptr).S6D_meta_group_listbox_wid, SET_LIST_TOP= ( g_ind - 6)
				endif
			   end
		endcase
;		MSP_PPOL_Save_Group_File, Event
		;
	endfor
	;
	;	all groups done.
	;
	print_text, Event, "All Queued Groups have had Scale Factors Computed"
	;
	S6_SS_end:
	MSP_PPOL_Save_Group_File, Event
end
