;
;	Step 7 Event Handler Routines - Image coadding
;
pro S7_Init, Event
	;
	;	initialize S7 stuff when tabbing onto Step 7
	;
	WIDGET_CONTROL, Event.top, GET_UVALUE=PTR_struct
	w_ptr = PTR_struct.PTR_wid_id
	g_ptr = PTR_struct.PTR_group
	;
	h_wid = (*w_ptr).S7_history_textbox_wid
	SAll_populate_history, Event, h_wid, 7
	;
	;	populate the group, metagroup tables after cleansing
	;		(setting "Active" and "Queued" flags to "?")
	;
	sub_tab = WIDGET_INFO((*w_ptr).S7_tab_base_wid,/TAB_CURRENT)
	case sub_tab of
		0:	begin
				n_groups = (*g_ptr).n_groups
				if(n_groups gt 0) then begin
					ind = WHERE((*g_ptr).S7_group_queue[0:n_groups-1] ge 1,count)
					if(count gt 0) then (*g_ptr).S7_group_queue[ind] = -2
				endif
				S7A_populate_group_list, Event
			end
		1:	begin
				n_meta_groups = (*g_ptr).n_meta_groups
				if(n_meta_groups gt 0) then begin
					ind = WHERE((*g_ptr).S7_meta_group_queue[1:n_meta_groups] ge 1,count)
					if(count gt 0) then (*g_ptr).S7_meta_group_queue[ind+1] = -2
				endif
				S7B_populate_meta_group_list, Event
			end
		else: print_text, Event, "ERROR - illegal subtab on Step 7"
	endcase
	;
	;	clear LEDs to red
	;
	S7_LED_sensitize, Event, 1, 0
	S7_LED_sensitize, Event, 2, 0
	;
	;	initialize options buttons
	;
	F17 = (*w_ptr).S7_camera_mode
;	S7_Camera, Event, F17
	;
	;
;	(*w_ptr).S7_astrometry_mode = 1 - (*w_ptr).S7_astrometry_mode
;	S7_Astrometry_option, Event
	;
	;	load options for both options tabs
	;(*w_ptr).S7_options_mode_and_tab = 0
	WIDGET_CONTROL, (*w_ptr).S7_options_tab_base_wid, SET_TAB_CURRENT=0	; the star field option
	;
	;	Star Field Options:
	;
	(*w_ptr).S7_stars_mode = 1 - (*w_ptr).S7_stars_mode
	S7_Toggle_Star_Mode, Event
	;
	;		and sub-options
	;
	(*w_ptr).S7_save_supersky_mode = 1 - (*w_ptr).S7_save_supersky_mode
	S7_Toggle_Save_Supersky, Event
	;
	(*w_ptr).S7_ss_star_sky_flag = 1 - (*w_ptr).S7_ss_star_sky_flag
  	S7_Toggle_SS_Star_Mode, Event
	;
	(*w_ptr).S7_smooth_supersky_mode = 1 - (*w_ptr).S7_smooth_supersky_mode
	S7_Toggle_Smooth_Supersky, Event
	;
	(*w_ptr).S7_flatten_images_pre_flag = 1 - (*w_ptr).S7_flatten_images_pre_flag
	S7_Toggle_Flatten_Images_Pre, Event
	;
	(*w_ptr).S7_flatten_images_post_flag = 1 - (*w_ptr).S7_flatten_images_post_flag
	S7_Toggle_Flatten_Images_Post, Event
	;
	;	load options for extended modes
	;
	WIDGET_CONTROL, (*w_ptr).S7_options_tab_base_wid, SET_TAB_CURRENT=1	; the extended object option
	;
	;	the Extended Object Options
	;
	(*w_ptr).S7_extended_mode = 1 - (*w_ptr).S7_extended_mode
	S7_Toggle_Extended_Mode, Event
	;
	;	set the quad choices to 'all'
	;
	(*w_ptr).S7_fit_options_mode = 0
	WIDGET_CONTROL, (*w_ptr).S7_fit_options_droplist_wid, SET_DROPLIST_SELECT = (*w_ptr).S7_fit_options_mode
	;
	;	and general options
	;
	(*w_ptr).S7_override_scaling_mode = 1 - (*w_ptr).S7_override_scaling_mode
	S7_Scaling_option, Event
	;
;	(*w_ptr).S7_fix_bad_pixels_flag = 1 - (*w_ptr).S7_fix_bad_pixels_flag
;	S7_Toggle_Fix_Bad_Pixels, Event
	;
	(*w_ptr).S7_star_sky_flag = 1 - (*w_ptr).S7_star_sky_flag
	S7_Toggle_Star_Sky_Mask, Event
	;
	(*w_ptr).S7_mask_row513_mode = 1 - (*w_ptr).S7_mask_row513_mode
	S7_Toggle_Mask_R513, Event
	;
	(*w_ptr).S7_astrom_override_flag = 1 - (*w_ptr).S7_astrom_override_flag
	S7_Toggle_Astrom_Override, Event
	;
	(*w_ptr).S7_USE_0_override_flag = 1 - (*w_ptr).S7_USE_0_override_flag
  S7_Toggle_USE_0_Override, Event
  ;
  S7_Set_Sub_Div_Mode, Event, 1-(*w_ptr).S7_subtract_ss_flag
	;
	center_in_textbox, (*w_ptr).S7_box_width_textbox_wid, STRTRIM(STRING( (*w_ptr).S7_box_width_value, $
					format='(I3.1)'),2)
	;
	;	next, put the options tab where it belongs
	;
	WIDGET_CONTROL, (*w_ptr).S7_options_tab_base_wid, SET_TAB_CURRENT=(*w_ptr).S7_options_mode_and_tab
	;
	if((*w_ptr).S7_astrometry_mode) then begin
		F17 = (*w_ptr).S7_camera_mode
		S7_Camera, Event, F17
		;
		(*w_ptr).S7_2mass_mode = 1 - (*w_ptr).S7_2mass_mode
		S7_Save_2mass_option, Event
	endif
	;
	(*w_ptr).S7_comments_mode = 1 - (*w_ptr).S7_comments_mode
	S7_Comments_option, Event
	;
	(*w_ptr).S7_skip_RC_flag = 1 - (*w_ptr).S7_skip_RC_flag
	S7_Toggle_Skip_RC_Flattening_Mode, Event
	;
	(*w_ptr).S7_comments_nch = 0
	(*w_ptr).S7_comments_buffer[*] = ''
	WIDGET_CONTROL, (*w_ptr).S7_comments_textbox_wid, SET_VALUE=''
	;
end
;
;-------------------------------------------------
pro S7_Tab_Handler, Event
	WIDGET_CONTROL, Event.top, GET_UVALUE=PTR_struct
	w_ptr = PTR_struct.PTR_wid_id
	g_ptr = PTR_struct.PTR_group
	;
	h_wid = (*w_ptr).S7_history_textbox_wid
	SAll_populate_history, Event, h_wid, 7
	;
	;	what to do when arriving at a tab
	;
	(*w_ptr).S7_current_tab = Event.tab
	;
	case Event.tab of
		0: begin
				print_text, Event, "Tab Change to Step 7A"
				n_groups = (*g_ptr).n_groups
				if(n_groups gt 0) then begin
					ind = WHERE((*g_ptr).S7_group_queue[0:n_groups-1] ge 1,count)
					if(count gt 0) then (*g_ptr).S7_group_queue[ind] = -2
				endif
				S7A_populate_group_list, Event
				;
				;	maybe clear LED and draw window? or repaint?
				;
			end
		1:  begin
				print_text, Event, "Tab Change to Step 7B"
				n_meta_groups = (*g_ptr).n_meta_groups
				if(n_meta_groups gt 0) then begin
					ind = WHERE((*g_ptr).S7_meta_group_queue[1:n_meta_groups] ge 1,count)
					if(count gt 0) then (*g_ptr).S7_meta_group_queue[ind+1] = -2
				endif
				S7B_populate_meta_group_list, Event
			end
		else: begin print_text, Event, "Tab not recognized - try again"
			end
	endcase
end
;
;-------------------------------------------------
pro S7_Options_Tab_Handler, Event
	WIDGET_CONTROL, Event.top, GET_UVALUE=PTR_struct
	w_ptr = PTR_struct.PTR_wid_id
	g_ptr = PTR_struct.PTR_group
	;
	h_wid = (*w_ptr).S7_history_textbox_wid
	SAll_populate_history, Event, h_wid, 7
	;
	;	what to do when arriving at a tab
	;
	(*w_ptr).S7_options_mode_and_tab = Event.tab
	;
	case Event.tab of
		0: begin
				print_text, Event, "Tab Change to Star Field Background Processing"
				;
				(*w_ptr).S7_options_mode_and_tab = 0
				(*w_ptr).S7_flatten_images_pre_flag = 1 - (*w_ptr).S7_flatten_images_pre_flag
				S7_Toggle_Flatten_Images_Pre, Event
				(*w_ptr).S7_flatten_images_post_flag = 1 - (*w_ptr).S7_flatten_images_post_flag
				S7_Toggle_Flatten_Images_Post, Event
				;
			end
		1:  begin
				print_text, Event, "Tab Change to Extended Object Background Processing"
				;
				(*w_ptr).S7_options_mode_and_tab = 1
				;
				;	clear pre-, post- flattening
				;
;				(*w_ptr).S7_flatten_images_pre_flag = 1
;				S7_Toggle_Flatten_Images_Pre, Event
;				(*w_ptr).S7_flatten_images_post_flag = 1
;				S7_Toggle_Flatten_Images_Post, Event
			end
		else: begin print_text, Event, "Tab not recognized - try again"
			end
	endcase
end

;----------------------------------------------
pro S7_Toggle_Extended_Mode, Event
	WIDGET_CONTROL, Event.top, GET_UVALUE=PTR_struct
	w_ptr = PTR_struct.PTR_wid_id
	;
	(*w_ptr).S7_extended_mode = 1 - (*w_ptr).S7_extended_mode
	WIDGET_CONTROL, (*w_ptr).S7_low_order_wid, SET_BUTTON=(1 - (*w_ptr).S7_extended_mode)
	WIDGET_CONTROL, (*w_ptr).S7_use_step11_points_checkbox_wid, SET_BUTTON=(*w_ptr).S7_extended_mode
	;
	case (*w_ptr).S7_extended_mode of
		0: print_text, Event, "Selecting Constant (Opt. A) Background Removal for Extended Objects"
		1: print_text, Event, "Using Step 11 Grid Points (Opt. B) Background Removal for Extended Ojbects "
	endcase
end

;----------------------------------------------
pro S7_Toggle_Star_Mode, Event
	WIDGET_CONTROL, Event.top, GET_UVALUE=PTR_struct
	w_ptr = PTR_struct.PTR_wid_id
	;
	(*w_ptr).S7_stars_mode = 1 - (*w_ptr).S7_stars_mode
	WIDGET_CONTROL, (*w_ptr).S7_apply_illumination_button_wid, SET_BUTTON=(*w_ptr).S7_stars_mode
	WIDGET_CONTROL, (*w_ptr).S7_supersky_option_wid, SET_BUTTON=(1 - (*w_ptr).S7_stars_mode )
	;
	case (*w_ptr).S7_stars_mode of
		0: begin
				print_text, Event, "Selecting Super-Sky Backgrounds (Opt. A) for Star Field Processing"
				;
			end
		1: print_text, Event, "Selecting Background Modeling (Opt. B) for Star Field Processing"
	;
	endcase
end
;
;----------------------------------------------
pro S7_Toggle_USE_0_Override, Event
  WIDGET_CONTROL, Event.top, GET_UVALUE=PTR_struct
  w_ptr = PTR_struct.PTR_wid_id
  ;
  (*w_ptr).S7_USE_0_override_flag = 1 - (*w_ptr).S7_USE_0_override_flag
  WIDGET_CONTROL, (*w_ptr).S7_USE_0_override_checkbox_wid, SET_BUTTON=(*w_ptr).S7_USE_0_override_flag
  ;
  case (*w_ptr).S7_USE_0_override_flag of
    1: begin
        print_text, Event, "Selecting Override of USE=0 flag respecting for bad images"
        ;
      end
    0: print_text, Event, "Selecting Normal respecting of USE=0 flag for bad images"
  ;
  endcase
end
;
;----------------------------------------------
pro S7_Set_Sub_Div_Mode, Event, this_mode
  WIDGET_CONTROL, Event.top, GET_UVALUE=PTR_struct
  w_ptr = PTR_struct.PTR_wid_id
  ;
  ; checks or toggles the subtract/divide radio buttons for supersky processing
  ;
  if((*w_ptr).S7_subtract_ss_flag eq 1 and this_mode eq 0) then begin
    ;
    ; no change - set radio buttons and report
    ;
    (*w_ptr).S7_divide_ss_flag = 0L
    goto, report_ss
  endif
  ;
  if((*w_ptr).S7_divide_ss_flag eq 1 and this_mode eq 1) then begin
    ;
    ; also no change - set radio buttons and report
    ;
    (*w_ptr).S7_subtract_ss_flag = 0L
    goto, report_ss
  endif
  ;
  if((*w_ptr).S7_subtract_ss_flag eq 1 and this_mode eq 1) then begin
    ;
    (*w_ptr).S7_subtract_ss_flag = 0L
    (*w_ptr).S7_divide_ss_flag = 1L
    goto, report_ss
  endif
  ;
  if((*w_ptr).S7_divide_ss_flag eq 1 and this_mode eq 0) then begin
    ;
    (*w_ptr).S7_subtract_ss_flag = 1L
    (*w_ptr).S7_divide_ss_flag = 0L
  endif
  ;
  report_ss:
  WIDGET_CONTROL, (*w_ptr).S7_subtract_ss_radio_wid, SET_BUTTON=(*w_ptr).S7_subtract_ss_flag
  WIDGET_CONTROL, (*w_ptr).S7_divide_ss_radio_wid, SET_BUTTON=(*w_ptr).S7_divide_ss_flag
  ;
  case (*w_ptr).S7_subtract_ss_flag of
    1: begin
        print_text, Event, "Will Subtract Superskies from Images (Img - SS)"
        ;
      end
    0: print_text, Event, "Will Divide Images by Superskies (Img / SS)"
  ;
  endcase
end
;
;-------------------------------------------------
pro S7_Droplist_Select, Event
	;
	;	get the S11 sub-mode from the droplist index
	;
	WIDGET_CONTROL, Event.top, GET_UVALUE=PTR_struct
	w_ptr = PTR_struct.PTR_wid_id
	;
	index = WIDGET_INFO( (*w_ptr).S7_fit_options_droplist_wid, /DROPLIST_SELECT)
	(*w_ptr).S7_fit_options_mode = index
	case (*w_ptr).s7_fit_options_mode of
		0: print_text, Event, 'Will use a 4 Quads of the array simultaneously in fitting backgrounds'
		1: print_text, Event, 'Will use each of the 4 Quads of the array independently in fitting backgrounds'
		2: print_text, Event, 'Will use the top and bottom array halves independently in fitting backgrounds'
	endcase
end
;
;-----------------------------------------------
;pro S7_Camera, Event, F17
;	WIDGET_CONTROL, Event.top, GET_UVALUE=PTR_struct
;	w_ptr = PTR_struct.PTR_wid_id
;	;
;	;	if astrometry mode not selected, then clear
;	;	radio buttons and exit
;	;
;;	if((*w_ptr).S7_astrometry_mode) then begin
;		WIDGET_CONTROL, (*w_ptr).S7_F5_wid, SET_BUTTON=(1-F17)
;		WIDGET_CONTROL, (*w_ptr).S7_F17_wid, SET_BUTTON=F17
;		(*w_ptr).S7_camera_mode = F17
;		;
;		case F17 of
;			0: print_text, Event, "Changing camera mode to F5"
;			1: print_text, Event, "Changing camera mode to F17"
;		endcase
;;	endif else begin
;;		WIDGET_CONTROL, (*w_ptr).S7_F5_wid, SET_BUTTON=0
;;		WIDGET_CONTROL, (*w_ptr).S7_F17_wid, SET_BUTTON=0
;;	endelse
;	;
;end
;
;------------------------------------------------
;pro S7_Astrometry_option, Event
;	WIDGET_CONTROL, Event.top, GET_UVALUE=PTR_struct
;	w_ptr = PTR_struct.PTR_wid_id
;	;
;	(*w_ptr).S7_astrometry_mode = 1 - (*w_ptr).S7_astrometry_mode
;	WIDGET_CONTROL, (*w_ptr).S7_astrometry_option_wid, SET_BUTTON=(*w_ptr).S7_astrometry_mode
;	;
;	case (*w_ptr).S7_astrometry_mode of
;		0: begin
;			print_text, Event, "Turning OFF option for post coadding astrometry"
;			WIDGET_CONTROL, (*w_ptr).S7_F5_wid, SET_BUTTON=0
;			WIDGET_CONTROL, (*w_ptr).S7_F17_wid, SET_BUTTON=0
;			;
;			WIDGET_CONTROL, (*w_ptr).S7_2mass_option_wid, SET_BUTTON=0
;		   end
;		1: begin
;			print_text, Event, "Turning ON option for post coadding astrometry"
;			;
;			F17 = (*w_ptr).S7_camera_mode
;			WIDGET_CONTROL, (*w_ptr).S7_F5_wid, SET_BUTTON=(1-F17)
;			WIDGET_CONTROL, (*w_ptr).S7_F17_wid, SET_BUTTON=F17
;			;
;			WIDGET_CONTROL, (*w_ptr).S7_2mass_option_wid, SET_BUTTON=(*w_ptr).S7_2mass_mode
;		  end
;	;
;	endcase
;end
;
;----------------------------------------------
pro S7_Toggle_Astrom_Override, Event
	WIDGET_CONTROL, Event.top, GET_UVALUE=PTR_struct
	w_ptr = PTR_struct.PTR_wid_id
	;
	;	force the 2MASS mag window to move, even if there aren't lots 'o stars
	;	(added to allow April's simulations to proceed) 20110819 DPC
	;
	(*w_ptr).S7_astrom_override_flag = 1 - (*w_ptr).S7_astrom_override_flag
	WIDGET_CONTROL, (*w_ptr).S7_astrom_override_checkbox_wid, SET_BUTTON=(*w_ptr).S7_astrom_override_flag
	;
	case (*w_ptr).S7_astrom_override_flag of
		0: print_text, Event, "Turning OFF option for forcing 2MASS windowing motion w/o lots of stars"
		1: print_text, Event, "Turning ON option for forcing 2MASS windowing motion w/o lots of stars"
	;
	endcase
end
;----------------------------------------------
pro S7_Toggle_Skip_RC_Flattening_Mode, Event
	WIDGET_CONTROL, Event.top, GET_UVALUE=PTR_struct
	w_ptr = PTR_struct.PTR_wid_id
	;
	;	allow (or not) the Row/Column flattening to proceed (or not)
	;	Jordan needs to turn this off for his PEGS galaxies
	;
	(*w_ptr).S7_skip_RC_flag = 1 - (*w_ptr).S7_skip_RC_flag
	WIDGET_CONTROL, (*w_ptr).S7_skip_RC_checkbox_wid, SET_BUTTON=(*w_ptr).S7_skip_RC_flag
	;
	case (*w_ptr).S7_skip_RC_flag of
		0: print_text, Event, "Turning ON option for performing Row and Column flattening"
		1: print_text, Event, "Turning OFF option for performing Row and Column flattening"
	;
	endcase
end
;----------------------------------------------
pro S7_Toggle_Star_Sky_Mask, Event
	WIDGET_CONTROL, Event.top, GET_UVALUE=PTR_struct
	w_ptr = PTR_struct.PTR_wid_id
	;
	;	Normally, the coadder identifies stars as different from sky before doing MFM
	;	if the flag = 1 (default) this continue. If the flag is reset (0), then this
	;	test is turned off, which has the effect of removing stars if they don't match
	;	up - a useful effect for tracking moving objects like comets.
	;
	(*w_ptr).S7_star_sky_flag = 1 - (*w_ptr).S7_star_sky_flag
	WIDGET_CONTROL, (*w_ptr).S7_star_sky_checkbox_wid, SET_BUTTON=(*w_ptr).S7_star_sky_flag
	;
	case (*w_ptr).S7_star_sky_flag of
		0: print_text, Event, "Turning OFF option for distinguishing stars from sky for images being coadded"
		1: print_text, Event, "Turning ON option for distinguishing stars from sky for images being coadded"
	;
	endcase
end
;----------------------------------------------
pro S7_Toggle_SS_Star_Mode, Event
  WIDGET_CONTROL, Event.top, GET_UVALUE=PTR_struct
  w_ptr = PTR_struct.PTR_wid_id
  ;
  ; for selecting whether to remove stars or not when computing superskies - better in H if yes,
  ; better in K if no
  ;
  (*w_ptr).S7_ss_star_sky_flag = 1 - (*w_ptr).S7_ss_star_sky_flag
  WIDGET_CONTROL, (*w_ptr).S7_ss_star_sky_checkbox_wid, SET_BUTTON=(*w_ptr).S7_ss_star_sky_flag
  ;
  case (*w_ptr).S7_ss_star_sky_flag of
    0: print_text, Event, "Turning OFF option for distinguishing stars from sky when building supersky images"
    1: print_text, Event, "Turning ON option for distinguishing stars from sky when building supersky images"
  ;
  endcase
end
;----------------------------------------------
pro S7_Toggle_Mask_R513, Event
	WIDGET_CONTROL, Event.top, GET_UVALUE=PTR_struct
	w_ptr = PTR_struct.PTR_wid_id
	;
	;	row 513 is often problematic, this option allows masking it before coadding
	;
	(*w_ptr).S7_mask_row513_mode = 1 - (*w_ptr).S7_mask_row513_mode
	WIDGET_CONTROL, (*w_ptr).S7_mask_row513_checkbox_wid, SET_BUTTON=(*w_ptr).S7_mask_row513_mode
	;
	case (*w_ptr).S7_mask_row513_mode of
		0: print_text, Event, "Turning OFF option for masking out row 513 in images being coadded"
		1: print_text, Event, "Turning ON option for masking out row 513 in images being coadded"
	;
	endcase
end
;----------------------------------------------
pro S7_Toggle_Save_Supersky, Event
	WIDGET_CONTROL, Event.top, GET_UVALUE=PTR_struct
	w_ptr = PTR_struct.PTR_wid_id
	;
	(*w_ptr).S7_save_supersky_mode = 1 - (*w_ptr).S7_save_supersky_mode
	WIDGET_CONTROL, (*w_ptr).S7_save_supersky_checkbox_wid, SET_BUTTON=(*w_ptr).S7_save_supersky_mode
	;
	case (*w_ptr).S7_save_supersky_mode of
		0: print_text, Event, "Turning OFF option for saving Super-Sky images to disk"
		1: print_text, Event, "Turning ON option for saving Super-Sky images to disk"
	;
	endcase
end
;----------------------------------------------
pro S7_Toggle_Smooth_Supersky, Event
	WIDGET_CONTROL, Event.top, GET_UVALUE=PTR_struct
	w_ptr = PTR_struct.PTR_wid_id
	;
	(*w_ptr).S7_smooth_supersky_mode = 1 - (*w_ptr).S7_smooth_supersky_mode
	WIDGET_CONTROL, (*w_ptr).S7_smooth_supersky_checkbox_wid, SET_BUTTON=(*w_ptr).S7_smooth_supersky_mode
	;
	case (*w_ptr).S7_smooth_supersky_mode of
		0: begin
				print_text, Event, "Turning OFF option for smoothing Super-Sky images"
				WIDGET_CONTROL, (*w_ptr).S7_box_width_textbox_wid, SENSITIVE=0
		   end
		1: begin
				print_text, Event, "Turning ON option for smoothing Super-Sky images"
				WIDGET_CONTROL, (*w_ptr).S7_box_width_textbox_wid, SENSITIVE=1
		   end
	;
	endcase
end
;----------------------------------------------
pro S7_Edit_Box_Width, Event
	;
	;	manage edits to the boxcar size textbox
	;
	WIDGET_CONTROL, Event.top, GET_UVALUE=PTR_struct
	w_ptr = PTR_struct.PTR_wid_id
	;
	wid = (*w_ptr).S7_box_width_textbox_wid
	value = (*w_ptr).S7_box_width_value
	;
	S7_Modify_textbox, Event, wid, value, update_textbox
	;
	(*w_ptr).S7_box_width_value = value
	str = STRTRIM(STRING(value,format='(I4.1)'),2)
	;
	if(update_textbox eq 1) then begin
		center_in_textbox, wid, str
		print_text, Event, "Changed Smoothing Boxcar Width to "+str+" pixels"
	endif
end
;
;----------------------------------------------------------------
pro S7_Modify_textbox, Event, wid, value, update_textbox
	;
	;	handle insert character events for P scale override value
	;
	WIDGET_CONTROL, Event.top, GET_UVALUE=PTR_struct
	w_ptr = PTR_struct.PTR_wid_id
	;
	update_textbox = 0
	;
	;	ignore everything except a CR, then read textbox buffer
	;
	if(Event.type eq 0) then begin
		if(Event.ch eq 10B) then begin
			existing_text = ''
			WIDGET_CONTROL, wid, GET_VALUE=existing_text
			mch = STRLEN(existing_text[0])
			if(mch gt 0) then begin
				type = SIZE(value, /TYPE)
				if(type eq 2 or type eq 3) then begin
					reads, existing_text[0], format='(i)',value
					update_textbox = 1
				endif else begin
					if(mch ge 3) then reads, existing_text[0], format='(F)', value
					update_textbox = 1
				endelse
				;
			endif
		endif
	endif
end

;----------------------------------------------
pro S7_Toggle_Flatten_Images_Pre, Event
	WIDGET_CONTROL, Event.top, GET_UVALUE=PTR_struct
	w_ptr = PTR_struct.PTR_wid_id
	;
	;	overridden by extended+constant mode
	;
;	if( ((*w_ptr).S7_options_mode_and_tab eq 1) and $
;	    ((*w_ptr).S7_extended_mode eq 0)) then begin
;	    print_text, Event, 'Cannot use Flatten-Pre status in Extended+Constant Mode'
;	    ;
;	    ;	clear pre-, post- flattening
;		;
;		(*w_ptr).S7_flatten_images_pre_flag = 0
;		(*w_ptr).S7_flatten_images_post_flag = 0
;	endif else begin
		(*w_ptr).S7_flatten_images_pre_flag = 1 - (*w_ptr).S7_flatten_images_pre_flag
		WIDGET_CONTROL, (*w_ptr).S7_flatten_images_pre_button_wid, SET_BUTTON=(*w_ptr).S7_flatten_images_pre_flag
		;
		case (*w_ptr).S7_flatten_images_pre_flag of
			0: print_text, Event, "Turning OFF option for flattening images before coadding"
			1: print_text, Event, "Turning ON option for flattening images before coadding"
		;
		endcase
;	endelse
end
;
;----------------------------------------------
pro S7_Toggle_Flatten_Images_Post, Event
	WIDGET_CONTROL, Event.top, GET_UVALUE=PTR_struct
	w_ptr = PTR_struct.PTR_wid_id
	;
	;	overridden by extended+constant mode
	;
;	if( ((*w_ptr).S7_options_mode_and_tab eq 1) and $
;	    ((*w_ptr).S7_extended_mode eq 0)) then begin
;	    print_text, Event, 'Cannot use Flatten-Post status in Extended+Constant Mode'
;	    ;
;	    ;	clear pre-, post- flattening
;		;
;		(*w_ptr).S7_flatten_images_pre_flag = 0
;		(*w_ptr).S7_flatten_images_post_flag = 0
;	endif else begin
;		;
		(*w_ptr).S7_flatten_images_post_flag = 1 - (*w_ptr).S7_flatten_images_post_flag
		WIDGET_CONTROL, (*w_ptr).S7_flatten_images_post_button_wid, SET_BUTTON=(*w_ptr).S7_flatten_images_post_flag
		;
		case (*w_ptr).S7_flatten_images_post_flag of
			0: print_text, Event, "Turning OFF option for flattening images after coadding"
			1: print_text, Event, "Turning ON option for flattening images after coadding"
		;
		endcase
;	endelse
end
;
;----------------------------------------------
;pro S7_Toggle_Fix_Bad_Pixels, Event
;	WIDGET_CONTROL, Event.top, GET_UVALUE=PTR_struct
;	w_ptr = PTR_struct.PTR_wid_id
;	;
;	(*w_ptr).S7_fix_bad_pixels_flag = 1 - (*w_ptr).S7_fix_bad_pixels_flag
;	WIDGET_CONTROL, (*w_ptr).S7_fix_bad_pixels_button_wid, SET_BUTTON=(*w_ptr).S7_fix_bad_pixels_flag
;	;
;	case (*w_ptr).S7_fix_bad_pixels_flag of
;		0: print_text, Event, "Turning OFF option for fixing bad pixels remaining after coadding"
;		1: print_text, Event, "Turning ON option for fixing bad pixels remaining after coadding"
;	;
;	endcase
;end
;
;-----------------------------------------------
pro S7_Scaling_option, Event
	WIDGET_CONTROL, Event.top, GET_UVALUE=PTR_struct
	w_ptr = PTR_struct.PTR_wid_id
	;
	(*w_ptr).S7_override_scaling_mode = 1 - (*w_ptr).S7_override_scaling_mode
	WIDGET_CONTROL, (*w_ptr).S7_override_option_wid, SET_BUTTON=(*w_ptr).S7_override_scaling_mode
	;
	case (*w_ptr).S7_override_scaling_mode of
		0: begin
			print_text, Event, "Turning OFF option for overriding Step 6 scaling"
			WIDGET_CONTROL, (*w_ptr).S7_override_option_wid, SET_BUTTON=0
		   end
		1: begin
			print_text, Event, "Turning ON option for overriding Step 6 scaling"
			;
			WIDGET_CONTROL, (*w_ptr).S7_override_option_wid, SET_BUTTON=1
		  end
	;
	endcase
end
;
;-----------------------------------------------
pro S7_Save_2mass_option, Event
	WIDGET_CONTROL, Event.top, GET_UVALUE=PTR_struct
	w_ptr = PTR_struct.PTR_wid_id
	;
	;	if astrometry mode not selected, then clear
	;	radio buttons and exit
	;
	if((*w_ptr).S7_astrometry_mode) then begin
	;
		(*w_ptr).S7_2mass_mode = 1 - (*w_ptr).S7_2mass_mode
		WIDGET_CONTROL, (*w_ptr).S7_2mass_option_wid, SET_BUTTON=(*w_ptr).S7_2mass_mode
		;
		case (*w_ptr).S7_2mass_mode of
			0: print_text, Event, "Turning OFF option for saving 2MASS astrometry files"
			1: print_text, Event, "Turning ON option for saving 2MASS astrometry files"
		endcase
	endif else begin
		WIDGET_CONTROL, (*w_ptr).S7_2mass_option_wid, SET_BUTTON=0
	endelse
end						;
;
;----------------------------------------------
pro S7_Comments_option, Event
	;
	;	turns on FITS comments
	;
	WIDGET_CONTROL, Event.top, GET_UVALUE=PTR_struct
	w_ptr = PTR_struct.PTR_wid_id
	;
	(*w_ptr).S7_comments_mode = 1 - (*w_ptr).S7_comments_mode
	WIDGET_CONTROL, (*w_ptr).S7_add_comments_option_wid, SET_BUTTON=(*w_ptr).S7_comments_mode
	;
	case (*w_ptr).S7_comments_mode of
		0: begin
			print_text, Event, "Turning OFF option for saving comments to FITS files"
			(*w_ptr).S7_comments_nch = 0
			(*w_ptr).S7_comments_buffer[*] = ''
			WIDGET_CONTROL, (*w_ptr).S7_comments_textbox_wid, SET_VALUE=''
			WIDGET_CONTROL, (*w_ptr).S7_comments_textbox_wid, SENSITIVE=0
		   end
		1: begin
			print_text, Event, "Turning ON option for saving comments to FITS files"
			WIDGET_CONTROL, (*w_ptr).S7_comments_textbox_wid, SENSITIVE=1
		   end
	endcase
end
;
;-----------------------------------------------
pro S7_Comments_text, Event
	;
	;	handle insert character events for FITS comments
	;		- text is always valid, CRs ignored --
	;
	WIDGET_CONTROL, Event.top, GET_UVALUE=PTR_struct
	w_ptr = PTR_struct.PTR_wid_id
	g_ptr = PTR_struct.PTR_group
	;
	;	first, fetch current pointer into text box buffer
	;
	nch = (*w_ptr).S7_comments_nch
	wid = (*w_ptr).S7_comments_textbox_wid
	;
	;	if it is zero, check whether something is already there
	;
	if(nch eq 0) then begin
		mch = WIDGET_INFO(wid,/TEXT_NUMBER)
		if(mch gt 1) then begin				; have to skip first character entered...
			WIDGET_CONTROL, wid, GET_VALUE=existing_text
			mch = STRLEN(existing_text[0])
			;
			;	pack into character buffer
			;
			(*w_ptr).S7_comments_buffer[*] = ''
			;
			for im = 0, mch-1 do begin
				(*w_ptr).S7_comments_buffer[im] = STRMID(existing_text, im, 1)
			endfor
			(*w_ptr).S7_comments_nch = mch
			nch = mch
		endif
	endif
	;
	if(Event.type eq 0) then begin
		;
		;	if character not CR, put it into buffer
		;
		ch = Event.ch
		if(ch ne 10B) then begin
			WIDGET_CONTROL, wid, GET_VALUE=existing_text
			(*w_ptr).S7_comments_nch = STRLEN(existing_text)
			for il = 0, STRLEN(existing_text[0])-1 do (*w_ptr).S7_comments_buffer[il] = STRMID(existing_text, il, 1)
			WIDGET_CONTROL, wid, SET_TEXT_SELECT=[Event.offset,0]
		endif else begin
			;
			;	was a character return, echo text to print_text
			name = ''
			for ich = 0, (*w_ptr).S7_comments_nch-1 do begin
				name = name + (*w_ptr).S7_comments_buffer[ich]
			endfor
			;
			name = STRTRIM(name,2)
			;
			(*w_ptr).S7_comments_string = name
			;
			print_text, Event, "Setting FITS Comments to -- "+name
		endelse
	endif else begin
		if(Event.type eq 1) then begin
			WIDGET_CONTROL, wid, GET_VALUE=existing_text
			;
			name = STRTRIM(Event.str,2)
			length = STRLEN(name)
			if(length gt 1) then begin
				this_name = strarr(length)
				for il=0, length-1 do begin
					this_name[il] = STRMID(name,il,1)
				endfor
			endif else begin
				if(length eq 0) then goto, S7CT_end
				;
				this_name = strarr(1)
				this_name[0] = name
			endelse
		endif else begin
			if(Event.type eq 2) then begin
				WIDGET_CONTROL, wid, GET_VALUE=existing_text
				if(Event.length eq 0) then goto, S7CT_end
			endif else begin
				print_text, Event, "Event not recognized"
			endelse
		endelse
		(*w_ptr).S7_comments_nch = STRLEN(existing_text)
		for il = 0, STRLEN(existing_text[0])-1 do (*w_ptr).S7_comments_buffer[il] = STRMID(existing_text, il, 1)
		WIDGET_CONTROL, wid, SET_TEXT_SELECT=[Event.offset,0]
	endelse
	;
	S7CT_end:
end
;-----------------------------------------------
pro S7_Select_Groups, Event, tab_no
	;
	;	select groups or metagroups
	;
	WIDGET_CONTROL, Event.top, GET_UVALUE=PTR_struct
	s_ptr = PTR_struct.PTR_summary
	w_ptr = PTR_struct.PTR_wid_id
	g_ptr = PTR_struct.PTR_group
	;
	case tab_no of
		0:	begin
				wid = (*w_ptr).S7A_group_listbox_wid
			end
		1:  begin
				wid = (*w_ptr).S7B_meta_group_listbox_wid
			end
	endcase
	;
	index = WIDGET_INFO( wid, /LIST_SELECT)
    n = N_ELEMENTS(index)
    skip = 0
	if(n eq 1 and index[0] eq -1) then skip=1
	if(skip eq 0) then begin
		;
		case tab_no of
			0:	begin
					ind = WHERE((*g_ptr).group_step[index] ge 6 and $
			    				(*g_ptr).group_step[index] ne 31 and $
			    				(*g_ptr).group_step[index] ne 32, count)
					if(count gt 0) then begin
						index = index[ind]
						if(n ne count) then print_text, Event, "Warning - some groups not processed through Step 6 - skipping these"
						n = count
					endif else begin
						print_text, Event, "Warning - no groups processed through Step 6. Go back."
						goto, S7_SG_end
					endelse
					;
					;	next, don't enqueue groups in meta-groups
					;
					ind = WHERE((*g_ptr).group_meta[index] le 0, count)
					if(count gt 0) then begin
						index = index[ind]
						if(n ne count) then print_text, Event, "Warning - can not select groups in meta-groups on this tab. Use Meta-Group tab."
						n = count
					endif else begin
						print_text, Event, "Warning - groups selected are all in meta-groups. Use the Meta-Group tab to process."
						goto, S7_SG_end
					endelse
					;
					(*g_ptr).n_groups_selected = n
					(*g_ptr).selected_groups[0:n-1] = index[*]
					if(n eq 1) then begin
						group = (*g_ptr).group_names[index[0]]
						print_text, Event, "Selected Group "+group+" from Group List"
					endif else begin
						print_text, Event, "Selected "+STRING(format='(I)',n)+" groups from list"
					endelse
				end
			1:	begin
					(*g_ptr).n_meta_groups_selected = n
					(*g_ptr).selected_meta_groups[1:n] = index[*]+1
					if(n eq 1) then begin
						group = (*g_ptr).meta_group_names[index[0]+1]
						print_text, Event, "Selected Group "+group+" from Group List"
					endif else begin
						print_text, Event, "Selected "+STRING(format='(I)',n)+" groups from list"
					endelse
				end
		endcase
	   ;
	endif else print_text, Event, "Warning - no groups selected"
	S7_SG_end:
end
;
;-----------------------------------------------
pro S7_Add_groups, Event, tab_no
	;
	;	selected groups are added to the group or metagroup queues
	;
	WIDGET_CONTROL, Event.top, GET_UVALUE=PTR_struct
	w_ptr = PTR_struct.PTR_wid_id
	s_ptr = PTR_struct.PTR_summary
	g_ptr = PTR_struct.PTR_group
	;
	case tab_no of
		0:	begin
				;
				;	how many selected?
				;
				n = (*g_ptr).n_groups_selected
				;
				if(n gt 0) then begin
					for ig = 0, n-1 do begin
						j = (*g_ptr).selected_groups[ig]
						;
						;	set queue pointer to 2 (enqueued)
						;
						(*g_ptr).S7_group_queue[j] = 2
					endfor
				endif
				;
				;	reload listbox
				;
				S7A_populate_group_list, Event
				;
				;	clear selections
				;
				(*g_ptr).n_groups_selected = 0
				if(n gt 0) then (*g_ptr).selected_groups[0:n-1] = 0
			end
		1: 	begin
				;
				n = (*g_ptr).n_meta_groups_selected
				;
				if(n gt 0) then begin
					for ig = 1, n do begin
						j = (*g_ptr).selected_meta_groups[ig]
						;
						;	set queue pointer to 2 (enqueued)
						;
						(*g_ptr).S7_meta_group_queue[j] = 2
					endfor
				endif
				;
				;	reload listbox
				;
				S7B_populate_meta_group_list, Event
				;
				(*g_ptr).n_meta_groups_selected = 0
				if(n gt 0) then (*g_ptr).selected_meta_groups[1:n] = 0
			end
	endcase

end
;-----------------------------------------------
pro S7_Remove_groups, Event, tab_no
	;
	;	selected groups are removed (skipped) indicated queue
	;
	WIDGET_CONTROL, Event.top, GET_UVALUE=PTR_struct
	w_ptr = PTR_struct.PTR_wid_id
	s_ptr = PTR_struct.PTR_summary
	g_ptr = PTR_struct.PTR_group
	;
	case tab_no of
		0:	begin
				;
				;	how many selected?
				;
				n = (*g_ptr).n_groups_selected
				;
				if(n gt 0) then begin
					for ig = 0, n-1 do begin
						j = (*g_ptr).selected_groups[ig]
						;
						(*g_ptr).S7_group_queue[j] = -1
					endfor
				endif
				;
				;	reload listbox
				;
				S7A_populate_group_list, Event
				;
				;	clear selections
				;
				(*g_ptr).n_groups_selected = 0
				if(n gt 0) then (*g_ptr).selected_groups[0:n-1] = 0
			end
		1:	begin
				;
				;	how many selected?
				;
				n = (*g_ptr).n_meta_groups_selected
				;
				if(n gt 0) then begin
					for ig = 1, n do begin
						j = (*g_ptr).selected_meta_groups[ig]
						;
						(*g_ptr).S7_meta_group_queue[j] = -1
					endfor
				endif
				;
				S7B_populate_meta_group_list, Event
				;
				(*g_ptr).n_meta_groups_selected = 0
				if(n gt 0) then (*g_ptr).selected_meta_groups[1:n] = 0
			end
	endcase
end
;
;-----------------------------------------------
pro S7_LED_sensitize, Event, S7_LED_number, sense
	;
	;	initializes LED stacks
	;
	WIDGET_CONTROL, Event.top, GET_UVALUE=PTR_struct
	w_ptr = PTR_struct.PTR_wid_id
	;
	if(S7_LED_number eq 1) then begin
		wid = (*w_ptr).S7_LED1_images_wid
	endif else begin
		wid = (*w_ptr).S7_LED2_groups_wid
	endelse
	;
	WIDGET_CONTROL, wid, SENSITIVE=sense
	;
	;	set all colors to red upon sensitization
	;
	WIDGET_CONTROL, wid, GET_UVALUE=nLED
	;
	n_ele = N_ELEMENTS(nLED)
	if(n_ele eq 0) then nLED = 25
	if(nLED eq 0) then nLED = 25
	WIDGET_CONTROL, wid, SET_UVALUE=nLED
	colors = strarr(nLED)
	if(sense eq 1) then colors[*] = "red" else colors[*] = "gray"
	WCT_LED_stack, wid, colors
end
;
;-----------------------------------------------
pro S7A_populate_group_list, Event
	;
	;	lists current groups and step status by name on the listbox
	;
	WIDGET_CONTROL, Event.top, GET_UVALUE=PTR_struct
	w_ptr = PTR_struct.PTR_wid_id
	s_ptr = PTR_struct.PTR_summary
	g_ptr = PTR_struct.PTR_group
	;
	n_groups = (*g_ptr).n_groups
	if(n_groups gt 0) then begin
		;
		;	load group name,step and meta status, and queue status
		;
		text_vec = strarr(n_groups)
		for ig = 0, n_groups-1 do begin
			if((*g_ptr).group_step[ig] lt 6) then (*g_ptr).S7_group_queue[ig] = -2
			i_queue = (*g_ptr).S7_group_queue[ig]
			;
			case i_queue of
				-3: queue = "to Meta"
				-2:	queue = '?'
				-1: queue = 'Skip'
				 0: queue = 'Done'
				 1: queue = 'Active'
				 2: queue = 'Queued'
				else: queue = '...'
			endcase
			;
			grp_step = (*g_ptr).group_step[ig]
			if((grp_step ge 30 and grp_step le 40) or $
			   (grp_step ge 60 and grp_step le 70) or $
			   (grp_step ge 110 and grp_step le 119)) then begin
			   step_0 = FLOOR(grp_step / 10)
			   step_1 = grp_step - 10 * step_0
			   text_vec[ig] = STRTRIM(STRING(format='(A," Step=",I2.1,".",I1.1,", Meta=",I2.1,", Action= ",A)',$
					(*g_ptr).group_names[ig],step_0,step_1,(*g_ptr).group_meta[ig],queue),1)

			endif else begin
				text_vec[ig] = STRTRIM(STRING(format='(A," Step=",I2.1,", Meta=",I2.1,", Action= ",A)',$
					(*g_ptr).group_names[ig],(*g_ptr).group_step[ig],(*g_ptr).group_meta[ig],queue),1)
			endelse
			;
			;text_vec[ig] = STRTRIM(STRING(format='(A," Step=",I2.1,", Meta=",I2.1," Action= ",A)',$
			;		(*g_ptr).group_names[ig],(*g_ptr).group_step[ig],(*g_ptr).group_meta[ig],queue),1)
		endfor
	endif else begin
		text_vec = ['','']
	endelse
	;
	WIDGET_CONTROL, (*w_ptr).S7A_group_listbox_wid, SET_VALUE=text_vec
	;
	(*g_ptr).n_groups_selected = 0
	(*g_ptr).selected_groups[*] = 0
end
;
;------------------------------------------------------------------
pro S7B_populate_meta_group_list, Event
	;
	;	loads the meta-name listbox on the indicated tab_number
	;
	WIDGET_CONTROL, Event.top, GET_UVALUE=PTR_struct
	w_ptr = PTR_struct.PTR_wid_id
	g_ptr = PTR_struct.PTR_group
	;
	wid = (*w_ptr).S7B_meta_group_listbox_wid
	;
	n_meta = (*g_ptr).n_meta_groups
	if(n_meta gt 0) then begin
		;
		text_vec = strarr(n_meta)
		for img = 1, n_meta do begin
			;
			(*g_ptr).S7_meta_group_queue[0] = -1
			if((*g_ptr).meta_group_step[img] lt 6) then (*g_ptr).S7_meta_group_queue[img] = -2
			case (*g_ptr).S7_meta_group_queue[img] of
				-2:	queue = '?'
				-1: queue = 'Skip'
				 0: queue = 'Done'
				 1: queue = 'Active'
				 2: queue = 'Queued'
				else: queue = '...'
			endcase
			;
			text_vec[img-1] = STRTRIM(STRING(format='(A," Step=",I2.1," Action= ",A)',$
				(*g_ptr).meta_group_names[img],(*g_ptr).meta_group_step[img],queue),1)
		endfor
	endif else begin
		text_vec = ['','']
	endelse
	;
	WIDGET_CONTROL, wid, SET_VALUE=text_vec
	;
	(*g_ptr).n_meta_groups_selected = 0
	(*g_ptr).selected_meta_groups[*] = 0
end
;------------------------------------------------------
pro S7_Start_coadding, Event, meta_flag
	;
	;	Begin image coadding of enqueued requests
	;
	WIDGET_CONTROL, Event.top, GET_UVALUE=PTR_struct
	w_ptr = PTR_struct.PTR_wid_id
	s_ptr = PTR_struct.PTR_summary
	g_ptr = PTR_struct.PTR_group
	;
	override_scale_flag = (*w_ptr).S7_override_scaling_mode
	;
	LED1_wid = (*w_ptr).S7_LED1_images_wid
	LED2_wid = (*w_ptr).S7_LED2_groups_wid
	;
	case meta_flag of
		0:	begin
				this_queue = (*g_ptr).S7_group_queue[0:(*g_ptr).n_groups-1]
				these_names = (*g_ptr).group_names[0:(*g_ptr).n_groups-1]
				;
				;	how many active items on the queue?
				;
				ind_queue = WHERE(this_queue[0:(*g_ptr).n_groups-1] eq 2,count)
				if(count le 0) then begin
					; if none, quit
					print_text, Event, "WARNING - no items in queue to process."
					goto, S7_SC_end
				endif
			end
		1:  begin
				this_queue = (*g_ptr).S7_meta_group_queue[1:(*g_ptr).n_meta_groups]
				these_names = (*g_ptr).meta_group_names[1:(*g_ptr).n_meta_groups]
				ind_queue = WHERE(this_queue[0:(*g_ptr).n_meta_groups-1] eq 2,count)
				if(count le 0) then begin
					; if none, quit
					print_text, Event, "WARNING - no items in meta queue to process."
					goto, S7_SC_end
				endif
			end
	endcase
	;
	print_text, Event, "Found "+STRING(format='(I)',count)+" groups in the queue. Processing starting"
	;
	;	Clear LED2 to red with the number of groups to process
	;
	WIDGET_CONTROL, LED2_wid, SET_UVALUE=count
	group_colors = strarr(count)
	group_colors[*] = "red"
	S7_LED_sensitize, Event, 2, 1
	;
	;	for each of the enqueued groups:
	;
	for ig = 0, count-1 do begin
		;
		g_ind = ind_queue[ig]
		group_name = these_names[g_ind]

		case meta_flag of
			0: begin
				print_text, Event, "Starting Coadding for Group = "+group_name
				(*g_ptr).S7_group_queue[g_ind] = 1
				S7A_populate_group_list, Event
				if( g_ind gt 10) then begin
					WIDGET_CONTROL, (*w_ptr).S7A_group_listbox_wid, SET_LIST_TOP= ( g_ind - 6)
				endif
			   end
			1: begin
				print_text, Event, "Starting Coadding for Meta-Group = "+group_name
				(*g_ptr).S7_meta_group_queue[g_ind+1] = 1
				S7B_populate_meta_group_list, Event
				if( g_ind gt 10) then begin
					WIDGET_CONTROL, (*w_ptr).S7B_meta_group_listbox_wid, SET_LIST_TOP= ( g_ind - 6)
				endif
			   end
		endcase
		;
		;	change the LED2 bar to blue
		;
		group_colors[ig] = "blue"
		WCT_LED_stack, LED2_wid, group_colors
		;
		case meta_flag of
			0:	begin
					S7_group_coadding, Event, g_ind, group_name, LED1_wid, status
					print_text, Event, "Finished Coadding for Group = "+group_name
				end
			1:	begin
					S7_meta_group_coadding, Event, g_ind, group_name, LED1_wid, status
					print_text, Event, "Finished Coadding for Meta-Group = "+group_name
				end
		endcase
		;
		wait, 1
		;
		;	evaluate completion status: 0=OK, -1=bad
		;
		case status of
			0: begin
				;
				;	change color of group LED to green
				;
				group_colors[ig] = "green"
				WCT_LED_stack, LED2_wid, group_colors
				;
				;	clear queue tag for this group and rewrite listbox
				;
				case meta_flag of
					0:	begin
							(*g_ptr).S7_group_queue[g_ind] = 0
							;
							;	and update step status value for this group
							;
							(*g_ptr).group_step[g_ind] = 7
							S7A_populate_group_list, Event
							if( g_ind gt 10) then begin
								WIDGET_CONTROL, (*w_ptr).S7A_group_listbox_wid, SET_LIST_TOP= ( g_ind - 6)
							endif
						end
					1:  begin
							(*g_ptr).S7_meta_group_queue[g_ind+1] = 0
							;
							;	and update step status value for this group
							;
							(*g_ptr).meta_group_step[g_ind+1] = 7
							S7B_populate_meta_group_list, Event
							if( g_ind gt 10) then begin
								WIDGET_CONTROL, (*w_ptr).S7B_meta_group_listbox_wid, SET_LIST_TOP= ( g_ind - 6)
							endif
						end
				endcase
			  end
			  ;
		  -1: begin
		  		;
				;	change color of group LED to yellow
				;
				group_colors[ig] = "yellow"
				WCT_LED_stack, LED2_wid, group_colors
				;
				;	clear queue tag for this group and rewrite listbox
				;
				case meta_flag of
					0:	begin
							(*g_ptr).S7_group_queue[g_ind] = -2
							;
							;	and don't step status value for this group
							;
							(*g_ptr).group_step[g_ind] = 6
							S7A_populate_group_list, Event
							if( g_ind gt 10) then begin
								WIDGET_CONTROL, (*w_ptr).S7A_group_listbox_wid, SET_LIST_TOP= ( g_ind - 6)
							endif
						end
					1:  begin
							(*g_ptr).S7_meta_group_queue[g_ind+1] = -2
							;
							;	and update step status value for this group
							;
							(*g_ptr).meta_group_step[g_ind+1] = 6
							S7B_populate_meta_group_list, Event
							if( g_ind gt 10) then begin
								WIDGET_CONTROL, (*w_ptr).S7B_meta_group_listbox_wid, SET_LIST_TOP= ( g_ind - 6)
							endif
						end
				endcase
			 end
		endcase
		MSP_PPOL_Save_Group_File, Event
	endfor
	;
	;	all groups done.
	;
	print_text, Event, "All Queued Groups have been Coadded"
	;
	S7_SC_end:
end
