function S7_old_coadd, coadd_struct
;
;	performs coaddition on pixel by pixel basis (the old way)
;
naxis11 = coadd_struct.naxis11
naxis21 = coadd_struct.naxis21
;
if(coadd_struct.double_precision_flag) then output_image = dblarr(coadd_struct.new_naxis1, coadd_new_struct.new_naxis2) else $
	output_image = fltarr(coadd_struct.new_naxis1, coadd_struct.new_naxis2)
;
for ix = 0, coadd_struct.new_naxis1-1 do begin
	;
	;	compute offsets into each constituent image
	;
	x_in_image = ix - coadd_struct.x_off[*]
	;
	ind_x = WHERE(x_in_image ge 0 and x_in_image le naxis11, count_x)
	;
	if(count_x eq 0) then goto, x_loop_end		; if none on image, jump past y
	;
	for iy = 0, coadd_struct.new_naxis2-1 do begin
		y_in_image = iy - coadd_struct.y_off[ind_x]
		ind_y = WHERE(y_in_image ge 0 and y_in_image le naxis21, count_y)
		if(count_y eq 0) then goto, y_loop_end
		;
		;	at this point, we have offsets into the images that overlap this
		;		output image pixel, but in odd pointers - rectify
		;
		;	for each of these images, pull their relevant pixels to form a vector
		;
		if(coadd_struct.double_precision_flag) then begin
			vec = dblarr(count_y)
		endif else begin
			vec = fltarr(count_y)
		endelse
		;
		save_sky = dblarr(N_ELEMENTS(vec))
		;
		igood = 0L
		for i_ind = 0, count_y-1 do begin
			i_image = ind_x[ind_y[i_ind]]				; selects which image
			;
			jx = x_in_image[i_image]					; column number in image
			jy = y_in_image[ind_y[i_ind]]				; row number in image
			;
			value = coadd_struct.raw_images[i_image, jx, jy]
			;
			sky = coadd_struct.sky_image[i_image]
			;
			if(value ne -1.0e6 and FINITE(value)) then begin
				if(coadd_struct.scale[i_image] ne 0.0) then begin
					vec[igood] = (value - sky) * coadd_struct.scale[i_image]	; dpc 20091008
;							save_sky[igood] = sky * scale[i_image]
					igood++
				endif
			endif
		endfor
		if(igood gt 0) then begin
			vec = vec[0:igood-1]
;					save_sky = save_sky[0:igood-1]
			;
			;	now, clean this vector of CRs
			;
			;	mfm clean, but use sum of good pixels, not mfm value
			;		- 20091008 - use mfm again...
			;
			if(igood ge 2) then begin
				zz = median_filtered_mean(vec)
;						zz_sky = median_filtered_mean(save_sky)
;						gind = WHERE(abs(vec-zz[0])/zz[1] le 3.0, gg_count)
;						sum = TOTAL(vec[gind])
				sum = (zz[0] + coadd_struct.scaled_mean_sky) * float(igood)		; 20091008
				gg_count = igood
			endif else begin
				sum = TOTAL(vec) + coadd_struct.scaled_mean_sky
				gg_count = igood
			endelse
			;
			output_image[ix,iy] = sum * (float(coadd_struct.fn_mean_images) / double(gg_count))	; scale to sum of median number of images
			;
		endif else begin
			output_image[ix,iy] = -1.0e6
		endelse
		;
		y_loop_end:				; leave border = 0
	endfor			; end of y loop
	;
	x_loop_end:
endfor
;
return, output_image
;
end