function S7_read_phot_file_header, pathname
	;
	;	opens, reads, decodes *_phot.dat file
	;	to recover FITS header
	;
	test = FILE_INFO(pathname)
	if(test.exists) then begin
		openr, lu_in, pathname, /GET_LUN
		;
		header = strarr(2000)
		nline = 0
		;
		line = ''
		;
		WHILE ~EOF(lu_in) do begin
			readf, lu_in, line, format='(a)'
			;
			;	test for presence of two semicolons ;; - skip any line lacking these
			;
			semi = STRPOS(line,';;')
			if(semi ne -1) then begin
				;
				;	skip any line with ' Star ' in it
				;
				st_test = STRPOS(line,' Star ')
				if(st_test eq -1 or st_test gt 10) then begin
					;
					header[nline] = STRMID(line,2)		; skip the semicolons
					nline++
					;
					;	test for END in first three characters, if present, exit
					;
					t_end = STRPOS(header[nline-1],'END')
					if(t_end eq 0) then goto, loop_end
					;
				endif
			endif
		ENDWHILE
		;
		loop_end:
		header = header[0:nline-1]
		;
		FREE_LUN, lu_in
	endif else begin
		header = strarr(1)
		header[0] = 'ERROR'
		;
		print, 'ERROR - file ',pathname,' not found'
	endelse
	;
	return, header
end
