pro Write_to_Photcat_Header, Event, lu_out, imgrp, group_name, ind_grp, image_start, image_last, $
									n_in_group
		;
		WIDGET_CONTROL, Event.top, GET_UVALUE=PTR_struct
    w_ptr = PTR_struct.PTR_wid_id
    s_ptr = PTR_struct.PTR_summary
    g_ptr = PTR_struct.PTR_group
		;
		printf, lu_out, format='(";;HISTORY - Information about group ",i2.2," follows -")',imgrp
		;
		;	parse to get directory, filename
		;
		ind_fwd = STRPOS(image_start, '/')
		ind_rev = STRPOS(image_start, '\')
		case ind_fwd of
			-1: begin
					case ind_rev of
						-1: begin
								stop
							end
					  else: begin
					  			delim = '\'
					  		end
					endcase
				end
		  else: begin
		  			case ind_rev of
		  				-1:	begin
		  						delim = '/'
		  					end
		  			  else:	begin
		  			  			stop
		  			  		end
		  			endcase
		  		end
		endcase
		;
		parts = STRSPLIT(image_start, delim, /EXTRACT, COUNT=count)
		;
		image_d = parts[0]
		for id = 1, count-2 do begin
			image_d = image_d + delim + parts[id]
		endfor
		;
		id_len = STRLEN(image_d)
		if(id_len gt 50) then begin
			image_d0 = STRMID(image_d, 0, 50)
			image_d1 = STRMID(image_d, 50)
			printf, lu_out, format='(";;IMAG_D",i2.2,"= ",a)',imgrp,"'"+image_d0+"&'"
			printf, lu_out, format='(";;CONTINUE    ",a)',"'"+image_d1+"'"
		endif else begin
			printf, lu_out, format='(";;IMAG_D",i2.2,"= ",a)',imgrp,"'"+image_d+"'"
		endelse
		;
		image_0 = parts[count-1]
		i0_len = STRLEN(image_0)
		if(i0_len gt 50) then begin
			image_00 = STRMID(image_0, 0, 50)
			image_01 = STRMID(image_0, 50)
			printf, lu_out, format='(";;IMAG_A",i2.2,"= ",a)',imgrp,"'"+image_00+"&'"
			printf, lu_out, format='(";;CONTINUE    ",a)',"'"+image_01+"'"
		endif else begin
			printf, lu_out, format='(";;IMAG_A",i2.2,"= ",a)',imgrp,"'"+image_0+"'"
		endelse
		;
		parts2 = STRSPLIT(image_last, delim, /EXTRACT, COUNT=count2)
		image_n = parts2[count2-1]
		in_len = STRLEN(image_n)
		if(in_len gt 50) then begin
			image_n0 = STRMID(image_n, 0, 50)
			image_n1 = STRMID(image_n, 50)
			printf, lu_out, format='(";;IMAG_Z",i2.2,"= ",a)',imgrp,"'"+image_n0+"&'"
			printf, lu_out, format='(";;CONTINUE    ",a)',"'"+image_n1+"'"
		endif else begin
			printf, lu_out, format='(";;IMAG_Z",i2.2,"= ",a)',imgrp,"'"+image_n+"'"
		endelse
		;
		;	get key info
		;
		s9_recover_field_info, Event, ind_grp, mean_jd, fwhm, n_use_zero, mean_sky, $
								sky_noise, field_pol, s_field_pol, rms_scale
		;
		printf, lu_out, format='(";;GRPNAM",i2.2,"= ",a)',imgrp,"'"+group_name+"'"
		printf, lu_out, format='(";;JDMEAN",i2.2,"= ",f20.7," / mean julian date/time")',imgrp,mean_jd
		printf, lu_out, format='(";;FWHMAV",i2.2,"= ",13x,f7.3," / average FWHM in arcsec")',imgrp,fwhm
		if(fwhm gt 0.6) then fwhm_cor = sqrt(fwhm*fwhm - 0.58*0.58) else fwhm_cor = 0.0
		printf, lu_out, format='(";;FWHMCR",i2.2,"= ",13x,f7.3," / FWHM corrected for pixel sampling")',imgrp,fwhm_cor
		printf, lu_out, format='(";;NINGRP",i2.2,"= ",13x,2x,i5," / observed image number for this group")',imgrp,n_in_group
		printf, lu_out, format='(";;NUSE0_",i2.2,"= ",13x,2x,i5," / number of images NOT used in PPOL analysis")',imgrp,n_use_zero
		printf, lu_out, format='(";;AV_SKY",i2.2,"= ",10x,f10.3," / mean sky, ADUs per pixel per second")',imgrp,mean_sky
		printf, lu_out, format='(";;SKNOIS",i2.2,"= ",10x,f10.3," / mean sky noise after scaling (%)")',imgrp,sky_noise
		printf, lu_out, format='(";;FLDPOL",i2.2,"= ",10x,f10.3," / mean field polarization found by scaler (%)")',imgrp,field_pol
		printf, lu_out, format='(";;S_FLPL",i2.2,"= ",10x,f10.3," / uncertainty of field polarization (%)")',imgrp,s_field_pol
		printf, lu_out, format='(";;RMSSCL",i2.2,"= ",13x,f7.3," / RMS of atmospheric scale factors")',imgrp,rms_scale
		;
		; if mock star flag set, add offset mag
		;
		if( (*w_ptr).S8_fix_2MASS_flag eq 1) then begin
		  printf, lu_out, format='(";;HISTORY - this image has mock stars added")'
		  printf, lu_out, format='(";;MST_MOFF= ",13x,f7.4," / 2MASS-Mimir Offset magnitude added")',(*w_ptr).S8_2MASS_offset_value
    endif
end


pro S8_Write_PHOTCAT_file, Event, deep_path, phot_struct, two_mass_struct, glimpse_struct, phot_header, pmode
	;
	;	writes phot_structure data to an ASCII output file
	;
	;	20130620	added pmode keyword and output (H-Pol, K-Pol, J-Band, H-Band, K-Band)
	;	20200503  forced star numbers to start at unity instead of zero
	;
	WIDGET_CONTROL, Event.top, GET_UVALUE=PTR_struct
	w_ptr = PTR_struct.PTR_wid_id
	s_ptr = PTR_struct.PTR_summary
	g_ptr = PTR_struct.PTR_group
	;
	;	check for sub-directory called PHOTCAT
	;
	fname = FILE_BASENAME(deep_path,".fits",/FOLD_CASE)
	;
	photcat_dir = (*s_ptr).analysis_dir + 'S8_PHOTCAT_entries' + PATH_SEP()
	test = FILE_INFO(photcat_dir)
	if(NOT(test.exists)) then begin
		print_text, Event, "Creating PHOTCAT sub-directory = "+photcat_dir
		FILE_MKDIR, photcat_dir
	endif
	;
	output_path = photcat_dir + PATH_SEP() + fname + "_PHOTCAT.dat"
	;
	openw, lu_out, output_path, /GET_LUN
	;
	nstars = N_ELEMENTS(phot_struct)
	;
	;	write header
	;
	trim = STRPOS(fname, '_Deep_Coadd')
	group_name = STRMID(fname,0,trim)
	;
	time = SYSTIME()
	;
	printf, lu_out, format='(";;GPOBSRUN= ",a)',"'"+(*s_ptr).analysis_dir+"'"
	printf, lu_out, format='(";;GP_GROUP= ",a)',"'"+group_name+"'"
	printf, lu_out, format='(";;PPOL_VER= ",a)',"'"+(*s_ptr).version_short_string+"'"
	printf, lu_out, format='(";;DTM_PPOL= ",a)',"'"+time+"'"
	printf, lu_out, format='(";;LONGSTRN= ",a)',"'"+'OGIP 1.0'+"'"
	;
	printf, lu_out, format='(";;PMODE   = ",a)',"'"+pmode+"'"
	;
	;	information about A/B ratio at S8
	;
	axis_abr = SXPAR(phot_header, "AXIS_ABR",COUNT=a_count)
	if(a_count eq 0) then axis_abr = -99.0
	;
	printf, lu_out, format='(";;AXIS_ABR= ",10x,f10.4," / PSF average A/B axis ratio")',axis_abr
	;
	;	use group name to match to group index for key quantity extraction
	;
	ind_grp = WHERE((*g_ptr).group_names eq group_name, ngrp)
	if(ngrp eq 1) then begin
		image_start = (*g_ptr).group_images[ind_grp,0]
		n_in_group = (*g_ptr).group_numbers[ind_grp]
		image_last = (*g_ptr).group_images[ind_grp,n_in_group-1]
		;
		imgrp = 0
		printf, lu_out, format='(";;NGROUPS = ",16x,i4.1," /  Number of Groups (>1 = Meta-Group)")',imgrp+1
		write_to_photcat_header, Event, lu_out, imgrp+1, group_name, ind_grp[0], image_start, image_last, $
				n_in_group
		;
	endif else begin
		print_text, Event, 'Warning - could not get clean group_name match in PHOTCAT writer - trying meta-groups'
		;
		ind_mgrp = WHERE((*g_ptr).meta_group_names eq group_name, nmgrp)
		if(nmgrp eq 1) then begin
			n_in_meta = (*g_ptr).meta_group_numbers[ind_mgrp[0]]
			printf, lu_out, format='(";;NGROUPS = ",16x,i4.1," /  Number of Groups (>1 = Meta-Group)")',n_in_meta
			;
			;	list properties of each constituent group in the meta group
			;
			if(n_in_meta gt 1) then begin
				for imgrp = 0, n_in_meta-1 do begin
					grp_no = (*g_ptr).meta_group_groups[ind_mgrp,imgrp]
					grp_name = (*g_ptr).group_names[grp_no]
					image_start = (*g_ptr).group_images[grp_no,0]
					n_in_group = (*g_ptr).group_numbers[grp_no]
					image_last = (*g_ptr).group_images[grp_no,n_in_group-1]
					;
					write_to_photcat_header, Event, lu_out, imgrp+1, grp_name, grp_no, image_start, image_last, $
									n_in_group
					;
				endfor
			endif
		endif else begin
			print_text, Event, 'Was not a meta-group, either - PHOTCAT header info compromised'
		endelse
	endelse
	;
	;
	line_a = ';;|---------------------------------------- GPIPS -------------------------------------------------------------------------|'
	line_b = '|----------------------------------- 2MASS ---------------------------------------------------|'
	line_c = '|----------------------------------- GLIMPSE ---------------------|'
	printf, lu_out, line_a, line_b, line_c, format='(a,a,a)'
	;
	line_d = ';; No.      Designation           X_img.  Y_img. X_det Y_det RA(deg)    Dec(deg)     '
	;
	case pmode of
		'H-Pol': line_da = 'Hmag    sHmag'
		'K-Pol': line_da = 'Kmag    sKmag'
		'J-Band': line_da = 'Jmag    sJmag'
		'H-Band': line_da = 'Hmag    sHmag'
		'K-Band': line_da = 'Kmag    sKmag'
		else: begin
				print, 'No Pmode match - stopping'
				stop
			  end
	endcase
	;
	line_dd = '    sPhot  Sky(cts)  Grp.'
	line_e = '  2ID      Designation      RA(deg)     Dec(deg)    Jmag   sJmag   Hmag   sHmag    Kmag   sKmag'
	line_f = '   3.6mag  s3.6mag 4.5mag  s4.5mag 5.8mag  s5.8mag 8.0mag  s8.0mag'
	printf, lu_out, line_d, line_da, line_dd, line_e, line_f, format='(a,a,a,a,a)'
	;
	for is = 0, nstars-1 do begin
		;
		;	compute designation
		;
		ra = double(phot_struct[is].ra) / 15.0d0
		;
		ra_hms = abs(SIXTY(ra))
		dec_dms = abs(SIXTY(phot_struct[is].dec))
		;
		ra_ts = FLOOR((ra_hms[2]+0.005)/10.0)				; tens digits for seconds
		ra_ds = (ra_hms[2] - double(10*ra_ts)) > 0.0			; ones and remainder for seconds
		if(ra_ds ge 9.995) then begin
			ra_ts = ra_ts + 1
			ra_ds = (ra_ds - 10.0) > 0.0
		endif
		if(ra_ts ge 6) then begin
			ra_hms[1] = ra_hms[1] + 1
			ra_ts = (ra_ts - 6) > 0
		endif
		if(ra_hms[1] ge 60) then begin
			ra_hms[0] = ra_hms[0] + 1
			ra_hms[1] = (ra_hms[1] - 60) > 0
		endif
		if(ra_hms[0] ge 24) then ra_hms[0] = (ra_hms[0] - 24) > 0
		;
		if(phot_struct[is].dec ge 0.0) then begin
			dec_sign = '+'
		endif else begin
			dec_sign = '-'
			dec_dms[0] = abs(dec_dms[0])
			dec_dms[1] = abs(dec_dms[1])
			dec_dms[2] = abs(dec_dms[2])
		endelse
		;
		dec_ts = FLOOR(dec_dms[2]/10.0)		; tens of seconds
		;
		dec_ds = (dec_dms[2] - 10*dec_ts) > 0
		if(dec_ds ge 9.95) then begin
			dec_ts = dec_ts + 1
			dec_ds = (dec_ds - 10.0) > 0.0
		endif
		if(dec_ts ge 6) then begin
			dec_dms[1] = dec_dms[1] + 1
			dec_ts = (dec_ts - 6) > 0
		endif
		if(dec_dms[1] ge 60) then begin
			dec_dms[0] = dec_dms[0] + 1
			dec_dms[1] = (dec_dms[1] - 60) > 0
		endif
		if(dec_dms[0] gt 90) then dec_dms[0] = 90
		;
		desig = 'GPIPS_J' + STRTRIM(STRING(ra_hms[0],ra_hms[1],ra_ts,ra_ds,$
										   dec_sign, dec_dms[0],dec_dms[1],dec_ts,dec_ds,$
										   format='(I2.2,i2.2,i1.1,f4.2,a1,i2.2,i2.2,i1.1,f3.1)'))
		;
		fmt1 ='(i5.5,1x,a25,1x,f7.2,1x,f7.2,1x,I4,1x,i4,1x,F10.6,1x,F11.6,1x,f8.4,1x,f8.4,1x,f8.4,1x,f8.1,1x,i5,1x,i5,'
		;
		;	2mass
		;
		fmt2 = '1x,a19,1x,f10.6,1x,f11.6,1x,6(f7.3,1x),'
		;
		;	glimpse
		;
		fmt3 = '1x,8(f7.3,1x))'
		;
		format123 = fmt1 + fmt2 + fmt3
		;
		printf, lu_out, phot_struct[is].id+1, $   ; 20200503 - DPC - force start at unity
						desig, $
						phot_struct[is].x, $
						phot_struct[is].y,$
						phot_struct[is].detector_x, $
						phot_struct[is].detector_y,$
						phot_struct[is].ra, $
						phot_struct[is].dec, $
						phot_struct[is].mag, $
						phot_struct[is].errmag,$
						phot_struct[is].ierrmag,$
						phot_struct[is].sky, $
						phot_struct[is].psf_group,$
						;
						two_mass_struct[is].id_phot, $
						two_mass_struct[is].desig, $
						two_mass_struct[is].ra, $
						two_mass_struct[is].dec, $
						two_mass_struct[is].Jmag, $
						two_mass_struct[is].E_Jmag, $
						two_mass_struct[is].Hmag, $
						two_mass_struct[is].E_Hmag, $
						two_mass_struct[is].Kmag, $
						two_mass_struct[is].E_Kmag, $
						;
						glimpse_struct[is].b36mag, $
						glimpse_struct[is].e_b36mag, $
						glimpse_struct[is].b45mag, $
						glimpse_struct[is].e_b45mag, $
						glimpse_struct[is].b58mag, $
						glimpse_struct[is].e_b58mag, $
						glimpse_struct[is].b80mag, $
						glimpse_struct[is].e_b80mag, $
						;
						format=format123
	endfor
	;
	FREE_LUN, lu_out
	;
	print_text, Event, "Wrote PHOTCAT file "+FILE_BASENAME(output_path)
end