pro Write_to_Polcat_Header, Event, lu_out, imgrp, group_name, ind_grp, image_start, image_last, n_in_group
		;
		printf, lu_out, format='(";;HISTORY - Information about group ",i2.2," follows -")',imgrp
		;
		;	parse to get directory, filename
		;
		ind_fwd = STRPOS(image_start, '/')
		ind_rev = STRPOS(image_start, '\')
		case ind_fwd of
			-1: begin
					case ind_rev of
						-1: begin
								stop
							end
					  else: begin
					  			delim = '\'
					  		end
					endcase
				end
		  else: begin
		  			case ind_rev of
		  				-1:	begin
		  						delim = '/'
		  					end
		  			  else:	begin
		  			  			stop
		  			  		end
		  			endcase
		  		end
		endcase
		;
		parts = STRSPLIT(image_start, delim, /EXTRACT, COUNT=count)
		;
		image_d = parts[0]
		for id = 1, count-2 do begin
			image_d = image_d + delim + parts[id]
		endfor
		;
		id_len = STRLEN(image_d)
		if(id_len gt 50) then begin
			image_d0 = STRMID(image_d, 0, 50)
			image_d1 = STRMID(image_d, 50)
			printf, lu_out, format='(";;IMAG_D",i2.2,"= ",a)',imgrp,"'"+image_d0+"&'"
			printf, lu_out, format='(";;CONTINUE    ",a)',"'"+image_d1+"'"
		endif else begin
			printf, lu_out, format='(";;IMAG_D",i2.2,"= ",a)',imgrp,"'"+image_d+"'"
		endelse
		;
		image_0 = parts[count-1]
		i0_len = STRLEN(image_0)
		if(i0_len gt 50) then begin
			image_00 = STRMID(image_0, 0, 50)
			image_01 = STRMID(image_0, 50)
			printf, lu_out, format='(";;IMAG_A",i2.2,"= ",a)',imgrp,"'"+image_00+"&'"
			printf, lu_out, format='(";;CONTINUE    ",a)',"'"+image_01+"'"
		endif else begin
			printf, lu_out, format='(";;IMAG_A",i2.2,"= ",a)',imgrp,"'"+image_0+"'"
		endelse
		;
		parts2 = STRSPLIT(image_last, delim, /EXTRACT, COUNT=count2)
		image_n = parts2[count2-1]
		in_len = STRLEN(image_n)
		if(in_len gt 50) then begin
			image_n0 = STRMID(image_n, 0, 50)
			image_n1 = STRMID(image_n, 50)
			printf, lu_out, format='(";;IMAG_Z",i2.2,"= ",a)',imgrp,"'"+image_n0+"&'"
			printf, lu_out, format='(";;CONTINUE    ",a)',"'"+image_n1+"'"
		endif else begin
			printf, lu_out, format='(";;IMAG_Z",i2.2,"= ",a)',imgrp,"'"+image_n+"'"
		endelse
		;
		;	get key info
		;
		s9_recover_field_info, Event, ind_grp, mean_jd, fwhm, n_use_zero, mean_sky, $
								sky_noise, field_pol, s_field_pol, rms_scale
		;
		printf, lu_out, format='(";;GRPNAM",i2.2,"= ",a)',imgrp,"'"+group_name+"'"
		printf, lu_out, format='(";;JDMEAN",i2.2,"= ",f20.7," / mean julian date/time")',imgrp,mean_jd
		printf, lu_out, format='(";;FWHMAV",i2.2,"= ",13x,f7.3," / average FWHM in arcsec")',imgrp,fwhm
		if(fwhm gt 0.6) then fwhm_cor = sqrt(fwhm*fwhm - 0.58*0.58) else fwhm_cor = 0.0
		printf, lu_out, format='(";;FWHMCR",i2.2,"= ",13x,f7.3," / FWHM corrected for pixel sampling")',imgrp,fwhm_cor
		printf, lu_out, format='(";;NINGRP",i2.2,"= ",13x,2x,i5," / observed image number for this group")',imgrp,n_in_group
		printf, lu_out, format='(";;NUSE0_",i2.2,"= ",13x,2x,i5," / number of images NOT used in PPOL analysis")',imgrp,n_use_zero
		printf, lu_out, format='(";;AV_SKY",i2.2,"= ",10x,f10.3," / mean sky, ADUs per pixel per second")',imgrp,mean_sky
		printf, lu_out, format='(";;SKNOIS",i2.2,"= ",10x,f10.3," / mean sky noise after scaling (%)")',imgrp,sky_noise
		printf, lu_out, format='(";;FLDPOL",i2.2,"= ",10x,f10.3," / mean field polarization found by scaler (%)")',imgrp,field_pol
		printf, lu_out, format='(";;S_FLPL",i2.2,"= ",10x,f10.3," / uncertainty of field polarization (%)")',imgrp,s_field_pol
		printf, lu_out, format='(";;RMSSCL",i2.2,"= ",13x,f7.3," / RMS of atmospheric scale factors")',imgrp,rms_scale
end



pro S9_Write_POLCAT_entry, Event, group_name, pol_struct, nstars
	;
	;	writes a file to the POLCAT directory for this group
	;	with all the indicated polarimetry information
	;
	;	DPC 20100828  added diamonds to show "detections" with < 2.0 S/N
	;	DPC	20110831	added high-quality flag field
	;	DPC	20110907	changed HQF to UF (Utility Flag)
	;
	WIDGET_CONTROL, Event.top, GET_UVALUE=PTR_struct
	w_ptr = PTR_struct.PTR_wid_id
	s_ptr = PTR_struct.PTR_summary
	g_ptr = PTR_struct.PTR_group
	;
	plen = 30.0	; pixels per percent of polarization - stick length - nominal
	;
	;	check for sub-directory called POLCAT
	;
	fname = replace_underscores(group_name)
	;
	;print_text, Event, "On entry to WritePolcatEntry, nstars = "+STRING(nstars, format='(I)')
	;
	polcat_dir = (*s_ptr).analysis_dir + 'S9_POLCAT_entries' + PATH_SEP()
	test = FILE_INFO(polcat_dir)
	if(NOT(test.exists)) then begin
		print_text, Event, "Creating POLCAT sub-directory = "+polcat_dir
		FILE_MKDIR, polcat_dir
	endif
	;
	output_path = polcat_dir + PATH_SEP() + fname + "_POLCAT.dat"
	;
	;	also, create region file and put it in the S9_Polarimetry directory
	;
	pol_dir = (*s_ptr).analysis_dir + 'S9_Polarimetry' + PATH_SEP()
	reg_path = pol_dir + fname + '_pol_region.reg'
	openw, lu_reg, reg_path, /GET_LUN
	;
	;	and a cleaner reg file
	;
	clean_reg_path = pol_dir + fname + '_clean_pol_region.reg'
	openw, lu_clean_reg, clean_reg_path, /GET_LUN
	;
	openw, lu_out, output_path, /GET_LUN
	;
	nstars = N_ELEMENTS(pol_struct)
	;
	;	write header
	;
	time = SYSTIME()
	;
	printf, lu_out, format='(";;GPOBSRUN= ",a)',"'"+(*s_ptr).analysis_dir+"'"
	printf, lu_out, format='(";;GP_GROUP= ",a)',"'"+group_name+"'"
	printf, lu_out, format='(";;PPOL_VER= ",a)',"'"+(*s_ptr).version_short_string+"'"
	printf, lu_out, format='(";;DTM_PPOL= ",a)',"'"+time+"'"
	printf, lu_out, format='(";;LONGSTRN= ",a)',"'"+'OGIP 1.0'+"'"
	;
	;	get A/B axis ratio from PHOTCAT header
	;
	photcat_dir = (*s_ptr).analysis_dir + 'S8_PHOTCAT_entries' + PATH_SEP()
	photcat_path = photcat_dir + fname + '_Deep_Coadd_PHOTCAT.dat'
	;
	S9_read_photcat_header, photcat_path, phot_header
	;
	axis_abr = SXPAR(phot_header, 'AXIS_ABR',count=ab_count)
	if(ab_count eq 0) then axis_abr = -99.0
	;
	printf, lu_out, format='(";;AXIS_ABR= ",10x,f10.4," / PSF average A/B axis ratio")',axis_abr
	;
	if( (*w_ptr).S9_Pinst_mode eq 0) then begin
		printf, lu_out, format='(";;HISTORY  - No Instrumental Polarization Applied -")'
	endif else begin
		;
		;	add P_Inst values used
		;
		printf, lu_out, format='(";;HISTORY  Instrumental Polarization Corrections Applied using directory: ")'
		printf, lu_out, format='(";;PINST_FL= ",a)',"'"+(*w_ptr).S9_textbox_pathname+"'"
		printf, lu_out, format='(";;DATESTMP= ",8x,f12.2," / date stamp for the P_Inst corr file")', (*(*w_ptr).S9_P_inst_values_ptr).date_stamp
		;
		this_block = (*(*w_ptr).S9_P_inst_values_ptr).this_pol_off_ind
		printf, lu_out, format='(";;PINST_BK= ",18x,i2," / year-month block number for PA offset")',$
									this_block+1
		printf, lu_out, format='(";;END_YR  = ",10x,f10.3," / This block end decimal year")',$
									(*(*w_ptr).S9_P_inst_values_ptr).end_yr_block[this_block]
		printf, lu_out, format='(";;PA_OFF  = ",10x,f10.3," / PA offset to add to Mimir values [deg]")',$
									(*(*w_ptr).S9_P_inst_values_ptr).pol_off_angle[this_block]
		printf, lu_out, format='(";;S_PA_OFF= ",10x,f10.3," / PA offset uncertainty [deg]")',$
									(*(*w_ptr).S9_P_inst_values_ptr).s_pol_off_angle[this_block]
		printf, lu_out, format='(";;P_EFFIC = ",10x,f10.3," / Polarization efficiency [%]")',$
									100.0*(*(*w_ptr).S9_P_inst_values_ptr).pol_efficiency
		printf, lu_out, format='(";;S_P_EFF = ",10x,f10.3," / Uncertainty of Pol. Effic. [%]")',$
									100.0*(*(*w_ptr).S9_P_inst_values_ptr).s_pol_effic
	endelse
	;
	;	use group name to match to group index for key quantity extraction
	;
	ind_grp = WHERE((*g_ptr).group_names eq group_name, ngrp)
	if(ngrp eq 1) then begin
		image_start = (*g_ptr).group_images[ind_grp,0]
		n_in_group = (*g_ptr).group_numbers[ind_grp]
		image_last = (*g_ptr).group_images[ind_grp,n_in_group-1]
		;
		imgrp = 0
		printf, lu_out, format='(";;NGROUPS = ",16x,i4.1," /  Number of Groups (>1 = Meta-Group)")',imgrp+1
		write_to_polcat_header, Event, lu_out, imgrp+1, group_name, ind_grp[0], image_start, image_last, n_in_group
		;
	endif else begin
		print_text, Event, 'Warning - could not get clean group_name match in POLCAT writer - trying meta-groups'
		;
		ind_mgrp = WHERE((*g_ptr).meta_group_names eq group_name, nmgrp)
		if(nmgrp eq 1) then begin
			n_in_meta = (*g_ptr).meta_group_numbers[ind_mgrp[0]]
			printf, lu_out, format='(";;NGROUPS = ",16x,i4.1," /  Number of Groups (>1 = Meta-Group)")',n_in_meta
			;
			;	list properties of each constituent group in the meta group
			;
			for imgrp = 0, n_in_meta-1 do begin
				grp_no = (*g_ptr).meta_group_groups[ind_mgrp,imgrp]
				grp_name = (*g_ptr).group_names[grp_no]
				image_start = (*g_ptr).group_images[grp_no,0]
				n_in_group = (*g_ptr).group_numbers[grp_no]
				image_last = (*g_ptr).group_images[grp_no,n_in_group-1]
				;
				write_to_polcat_header, Event, lu_out, imgrp+1, grp_name, grp_no, image_start, image_last, n_in_group
				;
			endfor
		endif else begin
			print_text, Event, 'Was not a meta-group, either - POLCAT header info compromised'
		endelse
	endelse
	;
	;
	printf, lu_out, format='(";; ")'
	line_a = ';;|----------------------------------------- GPIPS ----------------------------------------------------------------------------------'
	line_aa = '-------------------------------------------------------------------|'
	line_b = '|---------------------------------- 2MASS ------------------------------------------------------|'
	line_bb = '|----------------------------------- GLIMPSE --------------------|'
	printf, lu_out, line_a, line_aa, line_b, line_bb, format='(a,a,a,a)'
	;
	line_f = '   3.6mag  s3.6mag 4.5mag  s4.5mag 5.8mag  s5.8mag 8.0mag  s8.0mag'
	line_c = ';; No.   ID     Designation            X_img   Y_img  Xdet Ydet  RA(deg)    Dec(deg)     Hmag     sHmag    sPhot  Sky(cts) '
	line_cc = '   P[%]   sP[%] EPA[deg] GPA[deg]  sPA     Q[%]    sQ      U[%]    sU nHWP UF'
	line_d = '  2ID      Designation      RA(deg)     Dec(deg)     Jmag   sJmag    Hmag   sHmag    Kmag   sKmag'
	line_f = '   3.6mag  s3.6mag 4.5mag  s4.5mag 5.8mag  s5.8mag 8.0mag  s8.0mag'
	printf, lu_out, line_c, line_cc, line_d, line_f, format='(a,a,a,a)'
	;
	n_polcat = 0L
	n_upper_limits = 0L
	n_detections = 0L
	;
	;	vectors for region file
	;
	p = fltarr(nstars)
	s_p = fltarr(nstars)
	theta = fltarr(nstars)
	x = fltarr(nstars)
	y = fltarr(nstars)
	;
	;	mean m_H (no error weighting)
	;
	zz_mH = median_filtered_mean(pol_struct.mag)
	mean_mH = zz_mH[0]
	;
	print_text, Event, "Writing to POLCAT file from list containing "+STRING(nstars,format='(I)')+" stars"
	;
	nreject = 0L
	;
	for is = 0, nstars-1 do begin
		;
		;	compute designation
		;
		ra = pol_struct[is].ra / 15.0
		;
		ra_hms = SIXTY(ra)
		dec_dms = SIXTY(pol_struct[is].dec)
		;
		ra_ts = FIX((ra_hms[2]+0.005)/10.0)				; tens digits for seconds
		ra_ds = (ra_hms[2] - double(10*ra_ts)) > 0.0			; ones and remainder for seconds
		if(ra_ds ge 9.995) then begin
			ra_ts = ra_ts + 1
			ra_ds = (ra_ds - 10.0) > 0.0
		endif
		if(ra_ts ge 6) then begin
			ra_hms[1] = ra_hms[1] + 1
			ra_ts = (ra_ts - 6) > 0
		endif
		if(ra_hms[1] ge 60) then begin
			ra_hms[0] = ra_hms[0] + 1
			ra_hms[1] = (ra_hms[1] - 60) > 0
		endif
		if(ra_hms[0] ge 24) then ra_hms[0] = (ra_hms[0] - 24) > 0
		;
		if(pol_struct[is].dec ge 0.0) then begin
			dec_sign = '+'
		endif else begin
			dec_sign = '-'
			dec_dms[0] = abs(dec_dms[0])
			dec_dms[1] = abs(dec_dms[1])
			dec_dms[2] = abs(dec_dms[2])
		endelse
		;
		dec_ts = FLOOR(dec_dms[2]/10.0)
		;
		dec_ds = (dec_dms[2] - 10*dec_ts) > 0.0
		if(dec_ds ge 9.95) then begin
			dec_ts = dec_ts + 1
			dec_ds = (dec_ds - 10.0) > 0.0
		endif
		if(dec_ts ge 6) then begin
			dec_dms[1] = dec_dms[1] + 1
			dec_ts = (dec_ts - 6) > 0
		endif
		if(dec_dms[1] ge 60) then begin
			dec_dms[0] = dec_dms[0] + 1
			dec_dms[1] = (dec_dms[1] - 60) > 0
		endif
		if(dec_dms[0] gt 90) then dec_dms[0] = 90
		;
		desig = 'GPIPS_J' + STRTRIM(STRING(ra_hms[0],ra_hms[1],ra_ts,ra_ds,$
										   dec_sign, dec_dms[0],dec_dms[1],dec_ts,dec_ds,$
										   format='(I2.2,i2.2,i1.1,f4.2,a1,i2.2,i2.2,i1.1,f3.1)'))
		;
		if(STRPOS(desig,'*') ne -1) then stop
		;
		;	NB: ALL surviving stars go into POLCATs
		;		Utility Flag (UF) is set as follows:
		;			mH < 12.5		&  sP < 2%			UF = 1
		;			12.5 < mH < 14	& 2% < sP < 10%  	UF = 2
		;			mH > 14			or	sP > 10% 		UF = 3
		;
		;	tests for inclusion and color coding of REG file entries
		;
		;	rules:
		;			1. any entry with pol_err <= 5.0% is kept
		;			2. any entry with P/sP > 2 is kept, so long as P < 35%
		;				*and* m_H no more than 1 mag fainter than mean m_H (added 20100828)
		;
;		test1 = pol_struct[is].p_err le 5.0 and pol_struct[is].p_err ne 0.0
;		test2a = (pol_struct[is].p / pol_struct[is].p_err) gt 2.0 and pol_struct[is].p_err ne 0.0
;		test2b = pol_struct[is].p le 35.0
;		test2c = (pol_struct[is].mag - mean_mH) lt 1.0
;		test2 = test2a and test2b and test2c
		;
		;	utility flag choice - update per GPIPS DR4 definition - 20200503
		;
		UF = -1
		if(pol_struct[is].mag ge 14.0) then UF = 3
		if(pol_struct[is].p_err ge 10.0) then UF = 3
		if(UF ne 3) then begin
			if(pol_struct[is].mag ge 12.5) then UF = 2
			if(pol_struct[is].p_err ge 2.0) then UF = 2
			;
			if(UF lt 2) then begin
				if(pol_struct[is].mag lt 12.5 and pol_struct[is].p_err lt 2.0) then UF = 1
			endif
		endif
		;
;		if(test1 or test2) then begin
		;
		;	20110830 - keep all, but flag good
		;
		;	good, if sP <= 5 and mH >= 15
		;
		;hqf = pol_struct[is].p_err le 5.0 and pol_struct[is].mag le 14.0
		;
		hqf = UF
		;
		new_test = 1
		;
		if(new_test) then begin
			;
			;	passed one or the other, write the POLCAT entry
			;
			format_1 = '(i5.5,1x,i5.5,1x,a25,1x,f7.2,1x,f7.2,1x,I4,1x,i4,1x,'
		 	format_2 = 'F10.6,1x,F11.6,1x,f8.4,1x,f8.4,1x,f8.4,1x,f8.1,1x,'
		 	format_3 = '9(F7.3,1x),I2,1x,I2,1x,'
		 	format_4 = 'i5,1x,a19,1x,f10.6,1x,f11.6,1x,6(f7.3,1x),'
		 	format_5 = '1x,8(f7.3,1x))'
		 	;
		 	this_format = format_1 + format_2 + format_3 + format_4 + format_5
		 	;
		 	;	compute GPA
		 	;
		 	year = 2000.0
			j = 1
			glactc, pol_struct[is].ra, pol_struct[is].dec, 2000, L, B, 1, /DEGREE
			;
			GPA = EPA_to_GPA(L, B, pol_struct[is].theta)
			;
			printf, lu_out, $
						;is, $							      ; "is" is the pointer to the pol_struct entry
						n_polcat+1, $					    ; polcat consecutive counter (from 1)
						pol_struct[is].id+1, $		; this is the photcat entry, starting from unity - 20200503
						desig, pol_struct[is].x, pol_struct[is].y,$
						pol_struct[is].detector_x, pol_struct[is].detector_y,$
						pol_struct[is].ra, pol_struct[is].dec, $
						pol_struct[is].mag, pol_struct[is].errmag, pol_struct[is].ierrmag,$
						pol_struct[is].sky, $
						((pol_struct[is].p > 0.0) < 99.9),$
						((pol_struct[is].p_err > 0.0) < 99.0),$
						pol_struct[is].theta,$
						gpa, $
						(pol_struct[is].theta_err < 180.0),$
						((pol_struct[is].q > (-99.9)) < 99.9),$
						((pol_struct[is].q_err > 0.0) < 99.9),$
						((pol_struct[is].u > (-99.9)) < 99.9),$
						((pol_struct[is].u_err > 0.0) < 99.9),$
						pol_struct[is].n_hwp, $
						hqf, $
						;
						;	2mass
						;
						pol_struct[is].id_phot, $
						STRTRIM(pol_struct[is].desig,2), $
						pol_struct[is].ra_2mass, $
						pol_struct[is].dec_2mass, $
						pol_struct[is].Jmag, $
						pol_struct[is].E_Jmag, $
						pol_struct[is].Hmag, $
						pol_struct[is].E_Hmag, $
						pol_struct[is].Kmag, $
						pol_struct[is].E_Kmag, $
						;
						;	GLIMPSE
						;
						pol_struct[is].b36mag, $
						pol_struct[is].e_b36mag, $
						pol_struct[is].b45mag, $
						pol_struct[is].e_b45mag, $
						pol_struct[is].b58mag, $
						pol_struct[is].e_b58mag, $
						pol_struct[is].b80mag, $
						pol_struct[is].e_b80mag, $
						;						;
		 				format = this_format
			;
			p[n_polcat] = pol_struct[is].p
			s_p[n_polcat] = pol_struct[is].p_err
			theta[n_polcat] = pol_struct[is].theta
			x[n_polcat] = pol_struct[is].x
			y[n_polcat] = pol_struct[is].y
			;
			n_polcat++
			;
		endif else begin
			x_star = pol_struct[is].x
			y_star = pol_struct[is].y
;			print_text, Event, " Rejecting star (id,x,y) = "+STRING(is,x_star,y_star,format='(i4,1x,f6.1,1x,f6.1)')+$
;			 		" ....with (mag, P, sP) = "+$
;					STRING(pol_struct[is].mag, pol_struct[is].p,pol_struct[is].p_err, format='(F5.2,1x,F8.2,1x,f7.2)')
			nreject++
		endelse
	endfor
	;
	FREE_LUN, lu_out
	;
	print_text, Event, "In Write POLCAT - kept "+STRING(n_polcat,format='(I5.1)')+' good stars and rejected '+$
						STRING(nreject,format='(I5.1)')+" stars with bad polarimetry"
	;
	;	for the region file: - no entries with pol_err > 3%
	;
	;			1. upper limits (S/N < 1.25 after Ricean Correction) are marked as circles:
	;				A. if pol_err < 0.1%, 			circle is yellow
	;				B. if pol_err < 0.3%, 			circle is cyan
	;				C. if 0.3% < pol_err < 0.6%, 	circle is green
	;				D. if 0.6 < pol_err < 1.0%, 	circle is magenta
	;				E. if 1.0% < pol_err < 3.0% 	circle is blue

	;			2. marginal detections (1.25 < S/N < 2.0) get thin sticks
	;				A. if pol_err < 0.5%, 			stick is magenta
	;				B. else, 						stick is blue

	;			3. detections (S/N > 2.0) get sticks at the correct PA (E of N)
	;				A. if S/N > 10, 				stick is yellow
	;				B. if 10 > P/sP > 7, 			stick is yellow
	;				C. if 7> P/sP > 4, 				stick is cyan
	;				D. if 4 > P/sP > 2, 			stick is green
	;
	;
	s_to_n = p / s_P
	ind = WHERE(~finite(s_to_n) or s_P gt 5.0,nxx)
	if(nxx gt 0) then s_to_n[ind] = -1.0
	;
	upper_limit = 	s_to_n lt 1.25 and s_to_n ge 0.0
	marginal = 		s_to_n ge 1.25 and s_to_n lt 2.0
	detection = 	s_to_n ge 2.0
	;
	n_upper_limits = TOTAL(upper_limit)
	n_marginal = 	TOTAL(marginal)
	n_detection = 	TOTAL(detection)
	;
 	;	write the region file entry
 	;
	;	upper limits first - plot circle
	;
	if(n_upper_limits gt 0) then begin
		;
		;	get the entries that are in this group
		;
		ind_upper = WHERE(upper_limit eq 1)
		;
		x_upper = x[ind_upper]
		y_upper = y[ind_upper]
		s_p_upper = s_p[ind_upper]
		;
		u_ind = SORT(s_p_upper)
		;
		s_low =  [0.0, 0.1, 0.3, 0.6, 1.0]
		s_high = [0.1, 0.3, 0.6, 1.0, 5.0]
		color = ['red', 'yellow', 'cyan', 'magenta', 'blue']
		thick = [4, 3, 2, 2, 1]
		rad = [10, 9, 8, 7, 6]
		;
		for iband = 0, 4 do begin
			;
			this_ind = WHERE(s_p_upper ge s_low[iband] and s_p_upper lt s_high[iband], g_count)
			if(g_count gt 0) then begin
				for ig = 0, g_count-1 do begin
					ii = this_ind[ig]
					;
					printf, lu_reg, FORMAT='("circle ",f8.1,1x,f8.1,1x,I2," # color= ",a," width= ",i2)',$
											x_upper[ii]+1,y_upper[ii]+1,rad[iband],color[iband],thick[iband]
					if(iband lt 3) then begin
						printf, lu_clean_reg, FORMAT='("circle ",f8.1,1x,f8.1,1x,I2," # color= ",a," width= ",i2)',$
											x_upper[ii]+1,y_upper[ii]+1,rad[iband],color[iband],thick[iband]
					endif
				endfor
			endif
		endfor
	endif
	;
	;	detections - create stick
	;
	;   compute length, if there are any to compute lengths for (DPC 20091208)
	;
	if(n_detection+n_marginal gt 0) then begin
		ind_detect_best = WHERE(detection eq 1 and s_to_n gt 4.0,n_detect_best)
		ind_detect = WHERE(detection eq 1)
		ind_marginal = WHERE(marginal eq 1)
		;
		if(n_detect_best gt 0) then begin
			zz = median_filtered_mean(p[ind_detect_best])
		endif else begin
			if(n_detection gt 0) then begin
				zz = median_filtered_mean(p[ind_detect])
			endif else begin
				if(n_marginal gt 0) then begin
					zz = median_filtered_mean(p[ind_marginal])
				endif else begin
					zz = [2.0,0.0]
				endelse
			endelse
		endelse
		;
		mean_p = CEIL(zz[0])
		;
		p_scale_value = (*w_ptr).S9_textbox_value
		;print, "In S9, p_scale_value, mean_p = ", p_scale_value, mean_p
		if(p_scale_value ge 1 and p_scale_value le 10) then mean_p = p_scale_value
		;
		this_plen = plen / float(mean_p)
		;
		if(n_marginal gt 0) then begin
			p_det = p[ind_marginal]
			s_p_det = s_P[ind_marginal]
			x_det = x[ind_marginal]
			y_det = y[ind_marginal]
			theta_det = theta[ind_marginal]
		endif
		if(n_detection gt 0) then begin
			if(N_ELEMENTS(p_det) eq 0) then begin
				p_det = [p[ind_detect]]
				s_p_det = s_P[ind_detect]
				x_det = x[ind_detect]
				y_det = y[ind_detect]
				theta_det = theta[ind_detect]
			endif else begin
				p_det = [p_det,p[ind_detect]]
				s_p_det = [s_p_det,s_P[ind_detect]]
				x_det = [x_det,x[ind_detect]]
				y_det = [y_det,y[ind_detect]]
				theta_det = [theta_det,theta[ind_detect]]
			endelse
		endif
		;
		ratio = p_det / s_p_det
		d_ind = REVERSE(SORT(ratio))
		;
		p_det = p_det[d_ind]
		s_p_det = s_p_det[d_ind]
		x_det = x_det[d_ind]
		y_det = y_det[d_ind]
		ratio = ratio[d_ind]
		theta_det = theta_det[d_ind]
		;
		rlow =  [1.25, 1.25, 2.0, 4.0, 7.0, 10.0]
		rhigh = [2.0,  2.0,  4.0, 7.0, 10.0, 100000.0]
		slow =  [0.6,  0.0,  0.0, 0.0, 0.0, 0.0]
		shigh = [5.0,  0.6,  5.0, 5.0, 5.0, 5.0]
		color = ['blue', 'magenta', 'green', 'cyan', 'yellow', 'yellow']
		thick = [1, 2, 2, 3, 4, 5]
		;
		for iband = 0, 5 do begin
			;
			this_ind = WHERE(ratio ge rlow[iband] and ratio lt rhigh[iband] and $
						s_p_det ge slow[iband] and s_p_det lt shigh[iband], g_count)
			if(g_count gt 0) then begin
	    		;
	    		for iz = 0, g_count-1 do begin
	    			ii = this_ind[iz]
	    			;
	    			len = p_det[ii] * this_plen
					;
					;   and rotate ends to that angle
					;
					dra = len * sin((!pi/180.)*theta_det[ii])
					ddec = len * cos((!pi/180.0)*theta_det[ii])
					;
					xx = [x_det[ii]+dra,x_det[ii]-dra]
					yy = [y_det[ii]-ddec,y_det[ii]+ddec]
					;
					printf, lu_reg, FORMAT='("line ",f8.1,1x,f8.1,1x,f8.1,1x,f8.1," # color= ",a," width= ",i2)',$
										xx[0]+1,yy[0]+1,xx[1]+1,yy[1]+1,color[iband], thick[iband]
					if(iband gt 0) then begin
						if((p_det[ii] lt 10.0) or $
						   (p_det[ii] lt 20.0 and s_p_det[ii] lt 1.0) ) then begin
							printf, lu_clean_reg, FORMAT='("line ",f8.1,1x,f8.1,1x,f8.1,1x,f8.1," # color= ",a," width= ",i2)',xx[0]+1,$
										yy[0]+1,xx[1]+1,yy[1]+1,color[iband], thick[iband]
						endif
					endif else begin
						if((p_det[ii] lt 3.0 * mean_p and s_p_det[ii] lt 1.2) or $
						   (p_det[ii] lt 4.0 * mean_p and s_p_det[ii] lt 1.0) or $
						   (p_det[ii] lt 5.0 * mean_p and s_p_det[ii] lt 0.75) ) then begin
							printf, lu_clean_reg, FORMAT='("line ",f8.1,1x,f8.1,1x,f8.1,1x,f8.1," # color= ",a," width= ",i2)',xx[0]+1,$
										yy[0]+1,xx[1]+1,yy[1]+1,color[iband], thick[iband]
						endif
					endelse
				endfor
			endif
		endfor
		;
		;	add length label
		;
		len = this_plen * mean_p
		xcen = 850.0
		ycen = 125.0
		ang = 90
		;
		;   and rotate ends to that angle
		;
		dra = len * sin((!pi/180.)*ang)
		ddec = len * cos((!pi/180.0)*ang)
		;
		xx = [xcen+dra,xcen-dra]
		yy = [ycen-ddec,ycen+ddec]
		;
		printf, lu_reg, FORMAT='("line ",f8.1,1x,f8.1,1x,f8.1,1x,f8.1," # color = white width = 3 text = {",I2,"% Pol.}")',xx[0]+1,$
										yy[0]+1,xx[1]+1,yy[1]+1, mean_p
		printf, lu_clean_reg, FORMAT='("line ",f8.1,1x,f8.1,1x,f8.1,1x,f8.1," # color = white width = 3 text = {",I2,"% Pol.}")',xx[0]+1,$
										yy[0]+1,xx[1]+1,yy[1]+1, mean_p
		;
	endif
	;
	FREE_LUN, lu_reg
	FREE_LUN, lu_clean_reg
	;
	print_text, Event, "Wrote POLCAT file "+FILE_BASENAME(output_path)+" of "+STRING(n_polcat,format='(I5.1)')+" entries"
	print_text, Event, "... of which "+STRING(n_upper_limits,format='(I5.1)')+" were upper limits, "+$
					STRING(n_marginal,format='(I5.1)')+" were marginal, and "+$
					STRING(n_detection,format='(I5.1)')+" were polarization detections"
	;
end
