pro compute_plot_power_spectrum, image
;
; DPC 20140811 - computes FFT, then power spectrum, then lag, then plots
; 
;
imsize = SIZE(image)
nx = imsize[1]
ny = imsize[2]
;
; square up the array and reject the sides
; 
ncr = (nx < ny) - 100
this_image = image[50:ncr-1,50:ncr-1]
fft_image = fft(this_image)
;
ncr2 = FLOOR((ncr-1)/2)
pwr = (abs(fft_image[0:ncr2,0:ncr2]))^2
;
ix = findgen(ncr2+1)
x = fltarr(ncr2+1, ncr2+1)
y = fltarr(ncr2+1, ncr2+1)
for ik = 0, ncr2 do begin
  x[*,ik] = ix[ik]
  y[ik,*] = ix[ik]
endfor
;
r = sqrt(x^2 + y^2)
;
; bin and average by r step
; 
rbin = findgen(401)
nbin = lonarr(401)
bin_sum = findgen(401)
;
for ix = 0, ncr2 do begin
  for iy = 0, ncr2 do begin
    this_bin = ROUND(r[ix,iy])
    if(this_bin lt 401) then begin
      bin_sum[this_bin] += pwr[ix,iy]
      nbin[this_bin]++
    endif
  endfor
endfor
;
ind = where(nbin gt 0, ngood)
if(ngood gt 0) then begin
  bin_sum[ind] /= nbin[ind]
endif
;
window, 12
plot, rbin, bin_sum, psym=-3,/ylog,/xlog,yr=[10.0,3000.0],ys=1,xr=[1.,400.0],xs=1,$
  xtitle='Lag [pixels]',ytitle='Power',title='FFT Power Spectrum of Image'
cursor, xx, yy, /wait
wait, 0.5
;
wdelete, 12
end