pro g_mosaic_psf_models, Event, this_ng, psfrad, fit_rad, PSF_grid, psf_array
;
;	from a grid of PSF models, creates one array of the grid, in
;	their appropriate locations - for writing to disk and viewing
;
;	DPC	20100221
;
;-------------------------------------
;
;	how large should the image be?
;
;	remake each grid psf into a real psf
;
for igx = 0, this_ng-1 do begin
	for igy = 0, this_ng-1 do begin
		;
		;	rebuilt psf
		;
		gauss = PSF_grid[igx,igy].gauss
		resid = PSF_grid[igx,igy].resid
		g_remake_psf, gauss, resid, psfrad, psf_image, psfmag, fit_rad
		;
		;	if first time, reserve array space
		;
		if(igx + igy eq 0) then begin
			;
			psf_size = SIZE(psf_image)
			nx = psf_size[1]
			ny = psf_size[2]
			;
			nbuffer = 3
			;
			psf_array = fltarr(this_ng * nx + nbuffer * (this_ng - 1), this_ng * ny + nbuffer * (this_ng - 1))
			;
		endif
		;
		;	load into psf_array
		;
		xoff = igx * (nx + nbuffer)
		yoff = igy * (ny + nbuffer)
		;
		psf_array[xoff:xoff+nx-1, yoff:yoff+ny-1] = psf_image[*,*]
	endfor
endfor
;
end