function llq_clear, image, header
;
;	test for LLQ flag set in header
;
;	if found, force LLQ to mean sky level of other quads
;
;	DPC	20121231 new code
;
llq_flag = SXPAR(header, 'PP3_LLQF', COUNT=kwcount)
if(kwcount eq 1) then begin
	if(llq_flag eq 1) then begin
		s = size(image)
		nx = s[1]
		ny = s[2]
		if(nx ne 1024 or ny ne 1026) then begin
			print, 'ERROR on LLQ_CLEAR - image size wrong'
			stop
		endif
		;
		ptr_temp = PTR_NEW([image[512:1023:20,0:511:20],$
									         image[512:1023:20,513:1025:20],$
									         image[0:511:20,513:1025:20]])
		zz_3q = median_filtered_mean(REFORM(*ptr_temp))
		PTR_FREE, ptr_temp
		;
		image[0:511,0:512] = zz_3q[0]
	endif
endif
;
return, image
end