function ppol_order_stars, x, y
	;
	;	orders triplets of stars the same
	;	way
	;
	;	star 1 is the intersection of the Long and Medium
	;	distances
	;
	;	star 2 is L+S
	;	star 3 is M+S
	;
	;	returned index is the star 1,2,3 order relative to
	;	the input order
	;
	;	DPC	20081220
	;
	ind = lonarr(3,2)
	dist = fltarr(3)
	for i = 0, 2 do begin
		j = (i+1) MOD 3
		dx = x[i] - x[j]
		dy = y[i] - y[j]
		dist[i] = sqrt(dx^2 + dy^2)
		ind[i,0] = i
		ind[i,1] = j
	endfor
	;
	s_ind = SORT(dist)
	;
	;	now, ind[2,*] carries pointers to Star 1 and Star 2
	;	     ind[1,*] carries pointers to Star 1 and Star 3
	;
	if(ind[s_ind[2],0] eq ind[s_ind[1],0]) then star1 = ind[s_ind[1],0]
	if(ind[s_ind[2],1] eq ind[s_ind[1],0]) then star1 = ind[s_ind[1],0]
	if(ind[s_ind[2],0] eq ind[s_ind[1],1]) then star1 = ind[s_ind[1],1]
	if(ind[s_ind[2],1] eq ind[s_ind[1],1]) then star1 = ind[s_ind[1],1]
	;
	ind2 = WHERE(ind[s_ind[2],*] ne star1, count)
	star2 = ind[s_ind[2],ind2]
	;
	ind3 = WHERE(ind[s_ind[1],*] ne star1, count)
	star3 = ind[s_ind[1],ind3]
	;
	;print, "order of star 1, 2, 3 = ",star1, star2, star3
	;
	return, [star1, star2, star3]
end