function ppol_refine_header, matched_stars, header, orig_history, flag

;matched_stars = [[star_x_exact],[star_y_exact], [mass_ra], [mass_dec]]

num_stars = N_ELEMENTS(matched_stars[*,0])

if num_stars lt 4 then begin
  flag = 1
  return, header
endif

xsize = sxpar(header, 'NAXIS1')
ysize = sxpar(header, 'NAXIS2')
tel_dec = ten(strtrim(strsplit(sxpar(header, 'TELDEC'),':',/extract),2))
tel_ra = 15*ten(strtrim(strsplit(sxpar(header, 'TELRA'),':',/extract),2)); degrees

refx = ROUND(xsize/2.d)
refy = ROUND(ysize/2.d)

radec = dblarr(2*num_stars)
xy = dblarr(6,2*num_stars)

for star = 1, num_stars-1 do begin
  radec[2*star] = (matched_stars[star,2] - tel_ra)*cos(tel_dec*!dpi/180.); star RA
  radec[2*star+1] = matched_stars[star,3] - tel_dec; star Dec

  ;RA row
  xy[0,2*star] = 1.d*cos(tel_dec*!dpi/180.); RA_0
  xy[1,2*star] = 0.d; Dec_0
  xy[2,2*star] = matched_stars[star,0] - refx; CD1_1
  xy[3,2*star] = matched_stars[star,1] - refy; CD1_2
  xy[4,2*star] = 0.d ;CD2_1
  xy[5,2*star] = 0.d ;CD2_2

  ;Dec row
  xy[0,2*star+1] = 0.d; RA0
  xy[1,2*star+1] = 1.d; Dec0
  xy[2,2*star+1] = 0.d; CD1_1
  xy[3,2*star+1] = 0.d; CD1_2
  xy[4,2*star+1] = matched_stars[star,0] - refx; CD2_1
  xy[5,2*star+1] = matched_stars[star,1] - refy; CD2_2
endfor

epsil = invert(transpose(xy) ## xy, /double)
cd = epsil ## transpose(xy) ## radec
crval1  = [ cd[0]+tel_ra, cd[1]+tel_dec]
crpix1  = [ refx, refy ]

cd = transpose(reform(cd[2:5],2,2))
make_astr, astr,CD = cd, crval = crval1, crpix = crpix1+1, ctype = ['RA---','DEC--'] + 'TAN'
putast, header, astr, equi=2000.0,cd_type=2

;add back original history entries
hist_size = size(orig_history)
hist_size = hist_size[1]
for i=0, hist_size-1 do begin
  sxaddpar, header, 'HISTORY', orig_history[i]
endfor

flag = 2
return,header

end