function ppol_trim_star_list, Event, star_list, nstars, xsize, ysize, $
							max_quad_num, trim_flag, quad_criterion, idebug

;idebug = 1
;
if(quad_criterion eq 1) then begin
	;determine quadrant for each star
	ind1 = where(star_list[0,*] gt 0.5*xsize and star_list[1,*] gt 0.5*ysize,count1)	; UR
	if(count1 gt 0) then star_list[2,ind1] = 1
	ind2 = where(star_list[0,*] lt 0.5*xsize and star_list[1,*] gt 0.5*ysize,count2)	; UL
	if(count2 gt 0) then star_list[2,ind2] = 2
	ind3 = where(star_list[0,*] lt 0.5*xsize and star_list[1,*] lt 0.5*ysize,count3)	; LL
	if(count3 gt 0) then star_list[2,ind3] = 3
	ind4 = where(star_list[0,*] gt 0.5*xsize and star_list[1,*] lt 0.5*ysize,count4)	; LR
	if(count4 gt 0) then star_list[2,ind4] = 4

	;mask image
	;ind_edge = where((star_list[0,*] lt (xsize*0.05)) or (star_list[0,*] gt (0.95*xsize)) or (star_list[1,*] lt (ysize*0.05)) $
	;		or (star_list[1,*] gt (0.95*ysize)))
	;;
	;; mask these stars by putting them into a non-existent quad
	;;
	;if (ind_edge[0] ne -1) then star_list[2,ind_edge] = 0
	;;
	;ind_x_mask = where(star_list[0,*] lt xsize*0.55 and star_list[0,*] gt xsize*0.45)
	;if (ind_x_mask[0] ne -1) then star_list[2,ind_x_mask] = 0
	;ind_y_mask = where(star_list[1,*] lt ysize*0.55 and star_list[1,*] gt ysize*0.45)
	;if (ind_y_mask[0] ne -1) then star_list[2,ind_y_mask] = 0

	ind1 = where(star_list[2,*] eq 1, num_quad_1)
	ind2 = where(star_list[2,*] eq 2, num_quad_2)
	ind3 = where(star_list[2,*] eq 3, num_quad_3)
	ind4 = where(star_list[2,*] eq 4, num_quad_4)

	if num_quad_1 gt max_quad_num then begin
	  quad1_bright = star_list[3,ind1]
	  sort1 = reverse(sort(quad1_bright))
	  sort1 = sort1[0:max_quad_num-1]
	  ind1 = ind1[sort1]
	endif

	if num_quad_2 gt max_quad_num then begin
	  quad2_bright = star_list[3,ind2]
	  sort2 = reverse(sort(quad2_bright))
	  sort2 = sort2[0:max_quad_num-1]
	  ind2 = ind2[sort2]
	endif

	if num_quad_3 gt max_quad_num then begin
	  quad3_bright = star_list[3,ind3]
	  sort3 = reverse(sort(quad3_bright))
	  sort3 = sort3[0:max_quad_num-1]
	  ind3 = ind3[sort3]
	endif

	if num_quad_4 gt max_quad_num then begin
	  quad4_bright = star_list[3,ind4]
	  sort4 = reverse(sort(quad4_bright))
	  sort4 = sort4[0:max_quad_num-1]
	  ind4 = ind4[sort4]
	endif
	;
	if(idebug) then print_text, Event, "in TrimStarList, number of stars in each quad = "+$
							STRING(num_quad_1)+" "+STRING(num_quad_2)+" "+STRING(num_quad_3)+$
							" "+STRING(num_quad_4)
	;
	;  At most, one quadrant can have no stars, otherwise no triangle can be made and image is skipped
	;
	if num_quad_1 ne 0 then begin; quad 1 has stars
	  if num_quad_2 ne 0 then begin; quad 2 has stars
	    if num_quad_3 ne 0 then begin; quad 3 has stars
	      if num_quad_4 ne 0 then begin; quad 4 has stars; 1,2,3,4
	        new_star_x = [[star_list[0,ind1]],[star_list[0,ind2]],[star_list[0,ind3]],[star_list[0,ind4]]]
	        new_star_y = [[star_list[1,ind1]],[star_list[1,ind2]],[star_list[1,ind3]],[star_list[1,ind4]]]
	        new_star_quad = [[star_list[2,ind1]],[star_list[2,ind2]],[star_list[2,ind3]],[star_list[2,ind4]]]
	        new_star_flux = [[star_list[3,ind1]],[star_list[3,ind2]],[star_list[3,ind3]],[star_list[3,ind4]]]
	      endif else begin; 1, 2, 3
	        new_star_x = [[star_list[0,ind1]],[star_list[0,ind2]],[star_list[0,ind3]]]
	        new_star_y = [[star_list[1,ind1]],[star_list[1,ind2]],[star_list[1,ind3]]]
	        new_star_quad = [[star_list[2,ind1]],[star_list[2,ind2]],[star_list[2,ind3]]]
	        new_star_flux = [[star_list[3,ind1]],[star_list[3,ind2]],[star_list[3,ind3]]]
	      endelse
	    endif else begin; none in quad 3
	      if num_quad_4 ne 0 then begin; quad 4 has stars; 1,2,4
	        new_star_x = [[star_list[0,ind1]],[star_list[0,ind2]],[star_list[0,ind4]]]
	        new_star_y = [[star_list[1,ind1]],[star_list[1,ind2]],[star_list[1,ind4]]]
	        new_star_quad = [[star_list[2,ind1]],[star_list[2,ind2]],[star_list[2,ind4]]]
	        new_star_flux = [[star_list[3,ind1]],[star_list[3,ind2]],[star_list[3,ind4]]]
	      endif else begin; 1,2
	        goto, skip_image
	      endelse
	    endelse
	  endif else begin; none in quad 2
	    if num_quad_3 ne 0 then begin; quad 3 has stars
	      if num_quad_4 ne 0 then begin; quad 4 has stars, 1, 3, 4
	        new_star_x = [[star_list[0,ind1]],[star_list[0,ind3]],[star_list[0,ind4]]]
	        new_star_y = [[star_list[1,ind1]],[star_list[1,ind3]],[star_list[1,ind4]]]
	        new_star_quad = [[star_list[2,ind1]],[star_list[2,ind3]],[star_list[2,ind4]]]
	        new_star_flux = [[star_list[3,ind1]],[star_list[3,ind3]],[star_list[3,ind4]]]
	      endif else begin; 1, 4 only
	        goto, skip_image
	      endelse
	    endif else begin; none in quads 3 or 4
	      goto, skip_image
	    endelse
	  endelse
	endif else begin; none in quad 1
	  if num_quad_2 ne 0 and num_quad_3 ne 0 and num_quad_4 ne 0 then begin; 2,3,4
	    new_star_x = [[star_list[0,ind2]],[star_list[0,ind3]],[star_list[0,ind4]]]
	    new_star_y = [[star_list[1,ind2]],[star_list[1,ind3]],[star_list[1,ind4]]]
	    new_star_quad = [[star_list[2,ind2]],[star_list[2,ind3]],[star_list[2,ind4]]]
	    new_star_flux = [[star_list[3,ind2]],[star_list[3,ind3]],[star_list[3,ind4]]]
	  endif else begin
	    goto, skip_image
	  endelse
	endelse
endif else begin
	;
	;	no quad criterion, keep 4*max_quad_num brightest
	;
	new_star_x = star_list[0,*]
    new_star_y = star_list[1,*]
    new_star_quad = star_list[2,*]
    new_star_flux = star_list[3,*]
    ;
    ind = REVERSE(SORT(new_star_flux))
    count = N_ELEMENTS(ind)
    max_stars = 4 * max_quad_num
    if(count gt max_stars) then begin
    	new_star_x = new_star_x[ind[0:max_stars-1]]
    	new_star_y = new_star_y[ind[0:max_stars-1]]
    	new_star_quad = new_star_quad[ind[0:max_stars-1]]
    	new_star_flux = new_star_flux[ind[0:max_stars-1]]
    	;
    	new_star_quad[*] = 5
    endif
    ;
    nstars = N_ELEMENTS(new_star_x)
    if(nstars lt 4) then goto, skip_image
endelse
;
trimmed_star_list = transpose([[reform(new_star_x)],[reform(new_star_y)],[reform(new_star_quad)],[reform(new_star_flux)]])
trim_flag = 1
if(idebug) then print_text, Event, "TrimStarList - exiting OK with nstars = "+STRING(nstars)
return,trimmed_star_list
;
skip_image:
;
;  not enough stars to form triangles, program will fail, skip image
;
trim_flag = 0
if(idebug) then print_text, Event, "TrimStarList - bad exit, with nstars = "+STRING(nstars)
return, 0
end