pro s10_collect_data_points, xi, yi, dist, x_full, y_full, z_full, sz_full, $
							 x_vec, y_vec, z_vec, sz_vec, SIG_CUT = sig_cut, $
							 SIG_TRAP = sig_trap
;
;	collects data points about the grid point (xi,yi), based
;	on distance limit.
;
;	the *_full vectors are the full set of input data
;
;	the *_vec vectors are the selected subset
;
;----------------------------------------------------------------------------
;
if(N_ELEMENTS(sig_cut) eq 0) then sig_val = 100.0 else sig_val = sig_cut
if(N_ELEMENTS(sig_trap) eq 0) then trap_val = 0.0 else trap_val = sig_trap
;
d = sqrt(float(xi - x_full)^2 + float(yi - y_full)^2)
;
ind = where(d le float(dist) and sz_full le sig_val and abs(z_full) le sig_val, n_inside)
;
if(n_inside gt 0) then begin
	x_vec = x_full[ind]
	y_vec = y_full[ind]
	z_vec = z_full[ind]
	sz_vec = sz_full[ind] > trap_val
endif else begin
	x_vec = [-1]
	y_vec = [-1]
	z_vec = [0.]
	sz_vec = [0.]
endelse
;
end
