pro s10_parse_one_line_of_data, s, line, n
;
;	parses one line of POLCAT data into the structure s at the
;	indicated line
;
p = STRSPLIT(line, ' ',/REGEX, /EXTRACT, COUNT=nspaces)
;
if(nspaces lt 10) then begin
	print, "ERROR - bad line parsing - line follows:"
	print, line
	stop
endif
;
d = '(d)'
i = '(i)'
f = '(f)'
a = '(a)'
;
z = 		{pol_no: 0, phot_no: 0, g_desig: '', x_img: 0.0d0, y_img: 0.0d0, x_det: 0, y_det: 0, $
            ra: 0.0d0, dec: 0.0d0, H_mag: 0.0d0, sH_mag: 0.0d0, pH_mag: 0.0d0, sky: 0.0d0, P: 0.0d0, sP: 0.0d0, $
            PA: 0.0d0, GPA: 0.0d0, sPA: 0.0d0, Q: 0.0d0, sQ: 0.0d0, U: 0.0d0, sU: 0.0d0, nHWP: 0, UF: 1, t_id: 0L, t_desig: '',$
            RA_2: 0.0d0, Dec_2: 0.0d0, J2: 0.0d0, sJ2: 0.0d0, H2: 0.0d0, sH2: 0.0d0, K2: 0.0d0, $
            sK2: 0.0d0}
;
k = 0
reads, p[k++], format=i, t
z.pol_no = t
reads, p[k++], format=i, t
z.phot_no = t
za = ''
;zb = ''
reads, p[k++], format=a, za
;reads, p[k++], format=a, zb
;z.g_desig = za + ' ' + zb
z.g_desig = za
reads, p[k++], format=d, t
z.x_img = t
reads, p[k++], format=d, t
z.y_img = t
reads, p[k++], format=i, t
z.x_det = t
reads, p[k++], format=i, t
z.y_det = t
;
reads, p[k++], format=d, t
z.ra = t
reads, p[k++], format=d, t
z.dec = t
reads, p[k++], format=d, t
z.H_mag = t
reads, p[k++], format=d, t
z.sH_mag = t
reads, p[k++], format=d, t
z.pH_mag = t
reads, p[k++], format=d, t
z.sky = t
reads, p[k++], format=d, t
z.P = t
reads, p[k++], format=d, t
z.sP = t
;
reads, p[k++], format=d, t
z.PA = t
reads, p[k++], format=d, t
z.GPA = t
reads, p[k++], format=d, t
z.sPA = t
reads, p[k++], format=d, t
z.Q = t
reads, p[k++], format=d, t
z.sQ = t
reads, p[k++], format=d, t
z.U = t
reads, p[k++], format=d, t
z.sU = t
reads, p[k++], format=i, t
z.nHWP = t
reads, p[k++], format=i, t
z.UF = t
reads, p[k++], format=i, t
z.t_id = t
;
;	if 2mass ID = 0, then skip remaining parsing
;
if(z.t_id eq 0) then goto, skip_to_here
;
zc = ''
reads, p[k++], format=a, zc
z.t_desig = zc
;
reads, p[k++], format=d, t
z.RA_2 = t
reads, p[k++], format=d, t
z.Dec_2 = t
reads, p[k++], format=d, t
z.J2 = t
reads, p[k++], format=d, t
z.sJ2 = t
reads, p[k++], format=d, t
z.H2 = t
reads, p[k++], format=d, t
z.sH2 = t
reads, p[k++], format=d, t
z.K2 = t
reads, p[k], format=d, t
z.sK2 = t
;
skip_to_here:
;
s[n] = z
return
end


