function s7_read_points_file, Event, path_bg
;
;	returns pointer to heap structure containing
;	data from the indicated S11-type points file
;
;	if no file, returns null pointer
;
test = FILE_INFO(path_bg)
if(NOT(test.exists)) then begin
	return_ptr = PTR_NEW()
	return, return_ptr
endif
;
openr, lu_in, path_bg, /GET_LUN
;
header = strarr(100)
nh = 0L
xy_points = intarr(2800,2)
nxy = 0
;
WHILE ~EOF(lu_in) do begin
	line = ''
	readf, lu_in, line, format='(a)'
	;
	;	skip lines with double semicolons, keep lines with single colons to signify FITS HEADER - like line
	;
	test = STRPOS( line, ';;' )
	if(test eq -1) then begin
		test2 = STRPOS( line, ';' )
		if(test2 ne -1) then begin
			header[nh] = STRMID( line, 1)
			nh++
		endif else begin
			reads, line, i, x, y
			xy_points[nxy,0] = x
			xy_points[nxy,1] = y
			nxy++
		endelse
	endif
ENDWHILE
;
FREE_LUN, lu_in
;print_text, Event, 'Read in '+STRING(nh,format='(i3)')+' lines and '+STRING(nxy, format='(i4)')+$
;	' data points from S11-type grid points file'
;
;	extract key quantities from the header
;
header = header[0:nh-1]
radius = SXPAR( header, 'GRIDRADI')
order = SXPAR( header, 'FITORDER' )
npts = SXPAR( header, 'NPTS')
;
; and the astrometry stuff
; 
EXTAST, header, astr, noparams     ; DPC 20140319
if(noparams eq -1) then stop
;
;	check that npts and nxy agree
;
if(npts ne nxy) then begin
;	print_text, Event, 'ERROR - number of data points read does not match header number'
	return_ptr = PTR_NEW()
	return, return_ptr
endif
;
;	pack into structure
;
return_ptr = PTR_NEW( {	npts:	npts, $
						radius:	radius, $
						order:	order, $
						astr:   astr, $
						xy_points:	xy_points[0:nxy-1,*]})
;
return, return_ptr
end